DROP TABLE IF EXISTS #__assets;

CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) AUTO_INCREMENT=182 DEFAULT CHARSET=utf8;

INSERT INTO #__assets VALUES(1,0,1,436,0,'root.1','Root Asset','{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.login.offline\":[],\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}');
INSERT INTO #__assets VALUES(2,1,2,3,1,'com_admin','com_admin','{}');
INSERT INTO #__assets VALUES(3,1,4,11,1,'com_banners','com_banners','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(4,1,12,13,1,'com_cache','com_cache','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}');
INSERT INTO #__assets VALUES(5,1,14,15,1,'com_checkin','com_checkin','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}');
INSERT INTO #__assets VALUES(6,1,16,17,1,'com_config','com_config','{}');
INSERT INTO #__assets VALUES(7,1,18,87,1,'com_contact','com_contact','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(8,1,88,303,1,'com_content','com_content','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}');
INSERT INTO #__assets VALUES(9,1,304,305,1,'com_cpanel','com_cpanel','{}');
INSERT INTO #__assets VALUES(10,1,306,307,1,'com_installer','com_installer','{\"core.admin\":[],\"core.manage\":{\"7\":0},\"core.delete\":{\"7\":0},\"core.edit.state\":{\"7\":0}}');
INSERT INTO #__assets VALUES(11,1,308,309,1,'com_languages','com_languages','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(12,1,310,311,1,'com_login','com_login','{}');
INSERT INTO #__assets VALUES(13,1,312,313,1,'com_mailto','com_mailto','{}');
INSERT INTO #__assets VALUES(14,1,314,315,1,'com_massmail','com_massmail','{}');
INSERT INTO #__assets VALUES(15,1,316,317,1,'com_media','com_media','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1},\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(16,1,318,319,1,'com_menus','com_menus','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(17,1,37,38,1,'com_messages','com_messages','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}');
INSERT INTO #__assets VALUES(18,1,322,323,1,'com_modules','com_modules','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(19,1,324,331,1,'com_newsfeeds','com_newsfeeds','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(20,1,332,333,1,'com_plugins','com_plugins','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(21,1,334,335,1,'com_redirect','com_redirect','{\"core.admin\":{\"7\":1},\"core.manage\":[]}');
INSERT INTO #__assets VALUES(22,1,336,337,1,'com_search','com_search','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}');
INSERT INTO #__assets VALUES(23,1,338,339,1,'com_templates','com_templates','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(24,1,340,343,1,'com_users','com_users','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(25,1,344,361,1,'com_weblinks','com_weblinks','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1,\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}');
INSERT INTO #__assets VALUES(26,1,362,363,1,'com_wrapper','com_wrapper','{}');
INSERT INTO #__assets VALUES(33,1,424,425,1,'com_finder','com_finder','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}');
INSERT INTO #__assets VALUES(34,8,105,108,2,'com_content.category.9','Uncategorised','{\"core.create\":{\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(35,3,7,8,2,'com_banners.category.10','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(36,7,23,24,2,'com_contact.category.11','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(37,19,327,328,2,'com_newsfeeds.category.12','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(38,25,351,352,2,'com_weblinks.category.13','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(39,8,109,302,2,'com_content.category.14','Sample Data-Articles','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(40,3,9,10,2,'com_banners.category.15','Sample Data-Banners','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(41,7,25,86,2,'com_contact.category.16','Sample Data-Contact','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(42,19,329,330,2,'com_newsfeeds.category.17','Sample Data-Newsfeeds','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(43,25,353,360,2,'com_weblinks.category.18','Sample Data-Weblinks','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(44,39,110,247,3,'com_content.category.19','Joomla!','{\"core.create\":{\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(45,44,111,224,4,'com_content.category.20','Extensions','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(46,45,112,127,5,'com_content.category.21','Components','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(47,45,128,189,5,'com_content.category.22','Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(48,45,190,201,5,'com_content.category.23','Templates','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(49,45,202,203,5,'com_content.category.24','Languages','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(50,45,204,223,5,'com_content.category.25','Plugins','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(51,39,248,279,3,'com_content.category.26','Park Site','{\"core.create\":{\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(52,51,249,254,4,'com_content.category.27','Park Blog','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(53,51,255,276,4,'com_content.category.28','Photo Gallery','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(54,39,280,293,3,'com_content.category.29','Fruit Shop Site','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(55,54,281,286,4,'com_content.category.30','Growers','{\"core.create\":{\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":{\"10\":1}}');
INSERT INTO #__assets VALUES(56,43,354,355,3,'com_weblinks.category.31','Park Links','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(57,43,356,359,3,'com_weblinks.category.32','Joomla! Specific Links','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(58,57,357,358,4,'com_weblinks.category.33','Other Resources','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(59,41,26,27,3,'com_contact.category.34','Park Site','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(60,41,28,85,3,'com_contact.category.35','Shop Site','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(61,60,29,30,4,'com_contact.category.36','Staff','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(62,60,31,84,4,'com_contact.category.37','Fruit Encyclopedia','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(63,62,32,33,5,'com_contact.category.38','A','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(64,62,34,35,5,'com_contact.category.39','B','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(65,62,36,37,5,'com_contact.category.40','C','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(66,62,38,39,5,'com_contact.category.41','D','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(67,62,40,41,5,'com_contact.category.42','E','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(68,62,42,43,5,'com_contact.category.43','F','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(69,62,44,45,5,'com_contact.category.44','G','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(70,62,46,47,5,'com_contact.category.45','H','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(71,62,48,49,5,'com_contact.category.46','I','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(72,62,50,51,5,'com_contact.category.47','J','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(73,62,52,53,5,'com_contact.category.48','K','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(74,62,54,55,5,'com_contact.category.49','L','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(75,62,56,57,5,'com_contact.category.50','M','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(76,62,58,59,5,'com_contact.category.51','N','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(77,62,60,61,5,'com_contact.category.52','O','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(78,62,62,63,5,'com_contact.category.53','P','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(79,62,64,65,5,'com_contact.category.54','Q','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(80,62,66,67,5,'com_contact.category.55','R','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(81,62,68,69,5,'com_contact.category.56','S','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(82,62,70,71,5,'com_contact.category.57','T','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(83,62,72,73,5,'com_contact.category.58','U','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(84,62,74,75,5,'com_contact.category.59','V','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(85,62,76,77,5,'com_contact.category.60','W','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(86,62,78,79,5,'com_contact.category.61','X','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(87,62,80,81,5,'com_contact.category.62','Y','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(88,62,82,83,5,'com_contact.category.63','Z','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(89,46,113,114,6,'com_content.article.1','Administrator Components','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(90,93,130,131,7,'com_content.article.2','Archive Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(91,93,132,133,7,'com_content.article.3','Article Categories Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(92,93,134,135,7,'com_content.article.4','Articles Category Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(93,47,129,144,6,'com_content.category.64','Content Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(94,47,145,152,6,'com_content.category.65','User Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(95,47,153,166,6,'com_content.category.66','Display Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(96,47,167,180,6,'com_content.category.67','Utility Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(97,48,191,192,6,'com_content.category.68','Atomic','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(98,48,193,194,6,'com_content.category.69','Beez 20','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(99,48,195,196,6,'com_content.category.70','Beez5','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(100,48,197,198,6,'com_content.category.71','Milky Way','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(101,50,205,206,6,'com_content.article.5','Authentication','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(102,51,277,278,4,'com_content.article.6','Australian Parks ','{\"core.delete\":[],\"core.edit\":{\"2\":1},\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(103,95,154,155,7,'com_content.article.7','Banner Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(104,44,225,226,4,'com_content.article.8','Home Decorating Ideas','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(105,46,115,116,6,'com_content.article.9','Contact','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(106,46,117,118,6,'com_content.article.10','Content','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(107,109,267,268,6,'com_content.article.11','Cradle Mountain','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(108,53,256,265,5,'com_content.category.72','Animals','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(109,53,266,275,5,'com_content.category.73','Scenery','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(110,95,156,157,7,'com_content.article.12','Custom HTML Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(111,54,287,288,4,'com_content.article.13','Directions','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(112,50,207,208,6,'com_content.article.14','Editors','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(113,50,209,210,6,'com_content.article.15','Editors-xtd','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(114,95,158,159,7,'com_content.article.16','Feed Display','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(115,52,250,251,5,'com_content.article.17','First Blog Post','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(116,52,252,253,5,'com_content.article.18','Second Blog Post','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(117,95,160,161,7,'com_content.article.19','Footer Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(118,54,289,290,4,'com_content.article.20','Fruit Shop','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(119,44,227,228,4,'com_content.article.21','Getting Help','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(120,44,229,230,4,'com_content.article.22','Getting Started','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(121,55,282,283,5,'com_content.article.23','Happy Orange Orchard','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(122,44,231,232,4,'com_content.article.24','Tips on Buying Real Estate','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(123,108,257,258,6,'com_content.article.25','Koala','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(124,96,168,169,7,'com_content.article.26','Language Switcher','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(125,93,136,137,7,'com_content.article.27','Latest Articles Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(126,94,146,147,7,'com_content.article.28','Login Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(127,166,184,185,7,'com_content.article.29','Menu Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(128,93,138,139,7,'com_content.article.30','Most Read Content','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(129,93,140,141,7,'com_content.article.31','News Flash','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(130,44,233,234,4,'com_content.article.32','Parameters','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(131,108,259,260,6,'com_content.article.33','Phyllopteryx','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(132,109,269,270,6,'com_content.article.34','Pinnacles','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(133,44,235,236,4,'com_content.article.35','Professionals','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(134,95,162,163,7,'com_content.article.36','Random Image Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(135,93,142,143,7,'com_content.article.37','Related Items Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(136,44,237,238,4,'com_content.article.38','Sample Sites','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(137,46,119,120,6,'com_content.article.39','Search','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(138,96,170,171,7,'com_content.article.40','Search Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(139,50,211,212,6,'com_content.article.41','Search ','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(140,39,294,295,3,'com_content.article.42','Site Map','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(141,108,261,262,6,'com_content.article.43','Spotted Quoll','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(142,96,172,173,7,'com_content.article.44','Statistics Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(143,96,174,175,7,'com_content.article.45','Syndicate Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(144,50,213,214,6,'com_content.article.46','System','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(145,44,239,240,4,'com_content.article.47','The Joomla! Community','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(146,44,241,242,4,'com_content.article.48','The Joomla! Project','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(147,48,199,200,6,'com_content.article.49','Typography','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(148,44,243,244,4,'com_content.article.50','Upgraders','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(149,50,215,216,6,'com_content.article.51','User','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(150,46,121,122,6,'com_content.article.52','Users','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(151,44,245,246,4,'com_content.article.53','Using Joomla!','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(152,46,123,124,6,'com_content.article.54','Weblinks','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(153,95,164,165,7,'com_content.article.55','Weblinks Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(154,94,148,149,7,'com_content.article.56','Who\'s Online','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(155,108,263,264,6,'com_content.article.57','Wobbegone','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(156,55,284,285,5,'com_content.article.58','Wonderful Watermelon','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(157,96,176,177,7,'com_content.article.59','Wrapper Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(158,46,125,126,6,'com_content.article.60','News Feeds','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(159,166,186,187,7,'com_content.article.61','Breadcrumbs Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(160,50,217,218,6,'com_content.article.62','Content','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(162,109,271,272,6,'com_content.article.64','Blue Mountain Rain Forest','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(163,109,273,274,6,'com_content.article.65','Ormiston Pound','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(165,94,150,151,7,'com_content.article.66','Latest Users Module','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(166,47,183,188,6,'com_content.category.75','Navigation Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}');
INSERT INTO #__assets VALUES(167,54,291,292,4,'com_content.category.76','Recipes','{\"core.create\":{\"12\":1,\"10\":1},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":{\"12\":1,\"10\":1}}');
INSERT INTO #__assets VALUES(168,34,106,107,3,'com_content.article.67','What\'s New in 1.5?','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(169,24,341,342,2,'com_users.notes.category.77','Uncategorised','');
INSERT INTO #__assets VALUES(170,50,219,220,6,'com_content.article.68','Captcha','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(171,50,221,222,6,'com_content.article.69','Quick Icons','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(172,96,178,179,7,'com_content.article.70','Smart Search','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(173,1,426,427,1,'com_joomlaupdate','com_joomlaupdate','{\"core.admin\":[],\"core.manage\":[],\"core.delete\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(174,1,428,431,1,'com_djimageslider','com_djimageslider','{}');
INSERT INTO #__assets VALUES(175,174,429,430,2,'com_djimageslider.category.78','Categories1','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(176,1,432,433,1,'com_djclassifieds','djclassifieds','{}');
INSERT INTO #__assets VALUES(180,1,434,435,1,'com_djcatalog2','com_djcatalog2','{\"djcatalog2.filedownload\":[]}');
INSERT INTO #__assets VALUES(178,39,298,299,3,'com_content.article.71','Typography','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');
INSERT INTO #__assets VALUES(181,39,300,301,3,'com_content.article.72','Promotions','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');



DROP TABLE IF EXISTS #__associations;

CREATE TABLE `#__associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__banner_clients;

CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

INSERT INTO #__banner_clients VALUES(1,'Joomla!','Administrator','email@email.com','',1,0,'0000-00-00 00:00:00','',0,'',-1,-1,-1);
INSERT INTO #__banner_clients VALUES(2,'Shop','Example','example@example.com','',1,0,'0000-00-00 00:00:00','',0,'',-1,0,0);
INSERT INTO #__banner_clients VALUES(3,'Bookstore','Bookstore Example','example@example.com','',1,0,'0000-00-00 00:00:00','',0,'',-1,0,0);



DROP TABLE IF EXISTS #__banner_tracks;

CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__banners;

CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

INSERT INTO #__banners VALUES(2,3,0,'Shop 1','shop-1',0,94,2,'http://shop.joomla.org/amazoncom-bookstores.html',1,15,'Get books about Joomla! at the Joomla! Book Shop.','',0,1,'','{\"imageurl\":\"images\\/banners\\/white.png\",\"width\":\"\",\"height\":\"\",\"alt\":\"Joomla! Books\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-01 00:00:01','en-GB');
INSERT INTO #__banners VALUES(3,2,0,'Shop 2','shop-2',0,144,2,'http://shop.joomla.org',1,15,'T Shirts, caps and more from the Joomla! Shop.','',0,2,'','{\"imageurl\":\"images\\/banners\\/white.png\",\"width\":\"\",\"height\":\"\",\"alt\":\"Joomla! Shop\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-01 00:00:01','en-GB');
INSERT INTO #__banners VALUES(4,1,0,'Support Joomla!','support-joomla',0,63,1,'http://contribute.joomla.org',1,15,'Your contributions of time, talent and money make Joomla possible.','',0,3,'','{\"imageurl\":\"images\\/banners\\/white.png\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','en-GB');



DROP TABLE IF EXISTS #__categories;

CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) AUTO_INCREMENT=79 DEFAULT CHARSET=utf8;

INSERT INTO #__categories VALUES(1,0,0,0,137,0,'','system','ROOT','root','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(9,34,1,131,132,1,'uncategorised','com_content','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(10,35,1,129,130,1,'uncategorised','com_banners','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(11,36,1,125,126,1,'uncategorised','com_contact','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(12,37,1,61,62,1,'uncategorised','com_newsfeeds','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(13,38,1,57,58,1,'uncategorised','com_weblinks','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(14,39,1,9,56,1,'sample-data-articles','com_content','Sample Data-Articles','sample-data-articles','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(15,40,1,127,128,1,'sample-data-banners','com_banners','Sample Data-Banners','sample-data-banners','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(16,41,1,63,124,1,'sample-data-contact','com_contact','Sample Data-Contact','sample-data-contact','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(17,42,1,59,60,1,'sample-data-newsfeeds','com_newsfeeds','Sample Data-Newsfeeds','sample-data-newsfeeds','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(18,43,1,1,8,1,'sample-data-weblinks','com_weblinks','Sample Data-Weblinks','sample-data-weblinks','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(19,44,14,10,39,2,'sample-data-articles/joomla','com_content','Joomla!','joomla','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(20,45,19,11,38,3,'sample-data-articles/joomla/extensions','com_content','Extensions','extensions','','<p>The Joomla! content management system lets you create webpages of various types using extensions. There are 5 basic types of extensions: components, modules, templates, languages, and plugins. Your website includes the extensions you need to create a basic website in English, but thousands of additional extensions of all types are available. The <a href=\"http://extensions.joomla.org\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\">Joomla! Extensions Directory</a> is the largest directory of Joomla extensions.</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 11:57:22',0,'*');
INSERT INTO #__categories VALUES(21,46,20,12,13,4,'sample-data-articles/joomla/extensions/components','com_content','Components','components','','<p><img class=\"image-left\" src=\"administrator/templates/bluestork/images/header/icon-48-component.png\" border=\"0\" alt=\"Component Image\" />Components are larger extensions that produce the major content for your site. Each component has one or more \"views\" that control how content is displayed. In the Joomla administrator there are additional extensions such as Menus, Redirection, and the extension managers.</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 11:58:12',0,'*');
INSERT INTO #__categories VALUES(22,47,20,14,25,4,'sample-data-articles/joomla/extensions/modules','com_content','Modules','modules','','<p><img class=\"image-left\" src=\"administrator/templates/bluestork/images/header/icon-48-module.png\" border=\"0\" alt=\"Media Image\" />Modules are small blocks of content that can be displayed in positions on a web page. The menus on this site are displayed in modules. The core of Joomla! includes 24 separate modules ranging from login to search to random images. Each module has a name that starts mod_ but when it displays it has a title. In the descriptions in this section, the titles are the same as the names.</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 11:59:44',0,'*');
INSERT INTO #__categories VALUES(23,48,20,26,33,4,'sample-data-articles/joomla/extensions/templates','com_content','Templates','templates','','<p><img src=\"administrator/templates/bluestork/images/header/icon-48-themes.png\" border=\"0\" alt=\"Media Image\" align=\"left\" />Templates give your site its look and feel. They determine layout, colours, typefaces, graphics and other aspects of design that make your site unique. Your installation of Joomla comes prepackaged with three front end templates and two backend templates. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Template_Manager_Templates\">Help</a></p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 12:04:51',0,'*');
INSERT INTO #__categories VALUES(24,49,20,34,35,4,'sample-data-articles/joomla/extensions/languages','com_content','Languages','languages','','<p><img src=\"administrator/templates/bluestork/images/header/icon-48-language.png\" border=\"0\" alt=\"Languages Image\" align=\"left\" />Joomla! installs in English, but translations of the interfaces, sample data and help screens are available in dozens of languages. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Language_Manager_Installed\">Help</a></p>\r\n<p><a href=\"http://community.joomla.org/translations.html\">Translation information</a></p>\r\n<p>If there is no language pack available for your language, instructions are available for creating your own translation, which you can also contribute to the community by starting a translation team to create an accredited translation. </p>\r\n<p>Translations of the interfaces are installed using the extensions manager in the site administrator and then managed using the language manager.</p>\r\n<p>If you have two or more languages installed you may enable the language switcher plugin and module. They should always be used together. If you create multilingual content and mark your content, menu items or modules as being in specific languages and follow <a href=\"http://docs.joomla.org/Language_Switcher_Tutorial_for_Joomla_1.6\">the complete instructions</a> your users will be able to select a specific content language using the module. By default both the plugin and module are disabled.</p>\r\n<p>Joomla 2.5 installs with a language override manager that allows you to change the specific words (such as Edit or Search) used in the Joomla application.</p>\r\n<p>There are a number of extensions that can help you manage translations of content available in the<a href=\"http://extensions.joomla.org\"> Joomla! Extensions Directory</a>.</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2012-01-17 16:18:40',0,'*');
INSERT INTO #__categories VALUES(25,50,20,36,37,4,'sample-data-articles/joomla/extensions/plugins','com_content','Plugins','plugins','','<p><img src=\"administrator/templates/bluestork/images/header/icon-48-plugin.png\" border=\"0\" alt=\"Plugin Image\" align=\"left\" />Plugins are small task oriented extensions that enhance the Joomla! framework. Some are associated with particular extensions and others, such as editors, are used across all of Joomla. Most beginning users do not need to change any of the plugins that install with Joomla. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Plugin_Manager_Edit\">Help</a></p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 12:11:56',0,'*');
INSERT INTO #__categories VALUES(26,51,14,40,49,2,'sample-data-articles/park-site','com_content','Park Site','park-site','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'en-GB');
INSERT INTO #__categories VALUES(27,52,26,41,42,3,'sample-data-articles/park-site/park-blog','com_content','Park Blog','park-blog','','<p><span style=\"font-size: 12px;\">Here is where I will blog all about the parks of Australia.</span></p>\r\n<p><em>You can make a blog on your website by creating a category to write your blog posts in (this one is called Park Blog). Each blog post will be an article in that category. If you make a category blog menu link with 1 column it will look like this page, if you display the category description then this part is displayed. </em></p>\r\n<p><em>To enhance your blog you may want to add extensions for <a href=\"http://extensions.joomla.org/extensions/contacts-and-feedback/articles-comments\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\">comments</a>,<a href=\"http://extensions.joomla.org/extensions/social-web\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\"> interacting with social network sites</a>, <a href=\"http://extensions.joomla.org/extensions/content-sharing\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\">tagging</a>, and <a href=\"http://extensions.joomla.org/extensions/content-sharing\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\">keeping in contact with your readers</a>. You can also enable the syndication that is included in Joomla (in the Integration Options set Show Feed Link to Show and make sure to display the syndication module on the page).</em></p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"images\\/sampledata\\/parks\\/banner_cradle.jpg\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 12:15:40',0,'en-GB');
INSERT INTO #__categories VALUES(28,53,26,43,48,3,'sample-data-articles/park-site/photo-gallery','com_content','Photo Gallery','photo-gallery','','<p><img src=\"images/sampledata/parks/banner_cradle.jpg\" border=\"0\" /></p>\r\n<p>These are my photos from parks I have visited (I didn\'t take them, they are all from <a href=\"http://commons.wikimedia.org/wiki/Main_Page\">Wikimedia Commons</a>).</p>\r\n<p><em>This shows you how to make a simple image gallery using articles in com_content. </em></p>\r\n<p><em>In each article put a thumbnail image before a \"readmore\" and the full size image after it. Set the article to Show Intro Text: Hide. </em></p>',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'en-GB');
INSERT INTO #__categories VALUES(29,54,14,50,55,2,'sample-data-articles/fruit-shop-site','com_content','Fruit Shop Site','fruit-shop-site','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(30,55,29,51,52,3,'sample-data-articles/fruit-shop-site/growers','com_content','Growers','growers','','<p>We search the whole countryside for the best fruit growers.</p>\r\n<p><em>You can let each supplier have a page that he or she can edit. To see this in action you will need to create a user who is in the suppliers group.  </em></p>\r\n<p><em>Create one page in the growers category for that user and make that supplier the author of the page. That user will be able to edit his or her page. </em></p>\r\n<p><em>This illustrates the use of the Edit Own permission. </em></p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 12:17:40',0,'*');
INSERT INTO #__categories VALUES(31,56,18,2,3,2,'sample-data-weblinks/park-links','com_weblinks','Park Links','park-links','','<p>Here are links to some of my favorite parks.</p>\r\n<p><em>The weblinks component provides an easy way to make links to external sites that are consistently formatted and categorised. You can create weblinks from the front end of your site.</em></p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"images\\/sampledata\\/parks\\/banner_cradle.jpg\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'en-GB');
INSERT INTO #__categories VALUES(32,57,18,4,7,2,'sample-data-weblinks/joomla-specific-links','com_weblinks','Joomla! Specific Links','joomla-specific-links','','<p>A selection of links that are all related to the Joomla Project.</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 12:32:00',0,'*');
INSERT INTO #__categories VALUES(33,58,32,5,6,3,'sample-data-weblinks/joomla-specific-links/other-resources','com_weblinks','Other Resources','other-resources','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(34,59,16,64,65,2,'sample-data-contact/park-site','com_contact','Park Site','park-site','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'en-GB');
INSERT INTO #__categories VALUES(35,60,16,66,123,2,'sample-data-contact/shop-site','com_contact','Shop Site','shop-site','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(36,61,35,67,68,3,'sample-data-contact/shop-site/staff','com_contact','Staff','staff','','<p>Please feel free to contact our staff at any time should you need assistance.</p>',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(37,62,35,69,122,3,'sample-data-contact/shop-site/fruit-encyclopedia','com_contact','Fruit Encyclopedia','fruit-encyclopedia','','<p> </p><p>Our directory of information about different kinds of fruit.</p><p>We love fruit and want the world to know more about all of its many varieties.</p><p>Although it is small now, we work on it whenever we have a chance.</p><p>All of the images can be found in <a href=\"http://commons.wikimedia.org/wiki/Main_Page\">Wikimedia Commons</a>.</p><p><img src=\"images/sampledata/fruitshop/apple.jpg\" border=\"0\" alt=\"Apples\" title=\"Apples\" /></p><p><em>This encyclopedia is implemented using the contact component, each fruit a separate contact and a category for each letter. A CSS style is used to create the horizontal layout of the alphabet headings. </em></p><p><em>If you wanted to, you could allow some users (such as your growers) to have access to just this category in the contact component and let them help you to create new content for the encyclopedia.</em></p><p> </p>',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(38,63,37,70,71,4,'sample-data-contact/shop-site/fruit-encyclopedia/a','com_contact','A','a','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(39,64,37,72,73,4,'sample-data-contact/shop-site/fruit-encyclopedia/b','com_contact','B','b','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(40,65,37,74,75,4,'sample-data-contact/shop-site/fruit-encyclopedia/c','com_contact','C','c','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(41,66,37,76,77,4,'sample-data-contact/shop-site/fruit-encyclopedia/d','com_contact','D','d','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(42,67,37,78,79,4,'sample-data-contact/shop-site/fruit-encyclopedia/e','com_contact','E','e','','',0,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(43,68,37,80,81,4,'sample-data-contact/shop-site/fruit-encyclopedia/f','com_contact','F','f','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(44,69,37,82,83,4,'sample-data-contact/shop-site/fruit-encyclopedia/g','com_contact','G','g','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(45,70,37,84,85,4,'sample-data-contact/shop-site/fruit-encyclopedia/h','com_contact','H','h','','',0,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(46,71,37,86,87,4,'sample-data-contact/shop-site/fruit-encyclopedia/i','com_contact','I','i','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(47,72,37,88,89,4,'sample-data-contact/shop-site/fruit-encyclopedia/j','com_contact','J','j','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(48,73,37,90,91,4,'sample-data-contact/shop-site/fruit-encyclopedia/k','com_contact','K','k','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(49,74,37,92,93,4,'sample-data-contact/shop-site/fruit-encyclopedia/l','com_contact','L','l','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(50,75,37,94,95,4,'sample-data-contact/shop-site/fruit-encyclopedia/m','com_contact','M','m','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(51,76,37,96,97,4,'sample-data-contact/shop-site/fruit-encyclopedia/n','com_contact','N','n','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(52,77,37,98,99,4,'sample-data-contact/shop-site/fruit-encyclopedia/o','com_contact','O','o','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(53,78,37,100,101,4,'sample-data-contact/shop-site/fruit-encyclopedia/p','com_contact','P','p','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(54,79,37,102,103,4,'sample-data-contact/shop-site/fruit-encyclopedia/q','com_contact','Q','q','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(55,80,37,104,105,4,'sample-data-contact/shop-site/fruit-encyclopedia/r','com_contact','R','r','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(56,81,37,106,107,4,'sample-data-contact/shop-site/fruit-encyclopedia/s','com_contact','S','s','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(57,82,37,108,109,4,'sample-data-contact/shop-site/fruit-encyclopedia/t','com_contact','T','t','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(58,83,37,110,111,4,'sample-data-contact/shop-site/fruit-encyclopedia/u','com_contact','U','u','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(59,84,37,112,113,4,'sample-data-contact/shop-site/fruit-encyclopedia/v','com_contact','V','v','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(60,85,37,114,115,4,'sample-data-contact/shop-site/fruit-encyclopedia/w','com_contact','W','w','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(61,86,37,116,117,4,'sample-data-contact/shop-site/fruit-encyclopedia/x','com_contact','X','x','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(62,87,37,118,119,4,'sample-data-contact/shop-site/fruit-encyclopedia/y','com_contact','Y','y','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(63,88,37,120,121,4,'sample-data-contact/shop-site/fruit-encyclopedia/z','com_contact','Z','z','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(64,93,22,15,16,5,'sample-data-articles/joomla/extensions/modules/articles-modules','com_content','Content Modules','articles-modules','','<p>Content modules display article and other information from the content component.</p>',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(65,94,22,17,18,5,'sample-data-articles/joomla/extensions/modules/user-modules','com_content','User Modules','user-modules','','<p>User modules interact with the user system, allowing users to login, show who is logged-in, and showing the most recently registered users.</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 12:00:50',0,'*');
INSERT INTO #__categories VALUES(66,95,22,19,20,5,'sample-data-articles/joomla/extensions/modules/display-modules','com_content','Display Modules','display-modules','','<p>These modules display information from components other than content and user. These include weblinks, news feeds and the media manager.</p>',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(67,96,22,21,22,5,'sample-data-articles/joomla/extensions/modules/utility-modules','com_content','Utility Modules','utility-modules','','<p>Utility modules provide useful functionality such as search, syndication and statistics.</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 12:01:34',0,'*');
INSERT INTO #__categories VALUES(68,97,23,31,32,5,'sample-data-articles/joomla/extensions/templates/atomic','com_content','Atomic','atomic','','<p><img src=\"templates/atomic/template_thumbnail.png\" border=\"0\" alt=\"The Atomic Template\" style=\"border: 0; float: right;\" /></p>\r\n<p>Atomic is a minimal template designed to be a skeleton for making your own template and to learn about Joomla! templating.</p>\r\n<ul>\r\n<li><a href=\"index.php?Itemid=285\">Home Page</a></li>\r\n<li><a href=\"index.php?Itemid=316\">Typography</a></li>\r\n</ul>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 12:08:16',0,'*');
INSERT INTO #__categories VALUES(69,98,23,27,28,5,'sample-data-articles/joomla/extensions/templates/beez-20','com_content','Beez 20','beez-20','','<p><img src=\"templates/beez_20/template_thumbnail.png\" border=\"0\" alt=\"Beez_20 thumbnail\" align=\"right\" style=\"float: right;\" /></p>\r\n<p>Beez 2.0 is a versatile, easy to customise template that works for a variety of sites. It meets major accessibility standards and demonstrates a range of css and javascript techniques. It is the default template that installs with Joomla!</p>\r\n<ul>\r\n<li><a href=\"index.php?Itemid=424\">Home Page</a></li>\r\n<li><a href=\"index.php?Itemid=423\">Typography</a></li>\r\n</ul>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(70,99,23,29,30,5,'sample-data-articles/joomla/extensions/templates/beez-5','com_content','Beez 5','beez-5','','<p><img src=\"templates/beez5/template_thumbnail.png\" border=\"0\" alt=\"Beez5 Thumbnail\" align=\"right\" style=\"float: right;\" /></p>\r\n<p>Beez 5 is an html5 implementation of a Joomla! template. It uses a number of html5 techniques to enhance the presentation of a site. It is used as the template for the Fruit Shop sample site.</p>\r\n<ul>\r\n<li><a href=\"index.php?Itemid=458\">Home Page</a></li>\r\n<li><a href=\"index.php?Itemid=457\">Typography</a></li>\r\n</ul>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 12:06:57',0,'*');
INSERT INTO #__categories VALUES(72,108,28,44,45,4,'sample-data-articles/park-site/photo-gallery/animals','com_content','Animals','animals','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'en-GB');
INSERT INTO #__categories VALUES(73,109,28,46,47,4,'sample-data-articles/park-site/photo-gallery/scenery','com_content','Scenery','scenery','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'en-GB');
INSERT INTO #__categories VALUES(75,166,22,23,24,5,'sample-data-articles/joomla/extensions/modules/navigation-modules','com_content','Navigation Modules','navigation-modules','','<p>Navigation modules help your visitors move through your site and find what they need.</p>\r\n<p>Menus provide your site with structure and help your visitors navigate your site.  Although they are all based on the same menu module, the variety of ways menus are used in the sample data show how flexible this module is.</p>\r\n<p>A menu can range from extremely simple (for example the top menu or the menu for the Australian Parks sample site) to extremely complex (for example the About Joomla! menu with its many levels). They can also be used for other types of presentation such as the site map linked from the \"This Site\" menu.</p>\r\n<p>Breadcrumbs provide users with information about where they are in a site.</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(76,167,29,53,54,3,'sample-data-articles/fruit-shop-site/recipes','com_content','Recipes','recipes','','<p>Customers and suppliers can post their favorite recipes for fruit here.</p>\r\n<p>A good idea is to promote the use of metadata keywords to make finding other recipes for the same fruit easier.</p>\r\n<p><em>To see this in action, create a user assigned to the customer group and a user assigned to the suppliers group. These users will be able to create their own recipe pages and edit those pages. They will not be able to edit other users\' pages.</em><br /><br /></p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',42,'2011-12-27 12:18:25',0,'*');
INSERT INTO #__categories VALUES(77,169,1,133,134,1,'uncategorised','com_users.notes','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',614,'2011-01-01 00:00:01',0,'2011-01-01 00:00:01',0,'*');
INSERT INTO #__categories VALUES(78,175,1,135,136,1,'categories1','com_djimageslider','Categories1','categories1','','<p>Lorem ipsum</p>',1,0,'0000-00-00 00:00:00',1,'{\"category_layout\":\"\",\"image\":\"\"}','','','{\"author\":\"\",\"robots\":\"\"}',614,'2012-10-29 13:27:54',0,'0000-00-00 00:00:00',0,'*');



DROP TABLE IF EXISTS #__contact_details;

CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;

INSERT INTO #__contact_details VALUES(1,'Contact Name Here','name','Position','Street Address','Suburb','State','Country','Zip Code','Telephone','Fax','<p>Information about or by the contact.</p>','images/powered_by.png','top','email@example.com',1,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Twitter\",\"linka\":\"http:\\/\\/twitter.com\\/joomla\",\"linkb_name\":\"YouTube\",\"linkb\":\"http:\\/\\/www.youtube.com\\/user\\/joomla\",\"linkc_name\":\"Facebook\",\"linkc\":\"http:\\/\\/www.facebook.com\\/joomla\",\"linkd_name\":\"FriendFeed\",\"linkd\":\"http:\\/\\/friendfeed.com\\/joomla\",\"linke_name\":\"Scribed\",\"linke\":\"http:\\/\\/www.scribd.com\\/people\\/view\\/504592-joomla\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,16,1,'','','last','first','middle','en-GB','2011-01-01 00:00:01',614,'','2011-12-27 12:23:32',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__contact_details VALUES(2,'Webmaster','webmaster','','','','','','','','','','','','webmaster@example.com',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,34,1,'','','','','','en-GB','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__contact_details VALUES(3,'Owner','owner','','','','','','','','','<p>I\'m the owner of this store.</p>','','','',0,1,0,'0000-00-00 00:00:00',2,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,36,1,'','','','','','*','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__contact_details VALUES(4,'Buyer','buyer','','','','','','','','','<p>I am in charge of buying fruit. If you sell good fruit, contact me.</p>','','','',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"0\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,36,1,'','','','','','*','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__contact_details VALUES(5,'Bananas','bananas','Scientific Name: Musa','Image Credit: Enzik\r\nRights: Creative Commons Share Alike Unported 3.0\r\nSource: http://commons.wikimedia.org/wiki/File:Bananas_-_Morocco.jpg','','Type: Herbaceous','Large Producers: India, China, Brasil','','','','<p>Bananas are a great source of potassium.</p>\r\n<p> </p>','images/sampledata/fruitshop/bananas_2.jpg','','',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"show_with_link\",\"show_contact_list\":\"\",\"presentation_style\":\"plain\",\"show_name\":\"\",\"show_position\":\"1\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"1\",\"show_postcode\":\"\",\"show_country\":\"1\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Wikipedia: Banana English\",\"linka\":\"http:\\/\\/en.wikipedia.org\\/wiki\\/Banana\",\"linkb_name\":\"Wikipedia:  \\u0939\\u093f\\u0928\\u094d\\u0926\\u0940 \\u0915\\u0947\\u0932\\u093e\",\"linkb\":\"http:\\/\\/hi.wikipedia.org\\/wiki\\/%E0%A4%95%E0%A5%87%E0%A4%B2%E0%A4%BE\",\"linkc_name\":\"Wikipedia:Banana Portugu\\u00eas\",\"linkc\":\"http:\\/\\/pt.wikipedia.org\\/wiki\\/Banana\",\"linkd_name\":\"Wikipedia: \\u0411\\u0430\\u043d\\u0430\\u043d  \\u0420\\u0443\\u0441\\u0441\\u043a\\u0438\\u0439\",\"linkd\":\"http:\\/\\/ru.wikipedia.org\\/\\u0411\\u0430\\u043d\\u0430\\u043d\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"beez5:encyclopedia\"}',0,39,1,'','','','','','*','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__contact_details VALUES(6,'Apples','apples','Scientific Name: Malus domestica','Image Credit: Fievet\r\nRights: Public Domain\r\nSource: http://commons.wikimedia.org/wiki/File:Pommes_vertes.JPG','','Family: Rosaceae','Large: Producers: China, United States','','','','<p>Apples are a versatile fruit, used for eating, cooking, and preserving.</p>\r\n<p>There are more that 7500 different kinds of apples grown around the world.</p>','images/sampledata/fruitshop/apple.jpg','','',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"plain\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Wikipedia: Apples English\",\"linka\":\"http:\\/\\/en.wikipedia.org\\/wiki\\/Apple\",\"linkb_name\":\"Wikipedia: Manzana Espa\\u00f1ol \",\"linkb\":\"http:\\/\\/es.wikipedia.org\\/wiki\\/Manzana\",\"linkc_name\":\"Wikipedia: \\u82f9\\u679c \\u4e2d\\u6587\",\"linkc\":\"http:\\/\\/zh.wikipedia.org\\/zh\\/\\u82f9\\u679c\",\"linkd_name\":\"Wikipedia: Tofaa Kiswahili\",\"linkd\":\"http:\\/\\/sw.wikipedia.org\\/wiki\\/Tofaa\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"beez5:encyclopedia\"}',0,38,1,'','','','','','*','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__contact_details VALUES(7,'Tamarind','tamarind','Scientific Name: Tamarindus indica','Image Credit: Franz Eugen Köhler, Köhler\'s Medizinal-Pflanzen \r\nRights: Public Domain\r\nSource:http://commons.wikimedia.org/wiki/File:Koeh-134.jpg','','Family: Fabaceae','Large Producers: India, United States','','','','<p>Tamarinds are a versatile fruit used around the world. In its young form it is used in hot sauces; ripened it is the basis for many refreshing drinks.</p>\r\n<p> </p>','images/sampledata/fruitshop/tamarind.jpg','','',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"plain\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Wikipedia: Tamarind English\",\"linka\":\"http:\\/\\/en.wikipedia.org\\/wiki\\/Tamarind\",\"linkb_name\":\"Wikipedia: \\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2  \\u09ac\\u09be\\u0982\\u09b2\\u09be  \",\"linkb\":\"http:\\/\\/bn.wikipedia.org\\/wiki\\/\\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2 \",\"linkc_name\":\"Wikipedia: Tamarinier Fran\\u00e7ais\",\"linkc\":\"http:\\/\\/fr.wikipedia.org\\/wiki\\/Tamarinier\",\"linkd_name\":\"Wikipedia:Tamaline lea faka-Tonga\",\"linkd\":\"http:\\/\\/to.wikipedia.org\\/wiki\\/Tamaline\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"beez5:encyclopedia\"}',0,57,1,'','','','','','*','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__contact_details VALUES(8,'Shop Address','shop-address','','','Our City','Our Province','Our Country','','555-555-5555','','<p>Here are directions for how to get to our shop.</p>','','','',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,35,1,'','','','','','*','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00');



DROP TABLE IF EXISTS #__content;

CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `title_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'Deprecated in Joomla! 3.0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) AUTO_INCREMENT=73 DEFAULT CHARSET=utf8;

INSERT INTO #__content VALUES(1,89,'Administrator Components','administrator-components','','<p>All components are also used in the administrator area of your website. In addition to the ones listed here, there are components in the administrator that do not have direct front end displays, but do help shape your site. The most important ones for most users are</p>\r\n<ul>\r\n<li>Media Manager</li>\r\n<li>Extensions Manager</li>\r\n<li>Menu Manager</li>\r\n<li>Global Configuration</li>\r\n<li>Banners</li>\r\n<li>Redirect</li>\r\n</ul>\r\n<hr title=\"Media Manager\" alt=\"Media Manager\" class=\"system-pagebreak\" style=\"color: gray; border: 1px dashed gray;\" />\r\n<p> </p>\r\n<h3>Media Manager</h3>\r\n<p>The media manager component lets you upload and insert images into content throughout your site. Optionally, you can enable the flash uploader which will allow you to to upload multiple images. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Content_Media_Manager\">Help</a></p>\r\n<hr title=\"Extensions Manager\" alt=\"Extensions Manager\" class=\"system-pagebreak\" style=\"color: gray; border: 1px dashed gray;\" />\r\n<h3>Extensions Manager</h3>\r\n<p>The extensions manager lets you install, update, uninstall and manage all of your extensions. The extensions manager has been extensively redesigned, although the core install and uninstall functionality remains the same as in Joomla! 1.5. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Extension_Manager_Install\">Help</a></p>\r\n<hr title=\"Menu Manager\" alt=\"Menu Manager\" class=\"system-pagebreak\" style=\"color: gray; border: 1px dashed gray;\" />\r\n<h3>Menu Manager</h3>\r\n<p>The menu manager lets you create the menus you see displayed on your site. It also allows you to assign modules and template styles to specific menu links. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Menus_Menu_Manager\">Help</a></p>\r\n<hr title=\"Global Configuration\" alt=\"Global Configuration\" class=\"system-pagebreak\" style=\"color: gray; border: 1px dashed gray;\" />\r\n<h3>Global Configuration</h3>\r\n<p>The global configuration is where the site administrator configures things such as whether search engine friendly urls are enabled, the site meta data (descriptive text used by search engines and indexers) and other functions. For many beginning users simply leaving the settings on default is a good way to begin, although when your site is ready for the public you will want to change the meta data to match its content. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Site_Global_Configuration\">Help</a></p>\r\n<hr title=\"Banners\" alt=\"Banners\" class=\"system-pagebreak\" style=\"color: gray; border: 1px dashed gray;\" />\r\n<h3>Banners</h3>\r\n<p>The banners component provides a simple way to display a rotating image in a module and, if you wish to have advertising, a way to track the number of times an image is viewed and clicked. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Banners_Banners_Edit\">Help</a></p>\r\n<hr title=\"Redirect\" class=\"system-pagebreak\" />\r\n<h3><br />Redirect</h3>\r\n<p>The redirect component is used to manage broken links that produce Page Not Found (404) errors. If enabled it will allow you to redirect broken links to specific pages. It can also be used to manage migration related URL changes. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Redirect_Manager\">Help</a></p>','',1,0,0,21,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:03:19',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',9,0,7,'','',1,4,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(2,90,'Archive Module','archive-module','','<p>This module shows a list of the calendar months containing archived articles. After you have changed the status of an article to archived, this list will be automatically generated. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Archive\" title=\"Archive Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_archive,Archived Articles}</div>','',1,0,0,64,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:18:05',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',5,0,5,'modules, content','',1,5,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(3,91,'Article Categories Module','article-categories-module','','<p>This module displays a list of categories from one parent category. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Categories\" title=\"Categories Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_categories,Articles Categories}</div>\r\n<p> </p>','',1,0,0,64,'2011-01-01 00:00:01',614,'','2011-09-17 22:13:31',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',5,0,6,'modules, content','',1,6,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(4,92,'Articles Category Module','articles-category-module','','<p>This module allows you to display the articles in a specific category. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Category\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_category,Articles Category}</div>','',1,0,0,64,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:18:26',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',8,0,7,'','articles,content',1,10,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(5,101,'Authentication','authentication','','<p>The authentication plugins operate when users login to your site or administrator. The Joomla! authentication plugin is in operation by default but you can enable Gmail or LDAP or install a plugin for a different system. An example is included that may be used to create a new authentication plugin.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Joomla <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Authentication_-_GMail\">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>Gmail <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Authentication_-_GMail\">Help</a></li>\r\n<li>LDAP <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Authentication_-_LDAP\">Help</a></li>\r\n</ul>','',1,0,0,25,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:04:13',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,0,3,'','',1,2,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(6,102,'Australian Parks ','australian-parks','','<p><img src=\"images/sampledata/parks/banner_cradle.jpg\" border=\"0\" alt=\"Cradle Park Banner\" /></p>\r\n<p>Welcome!</p>\r\n<p>This is a basic site about the beautiful and fascinating parks of Australia.</p>\r\n<p>On this site you can read all about my travels to different parks, see photos, and find links to park websites.</p>\r\n<p><em>This sample site is an example of using the core of Joomla! to create a basic website, whether a \"brochure site,\"  a personal blog, or as a way to present information on a topic you are interested in.</em></p>\r\n<p><em> Read more about the site in the About Parks module.</em></p>\r\n<p> </p>','',1,0,0,26,'2011-01-01 00:00:01',614,'Parks Webmaster','2011-09-06 06:20:19',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,1,'','',1,24,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(7,103,'Banner Module','banner-module','','<p>The banner module is used to display the banners that are managed by the banners component in the site administrator. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Banners\">Help</a>.</p>\r\n<div class=\"sample-module\">{loadmodule banners,Banners}</div>','',1,0,0,66,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:32:58',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',4,0,6,'','',1,4,'',0,'*','');
INSERT INTO #__content VALUES(8,104,'Home Decorating Ideas','beginners','','<p>If this is your first Joomla! site or your first web site, you have come to the right place. Joomla will help you get your website up and running quickly and easily. Start off using your site by logging in using the administrator account you created when you installed Joomla. Explore the articles and other resources right here on your site data to learn more about how Joomla works. You\'ll also want to sign up for the Joomla Security.</p>\r\n','\r\n<p>Explore the articles and other resources right here on your site data to learn more about how Joomla works. (When you\'re done reading, you can delete or archive all of this.) You will also probably want to visit the Beginners\' Areas of the <a href=\"http://docs.joomla.org/Beginners\">Joomla documentation</a> and <a href=\"http://forum.joomla.org\">support forums</a>.</p>\r\n<p>You\'ll also want to sign up for the Joomla Security Mailing list and the Announcements mailing list. For inspiration visit the <a href=\"http://community.joomla.org/showcase/\">Joomla! Site Showcase</a> to see an amazing array of ways people use Joomla to tell their stories on the web.</p>\r\n<p>The basic Joomla installation will let you get a great site up and running, but when you are ready for more features the power of Joomla is in the creative ways that developers have extended it to do all kinds of things. Visit the <a href=\"http://extensions.joomla.org/\">Joomla! Extensions Directory</a> to see thousands of extensions that can do almost anything you could want on a website. Can\'t find what you need? You may want to find a Joomla professional in the <a href=\"http://resources.joomla.org/\">Joomla! Resource Directory</a>.</p>\r\n<p>Want to learn more? Consider attending a <a href=\"http://community.joomla.org/events.html\">Joomla! Day</a> or other event or joining a local <a href=\"http://community.joomla.org/user-groups.html\">Joomla! Users Group</a>. Can\'t find one near you? Start one yourself.</p>',1,0,0,19,'2011-01-01 00:00:01',614,'Joomla!','2012-11-13 13:16:43',614,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',9,0,4,'','',1,46,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*','');
INSERT INTO #__content VALUES(9,105,'Contacts','contact','','<p>The contact component provides a way to provide contact forms and information for your site or to create a complex directory that can be used for many different purposes. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Contacts_Contacts\">Help</a></p>','',1,0,0,21,'2011-01-01 00:00:01',614,'Joomla!','2011-01-10 04:15:37',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,2,'','',1,8,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(10,106,'Content','content','','<p>The content component (com_content) is what you use to write articles. It is extremely flexible and has the largest number of built in views. Articles can be created and edited from the front end, making content the easiest component to use to create your site content. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Content_Article_Manager\">Help</a></p>','',1,0,0,21,'2011-01-01 00:00:01',614,'','2011-01-10 04:28:12',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,1,'','',1,11,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(11,107,'Cradle Mountain','cradle-mountain','','<p> </p>\r\n','\r\n<p> </p>',1,0,0,73,'2011-01-01 00:00:01',614,'Parks Webmaster','2012-01-17 04:42:36',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"images\\/sampledata\\/parks\\/landscape\\/250px_cradle_mountain_seen_from_barn_bluff.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Cradle Mountain\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/landscape\\/800px_cradle_mountain_seen_from_barn_bluff.jpg\",\"float_fulltext\":\"none\",\"image_fulltext_alt\":\"Cradle Mountain\",\"image_fulltext_caption\":\"Source: http:\\/\\/commons.wikimedia.org\\/wiki\\/File:Rainforest,bluemountainsNSW.jpg Author: Alan J.W.C. License: GNU Free Documentation License v . 1.2 or later\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,0,1,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(12,110,'Custom HTML Module','custom-html-module','','<p>This module allows you to create your own HTML Module using a WYSIWYG editor. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Custom_HTML\" title=\"Custom HTML Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule custom,Custom HTML}</div>','',1,0,0,66,'2011-01-01 00:00:01',614,'','2011-12-27 11:12:46',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',13,0,1,'','',1,13,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(13,111,'Directions','directions','','<p>Here\'s how to find our shop.</p><p>By car</p><p>Drive along Main Street to the intersection with First Avenue.  Look for our sign.</p><p>By foot</p><p>From the center of town, walk north on Main Street until you see our sign.</p><p>By bus</p><p>Take the #73 Bus to the last stop. We are on the north east corner.</p>','',1,0,0,29,'2011-01-01 00:00:01',614,'Fruit Shop Webmaster','2011-01-01 00:00:01',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',1,0,2,'','',1,0,'',0,'*','');
INSERT INTO #__content VALUES(14,112,'Editors','editors','','<p>Editors are used thoughout Joomla! where content is created. TinyMCE is the default choice in most locations although CodeMirror is used in the template manager. No Editor provides a text box for html content.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>CodeMirror <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Editor_-_CodeMirror\">Help</a></li>\r\n<li>TinyMCE<a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Editor_-_TinyMCE\"> Help</a></li>\r\n<li>No Editor <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Editor_-_None\">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>None</li>\r\n</ul>','',1,0,0,25,'2011-01-01 00:00:01',614,'Joomla!','2011-09-06 05:45:40',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',2,0,5,'','',1,0,'',0,'*','');
INSERT INTO #__content VALUES(15,113,'Editors-xtd','editors-xtd','','<p>These plugins are the buttons found beneath your editor. They only run when an editor plugin runs.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Editor Button: Image<a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Image\"> Help</a></li>\r\n<li>Editor Button: Readmore <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Readmore\">Help</a></li>\r\n<li>Editor Button: Page Break <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Pagebreak\">Help</a></li>\r\n<li>Editor Button: Article <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Button_-_Article\">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>None</li>\r\n</ul>','',1,0,0,25,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:14:12',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,0,6,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(16,114,'Feed Display','feed-display','','<p>This module allows the displaying of a syndicated feed. <a href=\"http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Feed_Display\" title=\"Feed Display Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule feed,Feed Display}</div>','',1,0,0,66,'2011-01-01 00:00:01',614,'','2011-09-17 22:22:08',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',3,0,2,'','',1,3,'',0,'*','');
INSERT INTO #__content VALUES(17,115,'First Blog Post','first-blog-post','','<p><em>Lorem Ipsum is filler text that is commonly used by designers before the content for a new site is ready.</em></p><p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed faucibus purus vitae diam posuere nec eleifend elit dictum. Aenean sit amet erat purus, id fermentum lorem. Integer elementum tristique lectus, non posuere quam pretium sed. Quisque scelerisque erat at urna condimentum euismod. Fusce vestibulum facilisis est, a accumsan massa aliquam in. In auctor interdum mauris a luctus. Morbi euismod tempor dapibus. Duis dapibus posuere quam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. In eu est nec erat sollicitudin hendrerit. Pellentesque sed turpis nunc, sit amet laoreet velit. Praesent vulputate semper nulla nec varius. Aenean aliquam, justo at blandit sodales, mauris leo viverra orci, sed sodales mauris orci vitae magna.</p>','<p>Quisque a massa sed libero tristique suscipit. Morbi tristique molestie metus, vel vehicula nisl ultrices pretium. Sed sit amet est et sapien condimentum viverra. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Phasellus viverra tortor porta orci convallis ac cursus erat sagittis. Vivamus aliquam, purus non luctus adipiscing, orci urna imperdiet eros, sed tincidunt neque sapien et leo. Cras fermentum, dolor id tempor vestibulum, neque lectus luctus mauris, nec congue tellus arcu nec augue. Nulla quis mi arcu, in bibendum quam. Sed placerat laoreet fermentum. In varius lobortis consequat. Proin vulputate felis ac arcu lacinia adipiscing. Morbi molestie, massa id sagittis luctus, sem sapien sollicitudin quam, in vehicula quam lectus quis augue. Integer orci lectus, bibendum in fringilla sit amet, rutrum eget enim. Curabitur at libero vitae lectus gravida luctus. Nam mattis, ligula sit amet vestibulum feugiat, eros sem sodales mi, nec dignissim ante elit quis nisi. Nulla nec magna ut leo convallis sagittis ac non erat. Etiam in augue nulla, sed tristique orci. Vestibulum quis eleifend sapien.</p><p>Nam ut orci vel felis feugiat posuere ut eu lorem. In risus tellus, sodales eu eleifend sed, imperdiet id nulla. Nunc at enim lacus. Etiam dignissim, arcu quis accumsan varius, dui dui faucibus erat, in molestie mauris diam ac lacus. Sed sit amet egestas nunc. Nam sollicitudin lacinia sapien, non gravida eros convallis vitae. Integer vehicula dui a elit placerat venenatis. Nullam tincidunt ligula aliquet dui interdum feugiat. Maecenas ultricies, lacus quis facilisis vehicula, lectus diam consequat nunc, euismod eleifend metus felis eu mauris. Aliquam dapibus, ipsum a dapibus commodo, dolor arcu accumsan neque, et tempor metus arcu ut massa. Curabitur non risus vitae nisl ornare pellentesque. Pellentesque nec ipsum eu dolor sodales aliquet. Vestibulum egestas scelerisque tincidunt. Integer adipiscing ultrices erat vel rhoncus.</p><p>Integer ac lectus ligula. Nam ornare nisl id magna tincidunt ultrices. Phasellus est nisi, condimentum at sollicitudin vel, consequat eu ipsum. In venenatis ipsum in ligula tincidunt bibendum id et leo. Vivamus quis purus massa. Ut enim magna, pharetra ut condimentum malesuada, auctor ut ligula. Proin mollis, urna a aliquam rutrum, risus erat cursus odio, a convallis enim lectus ut lorem. Nullam semper egestas quam non mattis. Vestibulum venenatis aliquet arcu, consectetur pretium erat pulvinar vel. Vestibulum in aliquet arcu. Ut dolor sem, pellentesque sit amet vestibulum nec, tristique in orci. Sed lacinia metus vel purus pretium sit amet commodo neque condimentum.</p><p>Aenean laoreet aliquet ullamcorper. Nunc tincidunt luctus tellus, eu lobortis sapien tincidunt sed. Donec luctus accumsan sem, at porttitor arcu vestibulum in. Sed suscipit malesuada arcu, ac porttitor orci volutpat in. Vestibulum consectetur vulputate eros ut porttitor. Aenean dictum urna quis erat rutrum nec malesuada tellus elementum. Quisque faucibus, turpis nec consectetur vulputate, mi enim semper mi, nec porttitor libero magna ut lacus. Quisque sodales, leo ut fermentum ullamcorper, tellus augue gravida magna, eget ultricies felis dolor vitae justo. Vestibulum blandit placerat neque, imperdiet ornare ipsum malesuada sed. Quisque bibendum quam porta diam molestie luctus. Sed metus lectus, ornare eu vulputate vel, eleifend facilisis augue. Maecenas eget urna velit, ac volutpat velit. Nam id bibendum ligula. Donec pellentesque, velit eu convallis sodales, nisi dui egestas nunc, et scelerisque lectus quam ut ipsum.</p>',1,0,0,27,'2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',1,0,2,'','',1,0,'',0,'*','');
INSERT INTO #__content VALUES(18,116,'Second Blog Post','second-blog-post','','<p><em>Lorem Ipsum is text that is traditionally used by designers when working on a site before the content is ready.</em></p><p>Pellentesque bibendum metus ut dolor fermentum ut pulvinar tortor hendrerit. Nam vel odio vel diam tempus iaculis in non urna. Curabitur scelerisque, nunc id interdum vestibulum, felis elit luctus dui, ac dapibus tellus mauris tempus augue. Duis congue facilisis lobortis. Phasellus neque erat, tincidunt non lacinia sit amet, rutrum vitae nunc. Sed placerat lacinia fermentum. Integer justo sem, cursus id tristique eget, accumsan vel sapien. Curabitur ipsum neque, elementum vel vestibulum ut, lobortis a nisl. Fusce malesuada mollis purus consectetur auctor. Morbi tellus nunc, dapibus sit amet rutrum vel, laoreet quis mauris. Aenean nec sem nec purus bibendum venenatis. Mauris auctor commodo libero, in adipiscing dui adipiscing eu. Praesent eget orci ac nunc sodales varius.</p>','<p>Nam eget venenatis lorem. Vestibulum a interdum sapien. Suspendisse potenti. Quisque auctor purus nec sapien venenatis vehicula malesuada velit vehicula. Fusce vel diam dolor, quis facilisis tortor. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Pellentesque libero nisi, pellentesque quis cursus sit amet, vehicula vitae nisl. Curabitur nec nunc ac sem tincidunt auctor. Phasellus in mattis magna. Donec consequat orci eget tortor ultricies rutrum. Mauris luctus vulputate molestie. Proin tincidunt vehicula euismod. Nam congue leo non erat cursus a adipiscing ipsum congue. Nulla iaculis purus sit amet turpis aliquam sit amet dapibus odio tincidunt. Ut augue diam, congue ut commodo pellentesque, fermentum mattis leo. Sed iaculis urna id enim dignissim sodales at a ipsum. Quisque varius lobortis mollis. Nunc purus magna, pellentesque pellentesque convallis sed, varius id ipsum. Etiam commodo mi mollis erat scelerisque fringilla. Nullam bibendum massa sagittis diam ornare rutrum.</p><p>Praesent convallis metus ut elit faucibus tempus in quis dui. Donec fringilla imperdiet nibh, sit amet fringilla velit congue et. Quisque commodo luctus ligula, vitae porttitor eros venenatis in. Praesent aliquet commodo orci id varius. Nulla nulla nibh, varius id volutpat nec, sagittis nec eros. Cras et dui justo. Curabitur malesuada facilisis neque, sed tempus massa tincidunt ut. Sed suscipit odio in lacus auctor vehicula non ut lacus. In hac habitasse platea dictumst. Sed nulla nisi, lacinia in viverra at, blandit vel tellus. Nulla metus erat, ultrices non pretium vel, varius nec sem. Morbi sollicitudin mattis lacus quis pharetra. Donec tincidunt mollis pretium. Proin non libero justo, vitae mattis diam. Integer vel elit in enim varius posuere sed vitae magna. Duis blandit tempor elementum. Vestibulum molestie dui nisi.</p><p>Curabitur volutpat interdum lorem sed tempus. Sed placerat quam non ligula lacinia sodales. Cras ultrices justo at nisi luctus hendrerit. Quisque sit amet placerat justo. In id sapien eu neque varius pharetra sed in sapien. Etiam nisl nunc, suscipit sed gravida sed, scelerisque ut nisl. Mauris quis massa nisl, aliquet posuere ligula. Etiam eget tortor mauris. Sed pellentesque vestibulum commodo. Mauris vitae est a libero dapibus dictum fringilla vitae magna.</p><p>Nulla facilisi. Praesent eget elit et mauris gravida lobortis ac nec risus. Ut vulputate ullamcorper est, volutpat feugiat lacus convallis non. Maecenas quis sem odio, et aliquam libero. Integer vel tortor eget orci tincidunt pulvinar interdum at erat. Integer ullamcorper consequat eros a pellentesque. Cras sagittis interdum enim in malesuada. Etiam non nunc neque. Fusce non ligula at tellus porta venenatis. Praesent tortor orci, fermentum sed tincidunt vel, varius vel dui. Duis pulvinar luctus odio, eget porta justo vulputate ac. Nulla varius feugiat lorem sed tempor. Phasellus pulvinar dapibus magna eget egestas. In malesuada lectus at justo pellentesque vitae rhoncus nulla ultrices. Proin ut sem sem. Donec eu suscipit ipsum. Cras eu arcu porttitor massa feugiat aliquet at quis nisl.</p>',1,0,0,27,'2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',0,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',1,0,1,'','',1,0,'',0,'*','');
INSERT INTO #__content VALUES(19,117,'Footer Module','footer-module','','<p>This module shows the Joomla! copyright information. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Footer\" title=\"Footer Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule footer,Footer}</div>','',1,0,0,66,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:22:47',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',4,0,3,'','',1,4,'',0,'*','');
INSERT INTO #__content VALUES(20,118,'Fruit Shop','fruit-shop','','<h2>Welcome to the Fruit Shop</h2>\r\n<p>We sell fruits from around the world. Please use our website to learn more about our business. We hope you will come to our shop and buy some fruit.</p>\r\n<p><em>This mini site will show you how you might want to set up a site for a business, in this example one selling fruit. It shows how to use access controls to manage your site content. If you were building a real site, you might want to extend it with e-commerce, a catalog, mailing lists or other enhancements, many of which are available through the</em><a href=\"http://extensions.joomla.org\"><em> Joomla! Extensions Directory</em></a>.</p>\r\n<p><em>To understand this site you will probably want to make one user with group set to customer and one with group set to grower. By logging in with different privileges you can see how access control works.</em></p>','',1,0,0,29,'2011-01-01 00:00:01',614,'Fruit Shop Webmaster','2011-12-27 11:17:59',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,1,'','',1,2,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(21,119,'Getting Help','getting-help','','<p><img class=\"image-left\" src=\"administrator/templates/hathor/images/header/icon-48-help_header.png\" border=\"0\" /> There are lots of places you can get help with Joomla!. In many places in your site administrator you will see the help icon. Click on this for more information about the options and functions of items on your screen. Other places to get help are:</p>\r\n<ul>\r\n<li><a href=\"http://forum.joomla.org\">Support Forums</a></li>\r\n<li><a href=\"http://docs.joomla.org\">Documentation</a></li>\r\n<li><a href=\"http://resources.joomla.org\">Professionals</a></li>\r\n<li><a href=\"http://shop.joomla.org/amazoncom-bookstores.html\">Books</a></li>\r\n</ul>','',1,0,0,19,'2011-01-01 00:00:01',614,'Joomla!','2011-01-10 15:32:54',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',10,0,8,'','',1,19,'',0,'*','');
INSERT INTO #__content VALUES(22,120,'Getting Started','getting-started','','<p>It\'s easy to get started creating your website. Knowing some of the basics will help.</p>\r\n<h3>What is a Content Management System?</h3>\r\n<p>A content management system is software that allows you to create and manage webpages easily by separating the creation of your content from the mechanics required to present it on the web.</p>\r\n<p>In this site, the content is stored in a <em>database</em>. The look and feel are created by a <em>template</em>. The Joomla! software brings together the template and the content to create web pages.</p>\r\n<h3>Site and Administrator</h3>\r\n<p>Your site actually has two separate sites. The site (also called the front end) is what visitors to your site will see. The administrator (also called the back end) is only used by people managing your site. You can access the administrator by clicking the \"Site Administrator\" link on the \"This Site\" menu or by adding /administrator to the end of you domain name.</p>\r\n<p>Log in to the administrator using the username and password created during the installation of Joomla.</p>\r\n<h3>Logging in</h3>\r\n<p>To login to the front end of your site use the login form or the login menu link on the \"This Site\" menu. Use the user name and password that were created as part of the installation process. Once logged-in you will be able to create and edit articles.</p>\r\n<p>In managing your site, you will be able to create content that only logged-in users are able to see.</p>\r\n<h3>Creating an article</h3>\r\n<p>Once you are logged-in, a new menu will be visible. To create a new article, click on the \"submit article\" link on that menu.</p>\r\n<p>The new article interface gives you a lot of options, but all you need to do is add a title and put something in the content area. To make it easy to find, set the state to published and put it in the Joomla category.</p>\r\n<div>You can edit an existing article by clicking on the edit icon (this only displays to users who have the right to edit).</div>\r\n<h3>Learn more</h3>\r\n<p>There is much more to learn about how to use Joomla! to create the web site you envision. You can learn much more at the <a href=\"http://docs.joomla.org\">Joomla! documentation site</a> and on the<a href=\"http://forum.joomla.org\"> Joomla! forums</a>.</p>','',1,0,0,19,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:21:44',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,9,'','',1,86,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(23,121,'Happy Orange Orchard','happy-orange-orchard','','<p>At our orchard we grow the world\'s best oranges as well as other citrus fruit such as lemons and grapefruit. Our family has been tending this orchard for generations.</p>','',1,0,0,30,'2011-01-01 00:00:01',614,'Fruit Shop Webmaster','2011-01-01 00:00:01',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',1,0,2,'','',1,0,'',0,'*','');
INSERT INTO #__content VALUES(24,122,'Tips on Buying Real Estate','joomla','','<p>Congratulations! You have a Joomla site! Joomla makes it easy to build a website just the way you want it and keep it simple to update and maintain. Joomla is a flexible and powerful platform, whether you are building a small site for yourself or a huge site with hundreds of thousands of visitors. Joomla is open source, which means you can make it work just the way you want it to.</p>\r\n','\r\n<p>Joomla is open source, which means you can make it work just the way you want it to.</p>',1,0,0,19,'2011-01-01 00:00:01',614,'Joomla!','2012-11-13 13:17:21',614,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',7,0,2,'','',1,2,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*','');
INSERT INTO #__content VALUES(25,123,'Koala','koala','','<p> </p>\r\n<p> </p>\r\n<p> </p>\r\n<p> </p>\r\n<p> </p>\r\n','\r\n<p> </p>',1,0,0,72,'2011-01-01 00:00:01',614,'Parks Webmaster','2012-01-17 05:15:00',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"images\\/sampledata\\/parks\\/animals\\/180px_koala_ag1.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Koala  Thumbnail\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/animals\\/800px_koala_ag1.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Koala Climbing Tree\",\"image_fulltext_caption\":\"Source: http:\\/\\/commons.wikimedia.org\\/wiki\\/File:Koala-ag1.jpg Author: Arnaud Gaillard License: Creative Commons Share Alike Attribution Generic 1.0\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',9,0,2,'','',1,2,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(26,124,'Language Switcher','language-switcher','','<p>The language switcher module allows you to take advantage of the language tags that are available when content, modules and menu links are created.</p>\r\n<p>This module displays a list of available Content Languages for switching between them.</p>\r\n<p>When switching languages, it redirects to the Home page, or associated menu item, defined for the chosen language. Thereafter, the navigation will be the one defined for that language.</p>\r\n<p><strong>The language filter plugin must be enabled for this module to work properly.</strong></p>\r\n<p><strong></strong> <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Language_Switcher\" title=\"Language Switcher Module\">Help</a></p>\r\n<p>To view an example of the language switch moduler module, go to the site administrator and enable the language filter plugin and the language switcher module labelled \"language switcher\" and visit the fruit shop or park sample sites. Then follow<a href=\"http://docs.joomla.org/Language_Switcher_Tutorial_for_Joomla_1.6\"> the instructions in this tutorial</a>.</p>','',1,0,0,67,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:25:00',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',3,0,3,'','',1,3,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(27,125,'Latest Articles Module','latest-articles-module','','<p>This module shows a list of the most recently published and current Articles. Some that are shown may have expired even though they are the most recent. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Latest_News\" title=\"Latest Articles\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_latest,Latest News}</div>','',1,0,0,64,'2011-01-01 00:00:01',614,'','2011-12-27 11:25:41',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',9,0,1,'modules, content','',1,15,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(28,126,'Login Module','login-module','','<p>This module displays a username and password login form. It also displays a link to retrieve a forgotten password. If user registration is enabled (in the Global Configuration settings), another link will be shown to enable self-registration for users. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Login\" title=\"Login\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule login,login}</div>','',1,0,0,65,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:20:35',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',4,0,2,'','',1,5,'',0,'*','');
INSERT INTO #__content VALUES(29,127,'Menu Module','menu-module','','<p>This module displays a menu on the site (frontend).  Menus can be displayed in a wide variety of ways by using the menu options and css menu styles. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Menu\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule mod_menu,Menu Example}</div>','',1,0,0,75,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:18:45',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',8,0,1,'','',1,13,'',0,'*','');
INSERT INTO #__content VALUES(30,128,'Most Read Content','most-read-content','','<p>This module shows a list of the currently published Articles which have the highest number of page views. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Most_Read\" title=\"Most Read Content\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_popular,Articles Most Read}</div>','',1,0,0,64,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:26:41',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',6,0,2,'modules, content','',1,11,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(31,129,'News Flash','news-flash','','<p>Displays a set number of articles from a category based on date or random selection. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Newsflash\" title=\"News Flash Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule articles_news,News Flash}</div>','',1,0,0,64,'2011-01-01 00:00:01',614,'','2011-09-17 22:16:46',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',4,0,3,'modules, content','',1,10,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(32,130,'Options','options','','<p>As you make your Joomla! site you will control the details of the display using <em>options</em> also referred to as <em>parameter</em><strong>s</strong>. Options control everything from whether the author\'s name is displayed to who can view what to the number of items shown on a list.</p>\r\n<p>Default options for each component are changed using the Options button on the component toolbar.</p>\r\n<p>Options can also be set on an individual item, such as an article or contact and in menu links.</p>\r\n<p>If you are happy with how your site looks, it is fine to leave all of the options set to the defaults that were created when your site was installed. As you become more experienced with Joomla you will use options more.</p>\r\n<p> </p>','',1,0,0,19,'2011-01-01 00:00:01',614,'Joomla!','2012-01-17 16:21:24',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,0,10,'','',1,4,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(33,131,'Phyllopteryx','phyllopteryx','','<p> </p>\r\n','\r\n<p> </p>',1,0,0,72,'2011-01-01 00:00:01',614,'Parks Webmaster','2012-01-17 04:57:58',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"images\\/sampledata\\/parks\\/animals\\/200px_phyllopteryx_taeniolatus1.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Phyllopteryx\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/animals\\/800px_phyllopteryx_taeniolatus1.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Phyllopteryx\",\"image_fulltext_caption\":\"Source: http:\\/\\/en.wikipedia.org\\/wiki\\/File:Phyllopteryx_taeniolatus1.jpg Author: Richard Ling License: GNU Free Documentation License v 1.2 or later\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(34,132,'Pinnacles','pinnacles','','<p> </p>\r\n','\r\n<p> </p>',1,0,0,73,'2011-01-01 00:00:01',614,'Parks Webmaster','2012-01-17 04:41:30',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"images\\/sampledata\\/parks\\/landscape\\/120px_pinnacles_western_australia.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Kings Canyon\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/landscape\\/800px_pinnacles_western_australia.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Kings Canyon\",\"image_fulltext_caption\":\"Source: http:\\/\\/commons.wikimedia.org\\/wiki\\/File:Pinnacles_Western_Australia.jpg  Author: Martin Gloss  License: GNU Free Documentation license v 1.2 or later.\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',3,0,4,'','',1,3,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(35,133,'Professionals','professionals','','<p>Joomla! 2.5 continues development of the Joomla Framework and CMS as a powerful and flexible way to bring your vision of the web to reality. With the administrator now fully MVC, the ability to control its look and the management of extensions is now complete.</p>\r\n','\r\n<p>Working with multiple template styles and overrides for the same views, creating the design you want is easier than it has ever been. Limiting support to PHP 5.2.4 and above makes Joomla lighter and faster than ever. Languages files can now be overridden without having your changes lost during an upgrade.  With the proper xml your users update extensions with a single click.</p>\r\n<p>Access control lists are now incorporated using a new system developed for Joomla. The ACL system is designed with developers in mind, so it is easy to incorporate into your extensions. The new nested sets libraries allow you to incorporate infinitely deep categories but also to use nested sets in a variety of other ways.</p>\r\n<p>A new forms library makes creating all kinds of user interaction simple. MooTools 1.3 provides a highly flexible javascript framework that is a major advance over MooTools 1.0.</p>\r\n<p>New events throughout the core make integration of your plugins where you want them a snap.</p>\r\n<p>The separation of the Joomla! Platform project from the Joomla! CMS project makes continuous development of new, powerful APIs  and continuous improvement of existing APIs possible while maintaining the stability of the CMS that millions of webmasters and professionals rely upon.</p>\r\n<p>Learn about:</p>\r\n<ul>\r\n<li><a href=\"http://docs.joomla.org/What\'s_new_in_Joomla_1.6\">Changes since 1.5</a></li>\r\n<li><a href=\"http://docs.joomla.org/ACL_Tutorial_for_Joomla_1.6\">Working with ACL</a></li>\r\n<li><a href=\"http://docs.joomla.org/API16:JCategories\">Working with nested categories</a></li>\r\n<li><a href=\"http://docs.joomla.org/API16:JForm\">Forms library</a></li>\r\n<li><a href=\"http://docs.joomla.org/Working_with_Mootools_1.3\">Working with Mootools 1.3</a></li>\r\n<li><a href=\"http://docs.joomla.org/Layout_Overrides_in_Joomla_1.6\">Using new features of the override system</a></li>\r\n<li><a href=\"http://api.joomla.org\">Joomla! API</a></li>\r\n<li><a href=\"http://docs.joomla.org/API16:JDatabaseQuery\">Using JDatabaseQuery</a></li>\r\n<li><a href=\"http://docs.joomla.org/What\'s_new_in_Joomla_1.6#Events\">New and updated events</a></li>\r\n<li><a href=\"http://docs.joomla.org/Xml-rpc_changes_in_Joomla!_1.6\">Xmlrpc</a></li>\r\n<li><a href=\"http://docs.joomla.org/What\'s_new_in_Joomla_1.6#Extension_management\">Installing and updating extensions</a></li>\r\n<li><a href=\"http://docs.joomla.org/Setting_up_your_workstation_for_Joomla!_development\">Setting up your development environment</a></li>\r\n<li><a href=\"github.com/joomla\">The Joomla! Platform Repository</a> </li>\r\n</ul>',1,0,0,19,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:36:13',42,0,'0000-00-00 00:00:00','2011-01-09 16:41:13','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',16,0,5,'','',1,13,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*','');
INSERT INTO #__content VALUES(36,134,'Random Image Module','random-image-module','','<p>This module displays a random image from your chosen image directory. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Random_Image\" title=\"Random Image Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule random_image,Random Image}</div>','',1,0,0,66,'2011-01-01 00:00:01',614,'','2012-01-17 16:11:13',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',6,0,4,'','',1,6,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(37,135,'Related Items Module','related-items-module','','<p>This module displays other Articles that are related to the one currently being viewed. These relations are established by the Meta Keywords.  All the keywords of the current Article are searched against all the keywords of all other published articles. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Articles_Related\" title=\"Related Items Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule related_items,Articles Related Items}</div>','',1,0,0,64,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:37:34',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',5,0,4,'modules, content','',1,5,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(38,136,'Sample Sites','sample-sites','','<p>Your installation includes sample data, designed to show you some of the options you have for building your website. In addition to information about Joomla! there are two sample \"sites within a site\" designed to help you get started with building your own site.</p>\r\n<p>The first site is a simple site about <a href=\"index.php?Itemid=243\">Australian Parks</a>. It shows how you can quickly and easily build a personal site with just the building blocks that are part of Joomla. It includes a personal blog, weblinks, and a very simple image gallery.</p>\r\n<p>The second site is slightly more complex and represents what you might do if you are building a site for a small business, in this case a <a href=\"index.php/welcome.html\"></a><a href=\"index.php?Itemid=429\">Fruit Shop</a>.</p>\r\n<p>In building either style site, or something completely different, you will probably want to add <a href=\"http://extensions.joomla.org\">extensions</a> and either create or purchase your own template. Many Joomla users start by modifying the <a href=\"http://docs.joomla.org/How_do_you_modify_a_template%3F\">templates</a> that come with the core distribution so that they include special images and other design elements that relate to their site\'s focus.</p>','',1,0,0,19,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:39:07',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,11,'','',1,19,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(39,137,'Search','search-component','','<p>Joomla! 2.5 offers two search options.</p>\r\n<p>The Basic Search component provides basic search functionality for the information contained in your core components. Many extensions can also be searched by the search component. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Search\">Help</a></p>\r\n<p>The Smart Search component offers searching similar to that found in major search engines. Smart Search is disabled by default. If you choose to enable it you will need to take several steps. First, enable the Smart Search Plugin in the plugin manager. Then, if you are using the Basic Search Module replace it with the Smart Search Module. Finally, if you have already created content, go to the Smart Search component in your site administrator and click the Index icon. Once indexing of your content is complete, Smart Search will be ready to use. Help.</p>','',1,0,0,21,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:41:48',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,0,3,'','',1,5,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(40,138,'Search Module','search-module','','<p>This module will display a search box. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Search\" title=\"Search\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule search,Search}</div>','',1,0,0,67,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:35:56',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',4,0,4,'','',1,6,'',0,'*','');
INSERT INTO #__content VALUES(41,139,'Search ','search-plugin','','<p>The search component uses plugins to control which parts of your Joomla! site are searched. You may choose to turn off some areas to improve performance or for other reasons. Many third party Joomla! extensions have search plugins that extend where search takes place.</p>\r\n<p>Default On:</p>\r\n<ul>\r\n<li>Content <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Content\">Help</a></li>\r\n<li>Contacts <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Contacts\">Help</a></li>\r\n<li>Weblinks <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Weblinks\">Help</a></li>\r\n<li>News Feeds <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Newsfeeds\">Help</a></li>\r\n<li>Categories <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Search_-_Categories\">Help</a></li>\r\n</ul>','',1,0,0,25,'2011-01-01 00:00:01',614,'Joomla!','2011-09-06 06:13:18',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',3,0,1,'','',1,0,'',0,'*','');
INSERT INTO #__content VALUES(42,140,'Site Map','site-map','','<p>{loadposition sitemapload}</p><p><em>By putting all of your content into nested categories you can give users and search engines access to everything using a menu.</em></p>','',1,0,0,14,'2011-01-01 00:00:01',614,'Joomla!','2011-01-01 00:00:01',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',1,0,2,'','',1,40,'',0,'*','');
INSERT INTO #__content VALUES(43,141,'Spotted Quoll','spotted-quoll','','<p> </p>\r\n<p> </p>\r\n','\r\n<p> </p>',1,0,0,72,'2011-01-01 00:00:01',614,'Parks Webmaster','2012-01-17 05:02:58',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"images\\/sampledata\\/parks\\/animals\\/220px_spottedquoll_2005_seanmcclean.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Spotted Quoll\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/animals\\/789px_spottedquoll_2005_seanmcclean.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Spotted Quoll\",\"image_fulltext_caption\":\"Source: http:\\/\\/en.wikipedia.org\\/wiki\\/File:SpottedQuoll_2005_SeanMcClean.jpg Author: Sean McClean License: GNU Free Documentation License v 1.2 or later\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,0,4,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(44,142,'Statistics Module','statistics','','<p>This module shows information about your server installation together with statistics on the Web site users, number of Articles in your database and the number of Web links you provide.</p>\r\n<div class=\"sample-module\">{loadmodule mod_stats,Statistics}</div>','',1,0,0,67,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:43:25',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',6,0,5,'','',1,5,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(45,143,'Syndicate Module','syndicate-module','','<p>The syndicate module will display a link that allows users to take a feed from your site. It will only display on pages for which feeds are possible. That means it will not display on single article, contact or weblinks pages, such as this one. <a href=\"http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Syndicate\" title=\"Synicate Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadposition syndicate,Syndicate}</div>','',1,0,0,67,'2011-01-01 00:00:01',614,'','2011-12-27 11:44:16',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',3,0,6,'','',1,2,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(46,144,'System','system','','<p>System plugins operate every time a page on your site loads. They control such things as your URLS, whether users can check a \"remember me\" box on the login module, and whether caching is enabled. New is the redirect plugin that together with the redirect component will assist you in managing changes in URLs.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Remember me <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Remember_Me\">Help</a></li>\r\n<li>SEF <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_SEF\">Help</a></li>\r\n<li>Debug <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Debug\">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>Cache <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Cache\">Help</a></li>\r\n<li>Log <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Log\">Help</a></li>\r\n<li>Redirect <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#System_-_Redirect\">Help</a></li>\r\n</ul>','',1,0,0,25,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:45:54',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',5,0,2,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(47,145,'The Joomla! Community','the-joomla-community','','<p>Joomla means All Together, and it is a community of people all working and having fun together that makes Joomla possible. Thousands of people each year participate in the Joomla community, and we hope you will be one of them.</p>\r\n<p>People with all kinds of skills, of all skill levels and from around the world are welcome to join in. Participate in the <a href=\"http://joomla.org\">Joomla.org</a> family of websites (the<a href=\"http://forum.joomla.org\"> forum </a>is a great place to start). Come to a <a href=\"http://community.joomla.org/events.html\">Joomla! event</a>. Join or start a <a href=\"http://community.joomla.org/user-groups.html\">Joomla! Users Group</a>. Whether you are a developer, site administrator, designer, end user or fan, there are ways for you to participate and contribute.</p>','',1,0,0,19,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:47:56',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',3,0,3,'','',1,29,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(48,146,'The Joomla! Project','the-joomla-project','','<p>The Joomla Project consists of all of the people who make and support the Joomla Web Platform and Content Management System.</p>\r\n<p>Our mission is to provide a flexible platform for digital publishing and collaboration.</p>\r\n<p>The core values are:</p>\r\n<ul>\r\n<li>Freedom</li>\r\n<li>Equality</li>\r\n<li>Trust</li>\r\n<li>Community</li>\r\n<li>Collaboration</li>\r\n<li>Usability</li>\r\n</ul>\r\n<p>In our vision, we see:</p>\r\n<ul>\r\n<li>People publishing and collaborating in their communities and around the world</li>\r\n<li>Software that is free, secure, and high-quality</li>\r\n<li>A community that is enjoyable and rewarding to participate in</li>\r\n<li>People around the world using their preferred languages</li>\r\n<li>A project that acts autonomously</li>\r\n<li>A project that is socially responsible</li>\r\n<li>A project dedicated to maintaining the trust of its users</li>\r\n</ul>\r\n<p>There are millions of users around the world and thousands of people who contribute to the Joomla Project. They work in three main groups: the Production Working Group, responsible for everything that goes into software and documentation; the Community Working Group, responsible for creating a nurturing the community; and Open Source Matters, the non profit organization responsible for managing legal, financial and organizational issues.</p>\r\n<p>Joomla is a free and open source project, which uses the GNU General Public License version 2 or later.</p>','',1,0,0,19,'2011-01-01 00:00:01',614,'','2011-12-27 11:47:48',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,1,'','',1,67,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(49,147,'Typography','typography','','<h1>H1 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h1><h2>H2 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h2><h3>H3 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h3><h4>H4 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h4><h5>H5 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h5><h6>H6 ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmonpqrstuvwzyz</h6><p>P The quick brown fox ran over the lazy dog. THE QUICK BROWN FOX RAN OVER THE LAZY DOG.</p><ul><li>Item</li><li>Item</li><li>Item<br /> <ul><li>Item</li><li>Item</li><li>Item<br /> <ul><li>Item</li><li>Item</li><li>Item</li></ul></li></ul></li></ul><ol><li>tem</li><li>Item</li><li>Item<br /> <ol><li>Item</li><li>Item</li><li>Item<br /><ol><li>Item</li><li>Item</li><li>Item</li></ol></li></ol> </li></ol>','',1,0,0,23,'2011-01-01 00:00:01',614,'Joomla!','2011-01-01 00:00:01',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',1,0,1,'','',1,0,'',0,'*','');
INSERT INTO #__content VALUES(50,148,'Upgraders','upgraders','','<p>If you are an experienced Joomla! 1.5 user, this Joomla site will seem very familiar. There are new templates and improved user interfaces, but most functionality is the same. The biggest changes are improved access control (ACL) and nested categories. This release of Joomla has strong continuity with Joomla! 1.7 while adding enhancements.</p>\r\n','\r\n<p>The new user manager will let you manage who has access to what in your site. You can leave access groups exactly the way you had them in Joomla 1.5 or make them as complicated as you want. You can learn more about<a href=\"http://docs.joomla.org/ACL_Tutorial_for_Joomla_1.6\"> how access control works</a> in on the <a href=\"http://docs.joomla.org\">Joomla! Documentation site</a></p>\r\n<p>In Joomla 1.5 and 1.0 content was organized into sections and categories. From 1.6 forward sections are gone, and you can create categories within categories, going as deep as you want. The sample data provides many examples of the use of nested categories.</p>\r\n<p>All layouts have been redesigned to improve accessibility and flexibility. </p>\r\n<p>Updating your site and extensions when needed is easier than ever thanks to installer improvements.</p>\r\n<p> </p>',1,0,0,19,'2011-01-01 00:00:01',614,'','2012-01-17 04:28:10',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',5,0,6,'','',1,48,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*','');
INSERT INTO #__content VALUES(51,149,'User','user-plugins','','<p>Default on:</p>\r\n<ul>\r\n<li>Joomla <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#User_-_Joomla.21\">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<p>Two new plugins are available but are disabled by default.</p>\r\n<ul>\r\n<li>Contact Creator <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#User_-_Contact_Creator\">Help</a><br />Creates a new linked contact record for each new user created.</li>\r\n<li>Profile <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#User_-_Profile\">Help</a><br />This example profile plugin allows you to insert additional fields into user registration and profile display. This is intended as an example of the types of extensions to the profile you might want to create.</li>\r\n</ul>','',1,0,0,25,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:51:25',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',3,0,4,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(52,150,'Users','users-component','','<p>The users extension lets your site visitors register, login and logout, change their passwords and other information, and recover lost passwords. In the administrator it allows you to create, block and manage users and create user groups and access levels. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Users_User_Manager\">Help</a></p>\r\n<p>Please note that some of the user views will not display if you are not logged-in to the site.</p>','',1,0,0,21,'2011-01-01 00:00:01',614,'Joomla!','2011-01-10 04:52:55',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,5,'','',1,9,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(53,151,'Using Joomla!','using-joomla','','<p>With Joomla you can create anything from a simple personal website to a complex ecommerce or social site with millions of visitors.</p>\r\n<p>This section of the sample data provides you with a brief introduction to Joomla concepts and reference material to help you understand how Joomla works.</p>\r\n<p><em>When you no longer need the sample data, you can can simply unpublish the sample data category found within each extension in the site administrator or you may completely delete each item and all of the categories. </em></p>','',1,0,0,19,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:52:45',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,7,'','',1,391,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(54,152,'Weblinks','weblinks','','<p>Weblinks (com_weblinks) is a component that provides a structured way to organize external links and present them in a visually attractive, consistent and informative way. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Weblinks_Links\">Help</a></p>','',1,0,0,21,'2011-01-01 00:00:01',614,'Joomla!','2011-01-10 04:20:10',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',2,0,6,'','',1,4,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(55,153,'Weblinks Module','weblinks-module','','<p>This module displays the list of weblinks in a category. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Weblinks\" title=\"Weblinks Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule weblinks,Weblinks}</div>','',1,0,0,66,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:32:10',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',7,0,5,'','',1,23,'',0,'*','');
INSERT INTO #__content VALUES(56,154,'Who\'s Online','whos-online','','<p>The Who\'s Online Module displays the number of Anonymous Users (e.g. Guests) and Registered Users (ones logged-in) that are currently accessing the Web site. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Who_Online\" title=\"Who\'s Online\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule whosonline,Who\'s Online}</div>','',1,0,0,65,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:19:45',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',4,0,1,'','',1,8,'',0,'*','');
INSERT INTO #__content VALUES(57,155,'Wobbegone','wobbegone','','<p> </p>\r\n','\r\n<p> </p>',1,0,0,72,'2011-01-01 00:00:01',614,'Parks Webmaster','2012-01-17 05:01:59',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"images\\/sampledata\\/parks\\/animals\\/180px_wobbegong.jpg\",\"float_intro\":\"\",\"image_intro_alt\":\"Wobbegon\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/animals\\/800px_wobbegong.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Wobbegon\",\"image_fulltext_caption\":\"Source: http:\\/\\/en.wikipedia.org\\/wiki\\/File:Wobbegong.jpg Author: Richard Ling Rights: GNU Free Documentation License v 1.2 or later\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(58,156,'Wonderful Watermelon','wonderful-watermelon','','<p>Watermelon is a wonderful and healthy treat. We grow the world\'s sweetest watermelon. We have the largest watermelon patch in our country.</p>','',1,0,0,30,'2011-01-01 00:00:01',614,'Fruit Shop Webmaster','2011-01-01 00:00:01',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',1,0,1,'','',1,0,'',0,'*','');
INSERT INTO #__content VALUES(59,157,'Wrapper Module','wrapper-module','','<p>This module shows an iFrame window to specified location. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Wrapper\" title=\"Wrapper Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule wrapper,Wrapper}</div>','',1,0,0,67,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:35:00',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',8,0,1,'','',1,15,'',0,'*','');
INSERT INTO #__content VALUES(60,158,'News Feeds','news-feeds','','<p>News Feeds (com_newsfeeds) provides a way to organize and present news feeds. News feeds are a way that you present information from another site on your site. For example, the joomla.org website has numerous feeds that you can incorporate on your site. You an use menus to present a single feed, a list of feeds in a category, or a list of all feed categories. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Components_Newsfeeds_Feeds\">Help</a></p>','',1,0,0,21,'2011-01-01 00:00:01',614,'Joomla!','2011-12-27 11:27:31',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',3,0,4,'','',1,4,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(61,159,'Breadcrumbs Module','breadcrumbs-module','','<p>Breadcrumbs provide a pathway for users to navigate through the site. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Breadcrumbs\" title=\"Breacrumbs Module\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule breadcrumbs,breadcrumbs}</div>','',1,0,0,75,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:10:19',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',5,0,2,'','',1,10,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(62,160,'Content','content-plugins','','<p>Content plugins run when specific kinds of pages are loaded. They do things ranging from protecting email addresses from harvesters to creating page breaks.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Email Cloaking <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Email_Cloaking\">Help</a></li>\r\n<li>Load Module <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Load_Modules\">Help</a></li>\r\n<li>Page Break <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Pagebreak\">Help</a></li>\r\n<li>Page Navigation<a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Page_Navigation\"> Help</a></li>\r\n<li>Vote <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Vote\">Help</a></li>\r\n</ul>\r\n<p>Default off:</p>\r\n<ul>\r\n<li>Code Highlighter (GeSHi) <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit#Content_-_Code_Highlighter_.28GeSHi.29\">Help</a></li>\r\n</ul>','',1,0,0,25,'2011-01-01 00:00:01',614,'Joomla!','2011-09-06 06:11:50',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',2,0,7,'','',1,1,'',0,'*','');
INSERT INTO #__content VALUES(64,162,'Blue Mountain Rain Forest','blue-mountain-rain-forest','','<p> </p>\r\n','\r\n<p> </p>',1,0,0,73,'2011-01-01 00:00:01',614,'Parks Webmaster','2012-01-17 04:36:30',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"images\\/sampledata\\/parks\\/landscape\\/120px_rainforest_bluemountainsnsw.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"Rain Forest Blue Mountains\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/landscape\\/727px_rainforest_bluemountainsnsw.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Rain Forest Blue Mountains\",\"image_fulltext_caption\":\"Source: http:\\/\\/commons.wikimedia.org\\/wiki\\/File:Rainforest,bluemountainsNSW.jpg Author: Adam J.W.C. License: GNU Free Documentation License\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',4,0,2,'','',1,3,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(65,163,'Ormiston Pound','ormiston-pound','','<p> </p>\r\n','\r\n<p> </p>',1,0,0,73,'2011-01-01 00:00:01',614,'Parks Webmaster','2012-01-17 04:51:33',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','{\"image_intro\":\"images\\/sampledata\\/parks\\/landscape\\/180px_ormiston_pound.jpg\",\"float_intro\":\"none\",\"image_intro_alt\":\"Ormiston Pound\",\"image_intro_caption\":\"\",\"image_fulltext\":\"images\\/sampledata\\/parks\\/landscape\\/800px_ormiston_pound.jpg\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"Ormiston Pound\",\"image_fulltext_caption\":\"Source: http:\\/\\/commons.wikimedia.org\\/wiki\\/File:Ormiston_Pound.JPG Author: License: GNU Free Public Documentation License\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',5,0,3,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(66,165,'Latest Users Module','latest-users-module','','<p>This module displays the latest registered users. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;keyref=Help16:Extensions_Module_Manager_Latest_Users\">Help</a></p>\r\n<div class=\"sample-module\">{loadmodule users_latest,Users Latest}</div>','',1,0,0,65,'2011-01-01 00:00:01',614,'Joomla!','2011-09-17 22:21:05',42,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"1\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',4,0,3,'','',1,6,'',0,'*','');
INSERT INTO #__content VALUES(67,168,'What\'s New in 1.5?','whats-new-in-15','','<p>This article deliberately archived as an example.</p><p>As with previous releases, Joomla! provides a unified and easy-to-use framework for delivering content for Web sites of all kinds. To support the changing nature of the Internet and emerging Web technologies, Joomla! required substantial restructuring of its core functionality and we also used this effort to simplify many challenges within the current user interface. Joomla! 1.5 has many new features.</p>\r\n<p style=\"margin-bottom: 0in;\">In Joomla! 1.5, you\'\'ll notice:</p>\r\n<ul>\r\n<li>Substantially improved usability, manageability, and scalability far beyond the original Mambo foundations</li>\r\n<li>Expanded accessibility to support internationalisation, double-byte characters and right-to-left support for Arabic, Farsi, and Hebrew languages among others</li>\r\n<li>Extended integration of external applications through Web services</li>\r\n<li>Enhanced content delivery, template and presentation capabilities to support accessibility standards and content delivery to any destination</li>\r\n<li>A more sustainable and flexible framework for Component and Extension developers</li>\r\n<li>Backward compatibility with previous releases of Components, Templates, Modules, and other Extensions</li>\r\n</ul>','',2,0,0,9,'2011-01-01 00:00:01',614,'Joomla! 1.5','2011-01-01 00:00:01',0,0,'0000-00-00 00:00:00','2011-01-01 00:00:01','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_readmore\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"page_title\":\"\",\"alternative_readmore\":\"\",\"layout\":\"\"}',1,0,0,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(68,170,'Captcha','captcha','','<p>The Captcha plugins are used to prevent spam submissions on your forms such as registration, contact and login. You basic installation of Joomla includes one Captcha plugin which leverages the ReCaptcha® service but you may install other plugins connecting to different Captcha systems.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>ReCaptcha <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit\">help</a></li>\r\n</ul>\r\n<p>Note: ReCaptcha is a the trademark of Google Inc. and is an independent product not associated with or endorsed by the Joomla Project. You will need to register and agree to the Terms of Service at Recaptcha.net to use this plugin. Complete instructions are available if you edit the ReCaptcha plugin in the Plugin Manager.</p>','',1,0,0,25,'2012-01-17 03:20:45',614,'Joomla!','2012-01-17 03:35:46',42,0,'0000-00-00 00:00:00','2012-01-17 03:20:45','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(69,171,'Quick Icons','quick-icons','','<p> The Quick Icon plugin group is used to provide notification that updates to Joomla! or installed extensions are available and should be applied. These notifications display on your administrator control panel, which is the page you see when you first log in to your site administrator.</p>\r\n<p>Default on:</p>\r\n<ul>\r\n<li>Quick icon - Joomla! extensions updates notification <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit\">Help</a>.</li>\r\n<li>Quick icon - Joomla! update notification <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help17:Extensions_Plugin_Manager_Edit\">Help</a></li>\r\n</ul>\r\n<p> </p>\r\n<hr title=\"Lorem ipsum\" alt=\"Lorem ipsum\" class=\"system-pagebreak\" /><hr title=\"Lorem ipsum\" alt=\"Lorem ipsum\" class=\"system-pagebreak\" />\r\n<p> </p>','',1,0,0,25,'2012-01-17 03:27:39',614,'Joomla!','2012-10-24 07:24:40',614,0,'0000-00-00 00:00:00','2012-01-17 03:27:39','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,0,'','',1,182,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(70,170,'Smart Search','smart-search','','<p>This module provides search using the Smart Search component. You should only use it if you have indexed your content and either have enabled the Smart Search content plugin or are keeping the index of your site updated manually. <a href=\"http://help.joomla.org/proxy/index.php?option=com_help&amp;amp;keyref=Help25:Extensions_Module_Manager_Smart_Search\">Help</a>.</p>\r\n<div class=\"sample-module\">{loadmodule finder,Smart Search}</div>','',1,0,0,67,'2012-01-17 03:42:36',614,'','2012-01-17 16:15:48',42,0,'0000-00-00 00:00:00','2012-01-17 03:42:36','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":\"\",\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":\"\",\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":\"\",\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',10,0,0,'','',1,81,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(71,178,'Typography','typography','','<p> </p>\r\n<h3 class=\"jm-typo-title\">Animated hover CSS3 effects for images</h3>\r\n<p>This code allows you to display an image and its description with animated CSS3 effect.<br /><strong>Note:</strong> If you would like to add your own text into the image description, just modify the code below or edit an existing code in the custom module of the demo template.</p>\r\n<p> </p>\r\n<p><strong>Example 1</strong></p>\r\n<div class=\"jm-code\">&lt;div class=\"dj-image-hover\"&gt; &lt;div class=\"view view-first\"&gt;&lt;a href=\"#\"&gt;&lt;img src=\"<strong>image.jpg</strong>\" /&gt;&lt;a&gt; &lt;div class=\"mask\"&gt; &lt;h2&gt;&lt;a href=\"#\"&gt;<strong>Title goes here</strong>&lt;/a&gt; &lt;/h2&gt; &lt;p&gt;<strong>Custom description goes here.</strong>&lt;/p&gt; &lt;a class=\"readmore\" href=\"#\"&gt;<strong>Read More</strong>&lt;/a&gt;&lt;/div&gt; &lt;/div&gt; &lt;/div&gt;</div>\r\n<p> </p>\r\n<div class=\"dj-image-hover\" style=\"text-align: center;\">\r\n<div class=\"view view-first\"><a href=\"#\"><img src=\"images/modules/hoverme.jpg\" border=\"0\" alt=\"Typography\" /></a>\r\n<div class=\"mask\">\r\n<h2><a href=\"#\">Title goes here</a></h2>\r\n<p>Custom description goes here</p>\r\n<a class=\"readmore\" href=\"#\">Read More</a></div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<p><strong>Example 2</strong></p>\r\n<div class=\"jm-code\">&lt;div class=\"dj-image-hover\"&gt; &lt;div class=\"view view-second\"&gt;&lt;a href=\"#\"&gt;&lt;img src=\"<strong>image.jpg</strong>\" /&gt;&lt;a&gt; &lt;div class=\"mask\"&gt; &lt;h2&gt;&lt;a href=\"#\"&gt;<strong>Title goes here</strong>&lt;/a&gt; &lt;/h2&gt; &lt;p&gt;<strong>Custom description goes here.</strong>&lt;/p&gt; &lt;a class=\"readmore\" href=\"#\"&gt;<strong>Read More</strong>&lt;/a&gt;&lt;/div&gt; &lt;/div&gt; &lt;/div&gt;</div>\r\n<p> </p>\r\n<div class=\"dj-image-hover\" style=\"text-align: center;\">\r\n<div class=\"view view-second\"><a href=\"#\"><img src=\"images/modules/hoverme.jpg\" border=\"0\" alt=\"Typography\" /></a>\r\n<div class=\"mask\">\r\n<h2><a href=\"#\">Title goes here</a></h2>\r\n<p>Custom description goes here.</p>\r\n<a class=\"readmore\" href=\"#\">Read More</a></div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<p><strong>Example 3</strong></p>\r\n<div class=\"jm-code\">&lt;div class=\"dj-image-hover\"&gt; &lt;div class=\"view view-third\"&gt;&lt;a href=\"#\"&gt;&lt;img src=\"<strong>image.jpg</strong>\" /&gt;&lt;a&gt; &lt;div class=\"mask\"&gt; &lt;h2&gt;&lt;a href=\"#\"&gt;<strong>Title goes here</strong>&lt;/a&gt; &lt;/h2&gt; &lt;p&gt;<strong>Custom description goes here.</strong>&lt;/p&gt; &lt;a class=\"readmore\" href=\"#\"&gt;<strong>Read More</strong>&lt;/a&gt;&lt;/div&gt; &lt;/div&gt; &lt;/div&gt;</div>\r\n<p> </p>\r\n<div class=\"dj-image-hover\" style=\"text-align: center;\">\r\n<div class=\"view view-third\"><a href=\"#\"><img src=\"images/modules/hoverme.jpg\" border=\"0\" alt=\"Typography\" /></a>\r\n<div class=\"mask\">\r\n<h2><a href=\"#\">Title goes here</a></h2>\r\n<p>Custom description goes here.</p>\r\n<a class=\"readmore\" href=\"#\">Read More</a></div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<h3 class=\"jm-typo-title\">Image Borders</h3>\r\n<div class=\"clearfix\">\r\n<div style=\"float: left; width: 33%;\">\r\n<div class=\"jm-code\" style=\"margin: 0 10px 20px;\">&lt;img class=\"<strong>border_img1</strong>\" src=\"<strong>image.jpg</strong>\" /&gt;</div>\r\n<div style=\"text-align: center;\"><img class=\"border_img1\" src=\"images/modules/module1.jpg\" border=\"0\" alt=\"Typography\" /></div>\r\n</div>\r\n<div style=\"float: left; width: 33%;\">\r\n<div class=\"jm-code\" style=\"margin: 0 10px 20px;\">&lt;img class=\"<strong>border_img2</strong>\" src=\"<strong>image.jpg</strong>\" /&gt;</div>\r\n<div style=\"text-align: center;\"><img class=\"border_img2\" src=\"images/modules/module1.jpg\" border=\"0\" alt=\"Typography\" /></div>\r\n</div>\r\n<div style=\"float: left; width: 33%;\">\r\n<div class=\"jm-code\" style=\"margin: 0 10px 20px;\">&lt;img class=\"<strong>border_img3</strong>\" src=\"<strong>image.jpg</strong>\" /&gt;</div>\r\n<div style=\"text-align: center;\"><img class=\"border_img3\" src=\"images/modules/module1.jpg\" border=\"0\" alt=\"Typography\" /></div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<h3 class=\"jm-typo-title\">Headings</h3>\r\n<div class=\"clearfix\">\r\n<div style=\"float: left; width: 49%;\">\r\n<div style=\"padding: 0 10px 0 0;\">\r\n<h1>This is Heading One (h1)</h1>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h2>This is Heading Two (h2)</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h3>This is Heading Three (h3)</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n</div>\r\n</div>\r\n<div style=\"float: right; width: 49%;\">\r\n<div style=\"padding: 0 0 0 10px;\">\r\n<h4>This is Heading Four (h4)</h4>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h5>This is Heading Five (h5)</h5>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n<br />\r\n<h6>This is Heading Six (h6)</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris convallis porta lacinia bibendum felis.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<h3 class=\"jm-typo-title\">Numered blocks</h3>\r\n<div class=\"clearfix\">\r\n<div style=\"float: left; width: 49%;\">\r\n<div style=\"padding: 0 10px 0 0;\">\r\n<div class=\"jm-code\">&lt;p class=\"<strong>jm-block</strong>\"&gt;&lt;span&gt;01&lt;/span&gt;<strong>Text goes here</strong>&lt;/p&gt;</div>\r\n<p class=\"jm-block\"><span>01</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class=\"jm-block\"><span>02</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class=\"jm-block\"><span>03</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n</div>\r\n</div>\r\n<div style=\"float: right; width: 49%;\">\r\n<div style=\"padding: 0 0 0 10px;\">\r\n<div class=\"jm-code\">&lt;p class=\"<strong>jm-block second</strong>\"&gt;&lt;span&gt;a&lt;/span&gt;<strong>Text goes here</strong>&lt;/p&gt;</div>\r\n<p class=\"jm-block second\"><span>a</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class=\"jm-block second\"><span>b</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n<p class=\"jm-block second\"><span>c</span>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis viverra leo sed turpis convallis sit amet condimentum diam vehicula. Morbi suscipit nisl odio, nec sodales tellus. Aenean quis sapien suscipit mauris.</p>\r\n</div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<h3 class=\"jm-typo-title\">Colored blocks</h3>\r\n<div class=\"clearfix\">\r\n<div style=\"float: left; width: 49%;\">\r\n<div style=\"padding: 0 10px 0 0;\">\r\n<p class=\"blue\">this is a paragraph with the class \"<strong>blue</strong>\"<br /> &lt;p class=\"<strong>blue</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p style=\"margin: 11px 0; height: 0;\"> </p>\r\n<p class=\"green\">this is a paragraph with the class \"<strong>green</strong>\"<br /> &lt;p class=\"<strong>green</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p style=\"margin: 11px 0; height: 0;\"> </p>\r\n<p class=\"red\">this is a paragraph with the class \"<strong>red</strong>\"<br /> &lt;p class=\"<strong>red</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n</div>\r\n</div>\r\n<div style=\"float: right; width: 49%;\">\r\n<div style=\"padding: 0 0 0 10px;\">\r\n<p class=\"bluefill\">this is a paragraph with the class \"<strong>bluefill</strong>\"<br /> &lt;p class=\"<strong>bluefill</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"greenfill\">this is a paragraph with the class \"<strong>greenfill</strong>\"<br /> &lt;p class=\"<strong>greenfill</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"redfill\">this is a paragraph with the class \"<strong>redfill</strong>\"<br /> &lt;p class=\"<strong>redfill</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n</div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<h3 class=\"jm-typo-title\">Quote blocks</h3>\r\n<div class=\"clearfix\">\r\n<div style=\"float: left; width: 49%;\">\r\n<div style=\"padding: 0 10px 0 0;\">\r\n<p class=\"quote-left\">this is a paragraph with the class \"<strong>quote-left</strong>\"<br /> &lt;p class=\"<strong>quote-left</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n</div>\r\n</div>\r\n<div style=\"float: right; width: 49%;\">\r\n<div style=\"padding: 0 0 0 10px;\">\r\n<p class=\"quote-right\">this is a paragraph with the class \"<strong>quote-right</strong>\"<br /> &lt;p class=\"<strong>quote-right</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n</div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<h3 class=\"jm-typo-title\">Icon blocks</h3>\r\n<div class=\"clearfix\">\r\n<div style=\"float: left; width: 49%;\">\r\n<div style=\"padding: 0 10px 0 0;\">\r\n<p class=\"badge\">this is a paragraph with the class \"<strong>badge</strong>\"<br /> &lt;p class=\"<strong>badge</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"calendar\">this is a paragraph with the class \"<strong>calendar</strong>\"<br /> &lt;p class=\"<strong>calendar</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"chat\">this is a paragraph with the class \"<strong>chat</strong>\"<br /> &lt;p class=\"<strong>chat</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"check\">this is a paragraph with the class \"<strong>check</strong>\"<br /> &lt;p class=\"<strong>check</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"cloud\">this is a paragraph with the class \"<strong>cloud</strong>\"<br /> &lt;p class=\"<strong>cloud</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"direction\">this is a paragraph with the class \"<strong>direction</strong>\"<br /> &lt;p class=\"<strong>direction</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"divide\">this is a paragraph with the class \"<strong>divide</strong>\"<br /> &lt;p class=\"<strong>divide</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"error\">this is a paragraph with the class \"<strong>error</strong>\"<br /> &lt;p class=\"<strong>error</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"fire\">this is a paragraph with the class \"<strong>fire</strong>\"<br /> &lt;p class=\"<strong>fire</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n</div>\r\n</div>\r\n<div style=\"float: right; width: 49%;\">\r\n<div style=\"padding: 0 0 0 10px;\">\r\n<p class=\"flag\">this is a paragraph with the class \"<strong>flag</strong>\"<br /> &lt;p class=\"<strong>flag</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"heart\">this is a paragraph with the class \"<strong>heart</strong>\"<br /> &lt;p class=\"<strong>heart</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"home\">this is a paragraph with the class \"<strong>home</strong>\"<br /> &lt;p class=\"<strong>home</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"info\">this is a paragraph with the class \"<strong>info</strong>\"<br /> &lt;p class=\"<strong>info</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"list\">this is a paragraph with the class \"<strong>list</strong>\"<br /> &lt;p class=\"<strong>list</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"mail\">this is a paragraph with the class \"<strong>mail</strong>\"<br /> &lt;p class=\"<strong>mail</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"people\">this is a paragraph with the class \"<strong>people</strong>\"<br /> &lt;p class=\"<strong>people</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"star\">this is a paragraph with the class \"<strong>star</strong>\"<br /> &lt;p class=\"<strong>star</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n<p class=\"stat\">this is a paragraph with the class \"<strong>stat</strong>\"<br /> &lt;p class=\"<strong>stat</strong>\" &gt; Text goes here&lt;/p&gt;</p>\r\n</div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<h3 class=\"jm-typo-title\">Unordered lists</h3>\r\n<div class=\"clearfix\">\r\n<div style=\"float: left; width: 33%;\">\r\n<div style=\"padding: 0 10px 0 0;\">\r\n<div class=\"jm-code\" style=\"margin: 0 10px 20px;\"><br />Default list</div>\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div style=\"float: left; width: 33%;\">\r\n<div style=\"padding: 0 5px;\">\r\n<div class=\"jm-code\" style=\"margin: 0 10px 20px;\">This is a list with the class \"<strong>jm-light</strong>\"<br />Enter the class name to ul tag &lt;ul class=\"<strong>light</strong>\"&gt;</div>\r\n<ul class=\"jm-light\">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div style=\"float: left; width: 33%;\">\r\n<div style=\"padding: 0 0 0 15px;\">\r\n<div class=\"jm-code\" style=\"margin: 0 10px 20px;\">This is a list with the class \"<strong>jm-gray</strong>\"<br />Enter the class name to ul tag &lt;ul class=\"<strong>jm-gray</strong>\"&gt;</div>\r\n<ul class=\"jm-gray\">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum\r\n<ul>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<h3 class=\"jm-typo-title\">Ordered lists</h3>\r\n<div class=\"clearfix\">\r\n<div style=\"float: left; width: 33%;\">\r\n<div style=\"padding: 0 10px 0 0;\">\r\n<div class=\"jm-code\" style=\"margin: 0 10px 20px;\"><br />Default list</div>\r\n<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ol></li>\r\n</ol></li>\r\n</ol></div>\r\n</div>\r\n<div style=\"float: left; width: 33%;\">\r\n<div style=\"padding: 0 5px;\">\r\n<div class=\"jm-code\" style=\"margin: 0 10px 20px;\">This is a list with the class \"<strong>jm-roman</strong>\"<br />Enter the class name to ol tag &lt;ol class=\"<strong>jm-roman</strong>\"&gt;</div>\r\n<ol class=\"jm-roman\">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ol></li>\r\n</ol></li>\r\n</ol></div>\r\n</div>\r\n<div style=\"float: left; width: 33%;\">\r\n<div style=\"padding: 0 0 0 15px;\">\r\n<div class=\"jm-code\" style=\"margin: 0 10px 20px;\">This is a list with the class \"<strong>jm-alpha</strong>\"<br />Enter the class name to ol tag &lt;ol class=\"<strong>jm-alpha</strong>\"&gt;</div>\r\n<ol class=\"jm-alpha\">\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum<ol>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n<li>Duis tincidunt nunc sit amet ipsum</li>\r\n</ol></li>\r\n</ol></li>\r\n</ol></div>\r\n</div>\r\n</div>\r\n<p> </p>\r\n<h3 class=\"jm-typo-title\">Social icons with CSS3 effect</h3>\r\n<div class=\"jm-code\">&lt;p class=\"jm-icons\"&gt;&lt;a href=\"index.php\" style=\"display: inline-block;\"&gt;&lt;span class=\"jm-facebook\" style=\"margin: 0 10px 0 0;\"&gt;&amp;nbsp;&lt;/span&gt;&lt;/a&gt;&lt;a href=\"index.php\" style=\"display: inline-block;\"&gt;&lt;span class=\"jm-twitter\" style=\"margin: 0 10px;\"&gt;&amp;nbsp;&lt;/span&gt;&lt;/a&gt;&lt;a href=\"index.php\" style=\"display: inline-block;\"&gt;&lt;span class=\"jm-google\" style=\"margin: 0 10px;\"&gt;&amp;nbsp;&lt;/span&gt;&lt;/a&gt;&lt;/p&gt;</div>\r\n<p> </p>\r\n<p class=\"jm-icons\" style=\"background: #fff; text-align: center; padding: 10px 0;\"><a href=\"index.php\" style=\"display: inline-block;\"><span class=\"jm-facebook\" style=\"margin: 3px;\"> </span></a><a href=\"index.php\" style=\"display: inline-block;\"><span class=\"jm-twitter\" style=\"margin: 3px;\"> </span></a><a href=\"index.php\" style=\"display: inline-block;\"><span class=\"jm-google\" style=\"margin: 3px;\"> </span></a><a href=\"index.php\" style=\"display: inline-block;\"><span class=\"jm-pinterest\" style=\"margin: 3px;\"> </span></a><a href=\"index.php\" style=\"display: inline-block;\"><span class=\"jm-rss\" style=\"margin: 3px;\"> </span></a></p>\r\n<p> </p>\r\n<h3 class=\"jm-typo-title\">Read More Button</h3>\r\n<div class=\"jm-code\">This is a read more link with the class \"readmore\"<br />Enter the class name to a tag &lt;a class=\"readmore\" /&gt;</div>\r\n<p style=\"display: inline-block; width: 100%; margin: 10px 0 0;\"><a class=\"readmore\" href=\"#\">Read more</a></p>','',1,0,0,14,'2012-10-30 21:20:16',614,'','2012-11-13 10:49:05',614,0,'0000-00-00 00:00:00','2012-10-30 21:20:16','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_vote\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',5,0,1,'','',1,101,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');
INSERT INTO #__content VALUES(72,181,'Promotions','promotions','','<p><img src=\"images/modules/promotions.jpg\" border=\"0\" alt=\"Promotions\" style=\"display: block; margin-left: auto; margin-right: auto;\" /></p>','',1,0,0,14,'2012-11-13 13:09:51',614,'','2012-11-13 13:09:59',614,0,'0000-00-00 00:00:00','2012-11-13 13:09:51','0000-00-00 00:00:00','{\"image_intro\":\"\",\"float_intro\":\"\",\"image_intro_alt\":\"\",\"image_intro_caption\":\"\",\"image_fulltext\":\"\",\"float_fulltext\":\"\",\"image_fulltext_alt\":\"\",\"image_fulltext_caption\":\"\"}','{\"urla\":null,\"urlatext\":\"\",\"targeta\":\"\",\"urlb\":null,\"urlbtext\":\"\",\"targetb\":\"\",\"urlc\":null,\"urlctext\":\"\",\"targetc\":\"\"}','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"urls_position\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\",\"show_publishing_options\":\"\",\"show_article_options\":\"\",\"show_urls_images_backend\":\"\",\"show_urls_images_frontend\":\"\"}',2,0,0,'','',1,5,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');



DROP TABLE IF EXISTS #__content_frontpage;

CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) DEFAULT CHARSET=utf8;

INSERT INTO #__content_frontpage VALUES(8,2);
INSERT INTO #__content_frontpage VALUES(35,4);
INSERT INTO #__content_frontpage VALUES(24,1);
INSERT INTO #__content_frontpage VALUES(50,3);



DROP TABLE IF EXISTS #__content_rating;

CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__core_log_searches;

CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__djc2_categories;

CREATE TABLE `#__djc2_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text,
  `parent_id` int(11) NOT NULL,
  `metakey` text,
  `metadesc` text,
  `published` int(11) NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL,
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

INSERT INTO #__djc2_categories VALUES(1,'Homes','homes','<p>Lorem ipsum dolor sit.</p>',0,'','',1,1,0,'0000-00-00 00:00:00','2012-11-07 14:04:36',614);
INSERT INTO #__djc2_categories VALUES(2,'Apartments','apartments','<p>Lorem ipsum dolor sit.</p>',0,'','',1,2,0,'0000-00-00 00:00:00','2012-11-07 14:04:59',614);
INSERT INTO #__djc2_categories VALUES(3,'Other','other','<p>Lorem ipsum dolor sit.</p>',0,'','',1,3,0,'0000-00-00 00:00:00','2012-11-08 14:51:19',614);



DROP TABLE IF EXISTS #__djc2_files;

CREATE TABLE `#__djc2_files` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) NOT NULL,
  `type` varchar(64) NOT NULL,
  `fullname` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `ext` varchar(255) NOT NULL,
  `caption` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `hits` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__djc2_images;

CREATE TABLE `#__djc2_images` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) NOT NULL,
  `type` varchar(64) NOT NULL,
  `fullname` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `ext` varchar(255) NOT NULL,
  `caption` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;

INSERT INTO #__djc2_images VALUES(11,4,'item','5.1.jpg','5.1','jpg','Victoria Gardens Penthouse',1);
INSERT INTO #__djc2_images VALUES(9,1,'item','8.jpg','8','jpg','The Secret Garden',3);
INSERT INTO #__djc2_images VALUES(10,3,'item','2.jpg','2','jpg','Luxury Lakeside Living',1);
INSERT INTO #__djc2_images VALUES(6,1,'producer','producer.jpg','producer','jpg','Real Estate',1);
INSERT INTO #__djc2_images VALUES(7,1,'item','1.jpg','1','jpg','The Secret Garden',1);
INSERT INTO #__djc2_images VALUES(8,1,'item','5.jpg','5','jpg','The Secret Garden',2);
INSERT INTO #__djc2_images VALUES(14,7,'item','9.jpg','9','jpg','Garage for Rent',1);
INSERT INTO #__djc2_images VALUES(12,5,'item','4.jpg','4','jpg','Light and Sunny Apartment',1);
INSERT INTO #__djc2_images VALUES(13,6,'item','8.1.jpg','8.1','jpg','Bedroom Furnishes',1);



DROP TABLE IF EXISTS #__djc2_items;

CREATE TABLE `#__djc2_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cat_id` int(11) NOT NULL DEFAULT '0',
  `producer_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text,
  `intro_desc` text,
  `price` decimal(12,2) DEFAULT NULL,
  `metakey` text,
  `metadesc` text,
  `published` int(11) NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `featured` int(11) NOT NULL DEFAULT '0',
  `params` text,
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;

INSERT INTO #__djc2_items VALUES(1,1,1,'The Secret Garden','the-secret-garden','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. <br /><br />Vestibulum tincidunt sapien tortor, in elementum mi. Aliquam erat volutpat. Aliquam fringilla commodo scelerisque. Quisque lacinia ligula ut ipsum placerat ultricies.<br /><br /> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.</p>\r\n<hr title=\"Tab 1\" alt=\"Car Details\" class=\"system-pagebreak\" />\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bedrooms:</span> 4</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bathrooms:</span> 2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Floor Area:</span> 200m2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Internal Features:</span> Furnished Kitchen, Air Conditioning, Garage</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">External Features:</span> Patio, Garden</div>\r\n<hr title=\"Tab 2\" alt=\"Features\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px;\">\r\n<p><span style=\"font-weight: bold;\">Beautiful Garden!</span></p>\r\n<p>Praesent vitae risus ut mauris mollis hendrerit eget sit amet metus. Nunc auctor magna at eros accumsan suscipit. Aenean velit ligula, venenatis id tristique in, aliquam quis lectus. Phasellus dignissim malesuada pellentesque.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">Make an Appointment!</span></p>\r\n<p>Nunc vitae felis sed elit interdum interdum et ut libero. Etiam a turpis urna, ut viverra justo. Nulla tincidunt sodales nisi et bibendum. Etiam ut ultrices neque. Nulla non turpis vitae felis ultrices sollicitudin eu tempor tellus.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">100% Quality Guarantee!</span></p>\r\n<p>Suspendisse pellentesque sodales erat ut interdum. Maecenas neque dolor, malesuada non aliquam in, pellentesque eu arcu. Sed leo ante, convallis et sagittis in, congue sit amet dui. Maecenas volutpat accumsan dui, ac rhoncus.</p>\r\n</div>\r\n<hr title=\"Tab 3\" alt=\"Reviews\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca; margin-bottom: 15px;\">\r\n<p><span style=\"font-weight: bold;\">Dolores Sit!</span></p>\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">John Carew, 34</span></div>\r\n</div>\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca;\">\r\n<p><span style=\"font-weight: bold;\">Lorem Ipsum!</span></p>\r\nSed nec mi ac est adipiscing rutrum nec ac dolor. Mauris odio augue, faucibus ac varius vel, commodo vel diam. Duis ac magna et elit fringilla convallis. Suspendisse hendrerit, augue ac tincidunt dictum, diam nunc tristique elit, tempor fringilla mauris quam sit amet odio. Ut at euismod lorem.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">Miranda Cardozzo, 52</span></div>\r\n</div>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin hendrerit vehicula odio, non porta lacus facilisis sit amet. Donec faucibus purus ante, nec imperdiet lorem.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam ut ipsum nec nunc.</p>','2000.00','','',1,1,1,'',0,'0000-00-00 00:00:00','2012-11-07 14:05:55',614);
INSERT INTO #__djc2_items VALUES(7,3,1,'Garage for Rent','garage-for-rent','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. <br /><br />Vestibulum tincidunt sapien tortor, in elementum mi. Aliquam erat volutpat. Aliquam fringilla commodo scelerisque. Quisque lacinia ligula ut ipsum placerat ultricies.<br /><br /> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.</p>\r\n<hr title=\"Tab 1\" alt=\"Car Details\" class=\"system-pagebreak\" />\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bedrooms:</span> 4</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bathrooms:</span> 2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Floor Area:</span> 200m2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Internal Features:</span> Furnished Kitchen, Air Conditioning, Garage</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">External Features:</span> Patio, Garden</div>\r\n<hr title=\"Tab 2\" alt=\"Features\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px;\">\r\n<p><span style=\"font-weight: bold;\">Beautiful Garden!</span></p>\r\n<p>Praesent vitae risus ut mauris mollis hendrerit eget sit amet metus. Nunc auctor magna at eros accumsan suscipit. Aenean velit ligula, venenatis id tristique in, aliquam quis lectus. Phasellus dignissim malesuada pellentesque.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">Make an Appointment!</span></p>\r\n<p>Nunc vitae felis sed elit interdum interdum et ut libero. Etiam a turpis urna, ut viverra justo. Nulla tincidunt sodales nisi et bibendum. Etiam ut ultrices neque. Nulla non turpis vitae felis ultrices sollicitudin eu tempor tellus.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">100% Quality Guarantee!</span></p>\r\n<p>Suspendisse pellentesque sodales erat ut interdum. Maecenas neque dolor, malesuada non aliquam in, pellentesque eu arcu. Sed leo ante, convallis et sagittis in, congue sit amet dui. Maecenas volutpat accumsan dui, ac rhoncus.</p>\r\n</div>\r\n<hr title=\"Tab 3\" alt=\"Reviews\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca; margin-bottom: 15px;\">\r\n<p><span style=\"font-weight: bold;\">Dolores Sit!</span></p>\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">John Carew, 34</span></div>\r\n</div>\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca;\">\r\n<p><span style=\"font-weight: bold;\">Lorem Ipsum!</span></p>\r\nSed nec mi ac est adipiscing rutrum nec ac dolor. Mauris odio augue, faucibus ac varius vel, commodo vel diam. Duis ac magna et elit fringilla convallis. Suspendisse hendrerit, augue ac tincidunt dictum, diam nunc tristique elit, tempor fringilla mauris quam sit amet odio. Ut at euismod lorem.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">Miranda Cardozzo, 52</span></div>\r\n</div>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin hendrerit vehicula odio, non porta lacus facilisis sit amet. Donec faucibus purus ante, nec imperdiet lorem.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam ut ipsum nec nunc.</p>','500.00','','',1,2,0,'',0,'0000-00-00 00:00:00','2012-11-07 14:05:55',614);
INSERT INTO #__djc2_items VALUES(3,1,1,'Luxury Lakeside Living','luxury-lakeside-living','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. <br /><br />Vestibulum tincidunt sapien tortor, in elementum mi. Aliquam erat volutpat. Aliquam fringilla commodo scelerisque. Quisque lacinia ligula ut ipsum placerat ultricies.<br /><br /> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.</p>\r\n<hr title=\"Tab 1\" alt=\"Car Details\" class=\"system-pagebreak\" />\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bedrooms:</span> 4</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bathrooms:</span> 2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Floor Area:</span> 200m2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Internal Features:</span> Furnished Kitchen, Air Conditioning, Garage</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">External Features:</span> Patio, Garden</div>\r\n<hr title=\"Tab 2\" alt=\"Features\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px;\">\r\n<p><span style=\"font-weight: bold;\">Beautiful Garden!</span></p>\r\n<p>Praesent vitae risus ut mauris mollis hendrerit eget sit amet metus. Nunc auctor magna at eros accumsan suscipit. Aenean velit ligula, venenatis id tristique in, aliquam quis lectus. Phasellus dignissim malesuada pellentesque.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">Make an Appointment!</span></p>\r\n<p>Nunc vitae felis sed elit interdum interdum et ut libero. Etiam a turpis urna, ut viverra justo. Nulla tincidunt sodales nisi et bibendum. Etiam ut ultrices neque. Nulla non turpis vitae felis ultrices sollicitudin eu tempor tellus.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">100% Quality Guarantee!</span></p>\r\n<p>Suspendisse pellentesque sodales erat ut interdum. Maecenas neque dolor, malesuada non aliquam in, pellentesque eu arcu. Sed leo ante, convallis et sagittis in, congue sit amet dui. Maecenas volutpat accumsan dui, ac rhoncus.</p>\r\n</div>\r\n<hr title=\"Tab 3\" alt=\"Reviews\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca; margin-bottom: 15px;\">\r\n<p><span style=\"font-weight: bold;\">Dolores Sit!</span></p>\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">John Carew, 34</span></div>\r\n</div>\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca;\">\r\n<p><span style=\"font-weight: bold;\">Lorem Ipsum!</span></p>\r\nSed nec mi ac est adipiscing rutrum nec ac dolor. Mauris odio augue, faucibus ac varius vel, commodo vel diam. Duis ac magna et elit fringilla convallis. Suspendisse hendrerit, augue ac tincidunt dictum, diam nunc tristique elit, tempor fringilla mauris quam sit amet odio. Ut at euismod lorem.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">Miranda Cardozzo, 52</span></div>\r\n</div>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin hendrerit vehicula odio, non porta lacus facilisis sit amet. Donec faucibus purus ante, nec imperdiet lorem.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam ut ipsum nec nunc.</p>','560000.00','','',1,2,0,'',0,'0000-00-00 00:00:00','2012-11-07 14:05:55',614);
INSERT INTO #__djc2_items VALUES(4,2,1,'Victoria Gardens Penthouse','victoria-gardens-penthouse','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. <br /><br />Vestibulum tincidunt sapien tortor, in elementum mi. Aliquam erat volutpat. Aliquam fringilla commodo scelerisque. Quisque lacinia ligula ut ipsum placerat ultricies.<br /><br /> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.</p>\r\n<hr title=\"Tab 1\" alt=\"Car Details\" class=\"system-pagebreak\" />\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bedrooms:</span> 4</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bathrooms:</span> 2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Floor Area:</span> 200m2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Internal Features:</span> Furnished Kitchen, Air Conditioning, Garage</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">External Features:</span> Patio, Garden</div>\r\n<hr title=\"Tab 2\" alt=\"Features\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px;\">\r\n<p><span style=\"font-weight: bold;\">Beautiful Garden!</span></p>\r\n<p>Praesent vitae risus ut mauris mollis hendrerit eget sit amet metus. Nunc auctor magna at eros accumsan suscipit. Aenean velit ligula, venenatis id tristique in, aliquam quis lectus. Phasellus dignissim malesuada pellentesque.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">Make an Appointment!</span></p>\r\n<p>Nunc vitae felis sed elit interdum interdum et ut libero. Etiam a turpis urna, ut viverra justo. Nulla tincidunt sodales nisi et bibendum. Etiam ut ultrices neque. Nulla non turpis vitae felis ultrices sollicitudin eu tempor tellus.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">100% Quality Guarantee!</span></p>\r\n<p>Suspendisse pellentesque sodales erat ut interdum. Maecenas neque dolor, malesuada non aliquam in, pellentesque eu arcu. Sed leo ante, convallis et sagittis in, congue sit amet dui. Maecenas volutpat accumsan dui, ac rhoncus.</p>\r\n</div>\r\n<hr title=\"Tab 3\" alt=\"Reviews\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca; margin-bottom: 15px;\">\r\n<p><span style=\"font-weight: bold;\">Dolores Sit!</span></p>\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">John Carew, 34</span></div>\r\n</div>\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca;\">\r\n<p><span style=\"font-weight: bold;\">Lorem Ipsum!</span></p>\r\nSed nec mi ac est adipiscing rutrum nec ac dolor. Mauris odio augue, faucibus ac varius vel, commodo vel diam. Duis ac magna et elit fringilla convallis. Suspendisse hendrerit, augue ac tincidunt dictum, diam nunc tristique elit, tempor fringilla mauris quam sit amet odio. Ut at euismod lorem.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">Miranda Cardozzo, 52</span></div>\r\n</div>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin hendrerit vehicula odio, non porta lacus facilisis sit amet. Donec faucibus purus ante, nec imperdiet lorem.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam ut ipsum nec nunc.</p>','720000.00','','',1,2,0,'',0,'0000-00-00 00:00:00','2012-11-07 14:05:55',614);
INSERT INTO #__djc2_items VALUES(5,2,1,'Light and Sunny Apartment','light-and-sunny-apartment','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. <br /><br />Vestibulum tincidunt sapien tortor, in elementum mi. Aliquam erat volutpat. Aliquam fringilla commodo scelerisque. Quisque lacinia ligula ut ipsum placerat ultricies.<br /><br /> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.</p>\r\n<hr title=\"Tab 1\" alt=\"Car Details\" class=\"system-pagebreak\" />\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bedrooms:</span> 4</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bathrooms:</span> 2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Floor Area:</span> 200m2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Internal Features:</span> Furnished Kitchen, Air Conditioning, Garage</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">External Features:</span> Patio, Garden</div>\r\n<hr title=\"Tab 2\" alt=\"Features\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px;\">\r\n<p><span style=\"font-weight: bold;\">Beautiful Garden!</span></p>\r\n<p>Praesent vitae risus ut mauris mollis hendrerit eget sit amet metus. Nunc auctor magna at eros accumsan suscipit. Aenean velit ligula, venenatis id tristique in, aliquam quis lectus. Phasellus dignissim malesuada pellentesque.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">Make an Appointment!</span></p>\r\n<p>Nunc vitae felis sed elit interdum interdum et ut libero. Etiam a turpis urna, ut viverra justo. Nulla tincidunt sodales nisi et bibendum. Etiam ut ultrices neque. Nulla non turpis vitae felis ultrices sollicitudin eu tempor tellus.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">100% Quality Guarantee!</span></p>\r\n<p>Suspendisse pellentesque sodales erat ut interdum. Maecenas neque dolor, malesuada non aliquam in, pellentesque eu arcu. Sed leo ante, convallis et sagittis in, congue sit amet dui. Maecenas volutpat accumsan dui, ac rhoncus.</p>\r\n</div>\r\n<hr title=\"Tab 3\" alt=\"Reviews\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca; margin-bottom: 15px;\">\r\n<p><span style=\"font-weight: bold;\">Dolores Sit!</span></p>\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">John Carew, 34</span></div>\r\n</div>\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca;\">\r\n<p><span style=\"font-weight: bold;\">Lorem Ipsum!</span></p>\r\nSed nec mi ac est adipiscing rutrum nec ac dolor. Mauris odio augue, faucibus ac varius vel, commodo vel diam. Duis ac magna et elit fringilla convallis. Suspendisse hendrerit, augue ac tincidunt dictum, diam nunc tristique elit, tempor fringilla mauris quam sit amet odio. Ut at euismod lorem.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">Miranda Cardozzo, 52</span></div>\r\n</div>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin hendrerit vehicula odio, non porta lacus facilisis sit amet. Donec faucibus purus ante, nec imperdiet lorem.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam ut ipsum nec nunc.</p>','450000.00','','',1,3,1,'',0,'0000-00-00 00:00:00','2012-11-07 14:05:55',614);
INSERT INTO #__djc2_items VALUES(6,3,1,'Bedroom Furnishes','bedroom-furnishes','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. <br /><br />Vestibulum tincidunt sapien tortor, in elementum mi. Aliquam erat volutpat. Aliquam fringilla commodo scelerisque. Quisque lacinia ligula ut ipsum placerat ultricies.<br /><br /> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.</p>\r\n<hr title=\"Tab 1\" alt=\"Car Details\" class=\"system-pagebreak\" />\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bedrooms:</span> 4</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Bathrooms:</span> 2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Floor Area:</span> 200m2</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">Internal Features:</span> Furnished Kitchen, Air Conditioning, Garage</div>\r\n<div style=\"line-height: 40px; border-bottom: 1px solid #cacaca; padding: 0 15px;\"><span style=\"font-weight: bold; display: inline-block; width: 150px;\">External Features:</span> Patio, Garden</div>\r\n<hr title=\"Tab 2\" alt=\"Features\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px;\">\r\n<p><span style=\"font-weight: bold;\">Beautiful Garden!</span></p>\r\n<p>Praesent vitae risus ut mauris mollis hendrerit eget sit amet metus. Nunc auctor magna at eros accumsan suscipit. Aenean velit ligula, venenatis id tristique in, aliquam quis lectus. Phasellus dignissim malesuada pellentesque.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">Make an Appointment!</span></p>\r\n<p>Nunc vitae felis sed elit interdum interdum et ut libero. Etiam a turpis urna, ut viverra justo. Nulla tincidunt sodales nisi et bibendum. Etiam ut ultrices neque. Nulla non turpis vitae felis ultrices sollicitudin eu tempor tellus.</p>\r\n<p> </p>\r\n<p><span style=\"font-weight: bold;\">100% Quality Guarantee!</span></p>\r\n<p>Suspendisse pellentesque sodales erat ut interdum. Maecenas neque dolor, malesuada non aliquam in, pellentesque eu arcu. Sed leo ante, convallis et sagittis in, congue sit amet dui. Maecenas volutpat accumsan dui, ac rhoncus.</p>\r\n</div>\r\n<hr title=\"Tab 3\" alt=\"Reviews\" class=\"system-pagebreak\" />\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca; margin-bottom: 15px;\">\r\n<p><span style=\"font-weight: bold;\">Dolores Sit!</span></p>\r\nLorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam eget purus ut nunc volutpat lobortis. Morbi eget felis lorem, nec lobortis velit.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">John Carew, 34</span></div>\r\n</div>\r\n<div style=\"padding: 0 15px 15px; border-bottom: 1px solid #cacaca;\">\r\n<p><span style=\"font-weight: bold;\">Lorem Ipsum!</span></p>\r\nSed nec mi ac est adipiscing rutrum nec ac dolor. Mauris odio augue, faucibus ac varius vel, commodo vel diam. Duis ac magna et elit fringilla convallis. Suspendisse hendrerit, augue ac tincidunt dictum, diam nunc tristique elit, tempor fringilla mauris quam sit amet odio. Ut at euismod lorem.<br />\r\n<div style=\"text-align: right;\"><span style=\"font-weight: bold;\">Miranda Cardozzo, 52</span></div>\r\n</div>','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin hendrerit vehicula odio, non porta lacus facilisis sit amet. Donec faucibus purus ante, nec imperdiet lorem.</p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam ut ipsum nec nunc.</p>','300.00','','',1,1,0,'',0,'0000-00-00 00:00:00','2012-11-07 14:05:55',614);



DROP TABLE IF EXISTS #__djc2_items_categories;

CREATE TABLE `#__djc2_items_categories` (
  `item_id` int(11) NOT NULL,
  `category_id` int(11) NOT NULL
) DEFAULT CHARSET=utf8;

INSERT INTO #__djc2_items_categories VALUES(3,1);
INSERT INTO #__djc2_items_categories VALUES(1,1);
INSERT INTO #__djc2_items_categories VALUES(7,3);
INSERT INTO #__djc2_items_categories VALUES(4,2);
INSERT INTO #__djc2_items_categories VALUES(5,2);
INSERT INTO #__djc2_items_categories VALUES(6,3);



DROP TABLE IF EXISTS #__djc2_items_related;

CREATE TABLE `#__djc2_items_related` (
  `item_id` int(11) NOT NULL,
  `related_item` int(11) NOT NULL
) DEFAULT CHARSET=utf8;

INSERT INTO #__djc2_items_related VALUES(1,3);
INSERT INTO #__djc2_items_related VALUES(1,4);



DROP TABLE IF EXISTS #__djc2_producers;

CREATE TABLE `#__djc2_producers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text,
  `metakey` text,
  `metadesc` text,
  `published` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL,
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO #__djc2_producers VALUES(1,'Real Estate Company','real-estate-company','<p>Lorem ipsum dolor sit.</p>','','',1,1,0,'0000-00-00 00:00:00','2012-11-07 14:05:21',614);



DROP TABLE IF EXISTS #__djcf_categories;

CREATE TABLE `#__djcf_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL,
  `parent_id` int(11) NOT NULL,
  `price` int(11) NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `icon_url` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `published` int(11) NOT NULL DEFAULT '1',
  `autopublish` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

INSERT INTO #__djcf_categories VALUES(1,'Homes',0,0,'Lorem ipsum dolor sit amet dolor, consectetur adipiscing elit cras nisi.','',1,1,0,'','');
INSERT INTO #__djcf_categories VALUES(2,'For Sale',1,0,'Lorem ipsum dolor sit amet dolor, consectetur adipiscing elit cras nisi.','',2,1,0,'','');
INSERT INTO #__djcf_categories VALUES(3,'Apartments',0,0,'Lorem ipsum dolor sit amet dolor, consectetur adipiscing elit cras nisi.','',3,1,0,'','');
INSERT INTO #__djcf_categories VALUES(4,'For Rent',1,0,'Lorem ipsum dolor sit amet dolor, consectetur adipiscing elit cras nisi.','',1,1,0,'','');
INSERT INTO #__djcf_categories VALUES(5,'Other',0,0,'Lorem ipsum dolor sit amet dolor, consectetur adipiscing elit cras nisi.','',4,1,0,'','');



DROP TABLE IF EXISTS #__djcf_days;

CREATE TABLE `#__djcf_days` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `days` int(11) NOT NULL,
  `price` float(12,2) NOT NULL,
  `points` int(11) NOT NULL,
  `published` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

INSERT INTO #__djcf_days VALUES(1,7,'0.00',0,1);
INSERT INTO #__djcf_days VALUES(2,14,'1.00',0,1);
INSERT INTO #__djcf_days VALUES(3,21,'2.00',0,1);
INSERT INTO #__djcf_days VALUES(4,30,'3.00',0,1);



DROP TABLE IF EXISTS #__djcf_favourites;

CREATE TABLE `#__djcf_favourites` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__djcf_fields;

CREATE TABLE `#__djcf_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `label` varchar(255) NOT NULL,
  `type` varchar(255) NOT NULL,
  `values` text NOT NULL,
  `default_value` varchar(255) NOT NULL,
  `params` text NOT NULL,
  `in_search` int(11) NOT NULL DEFAULT '0',
  `search_type` varchar(255) NOT NULL,
  `search_value1` text NOT NULL,
  `search_value2` text NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  `required` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;

INSERT INTO #__djcf_fields VALUES(1,'bathrooms','Bathrooms:','selectlist','1;2;3+','','',1,'select','1;2;3+','',1,0);
INSERT INTO #__djcf_fields VALUES(3,'floor_area','Floor Area:','inputbox','value1;value2;value3;value4','','',1,'inputbox_min_max','value1;value2;value3;value4','',1,0);
INSERT INTO #__djcf_fields VALUES(4,'internal_features','Internal Features:','textarea','value1;value2;value3;value4','','',0,'radio','value1;value2;value3;value4','',1,0);
INSERT INTO #__djcf_fields VALUES(5,'bedrooms','Bedrooms:','inputbox','value1;value2;value3;value4','','',1,'inputbox_min_max','value1;value2;value3;value4','',1,0);
INSERT INTO #__djcf_fields VALUES(6,'external_features','External features:','textarea','','','',0,'','value1;value2;value3;value4','value1;value2;value3;value4',1,1);
INSERT INTO #__djcf_fields VALUES(8,'additional_features','Additional Features:','textarea','','','',0,'','','',1,0);



DROP TABLE IF EXISTS #__djcf_fields_values;

CREATE TABLE `#__djcf_fields_values` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `field_id` int(11) NOT NULL,
  `item_id` int(11) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=153 DEFAULT CHARSET=utf8;

INSERT INTO #__djcf_fields_values VALUES(124,5,1,'4');
INSERT INTO #__djcf_fields_values VALUES(90,4,2,'Furnished, Air Conditioning, Garage, Pool');
INSERT INTO #__djcf_fields_values VALUES(89,3,2,'260m2');
INSERT INTO #__djcf_fields_values VALUES(88,1,2,'3+');
INSERT INTO #__djcf_fields_values VALUES(151,6,3,'Garage');
INSERT INTO #__djcf_fields_values VALUES(150,5,3,'3');
INSERT INTO #__djcf_fields_values VALUES(146,6,4,'');
INSERT INTO #__djcf_fields_values VALUES(136,8,6,'Modern Beds, Wardrobe, Spacious Furnishes');
INSERT INTO #__djcf_fields_values VALUES(91,5,2,'5');
INSERT INTO #__djcf_fields_values VALUES(123,4,1,'Furnished Kitchen, Air Conditioning, Garage');
INSERT INTO #__djcf_fields_values VALUES(121,1,1,'2');
INSERT INTO #__djcf_fields_values VALUES(122,3,1,'200m2');
INSERT INTO #__djcf_fields_values VALUES(152,8,5,'Place for 2 Cars, Heating, Good Localization');
INSERT INTO #__djcf_fields_values VALUES(145,5,4,'6');
INSERT INTO #__djcf_fields_values VALUES(142,1,4,'2');
INSERT INTO #__djcf_fields_values VALUES(143,3,4,'320m2');
INSERT INTO #__djcf_fields_values VALUES(144,4,4,'Air Conditioning, Furnished Bathrooms, Home Cinema');
INSERT INTO #__djcf_fields_values VALUES(149,4,3,'Air Conditioning, Fridge');
INSERT INTO #__djcf_fields_values VALUES(147,1,3,'2');
INSERT INTO #__djcf_fields_values VALUES(148,3,3,'120m2');
INSERT INTO #__djcf_fields_values VALUES(92,6,2,'Beautiful Garden');
INSERT INTO #__djcf_fields_values VALUES(125,6,1,'Patio, Garden');



DROP TABLE IF EXISTS #__djcf_fields_xref;

CREATE TABLE `#__djcf_fields_xref` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cat_id` int(11) NOT NULL,
  `field_id` int(11) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=41 DEFAULT CHARSET=utf8;

INSERT INTO #__djcf_fields_xref VALUES(26,1,3,12);
INSERT INTO #__djcf_fields_xref VALUES(25,1,1,11);
INSERT INTO #__djcf_fields_xref VALUES(16,2,3,6);
INSERT INTO #__djcf_fields_xref VALUES(15,2,4,7);
INSERT INTO #__djcf_fields_xref VALUES(31,3,6,7);
INSERT INTO #__djcf_fields_xref VALUES(30,3,5,3);
INSERT INTO #__djcf_fields_xref VALUES(27,1,4,13);
INSERT INTO #__djcf_fields_xref VALUES(24,4,6,11);
INSERT INTO #__djcf_fields_xref VALUES(23,4,5,7);
INSERT INTO #__djcf_fields_xref VALUES(22,4,4,10);
INSERT INTO #__djcf_fields_xref VALUES(21,4,3,9);
INSERT INTO #__djcf_fields_xref VALUES(20,4,1,8);
INSERT INTO #__djcf_fields_xref VALUES(17,2,1,4);
INSERT INTO #__djcf_fields_xref VALUES(18,2,5,5);
INSERT INTO #__djcf_fields_xref VALUES(19,2,6,8);
INSERT INTO #__djcf_fields_xref VALUES(28,1,5,10);
INSERT INTO #__djcf_fields_xref VALUES(29,1,6,14);
INSERT INTO #__djcf_fields_xref VALUES(32,3,1,4);
INSERT INTO #__djcf_fields_xref VALUES(33,3,3,5);
INSERT INTO #__djcf_fields_xref VALUES(34,3,4,6);
INSERT INTO #__djcf_fields_xref VALUES(40,5,8,1);



DROP TABLE IF EXISTS #__djcf_items;

CREATE TABLE `#__djcf_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cat_id` int(11) NOT NULL DEFAULT '0',
  `user_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `description` text,
  `intro_desc` text,
  `image_url` text,
  `date_start` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `date_exp` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_mod` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `display` int(11) NOT NULL DEFAULT '0',
  `special` int(11) NOT NULL DEFAULT '0',
  `paypal_token` varchar(12) NOT NULL,
  `payed` int(11) NOT NULL DEFAULT '0',
  `notify` int(11) NOT NULL DEFAULT '0',
  `published` int(11) NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `price` varchar(255) DEFAULT NULL,
  `contact` text,
  `pay_type` varchar(255) DEFAULT NULL,
  `address` varchar(255) NOT NULL,
  `region_id` int(11) NOT NULL DEFAULT '0',
  `exp_days` int(11) NOT NULL,
  `promotions` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_id` (`cat_id`)
) AUTO_INCREMENT=47 DEFAULT CHARSET=utf8;

INSERT INTO #__djcf_items VALUES(1,4,614,' The Secret Garden','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras nisi dolor, convallis ac pellentesque nec, semper suscipit nisi. Aenean non tempus purus. Pellentesque aliquam tortor nec mi tempus eget fermentum quam placerat. Fusce vitae tortor justo. Suspendisse a vestibulum urna. Nullam rutrum erat consequat orci rutrum a suscipit mi pretium. Nam nisl lacus, vulputate vel cursus a, tincidunt non lorem.</p>','Donec ut quam felis. Cras egestas, quam in plac erat dictum, erat mauris inte rdum est nec.','1_1.jpg;1_5.jpg;1_8.jpg;','2012-10-29 16:43:29','2015-11-05 16:41:00','0000-00-00 00:00:00',236,1,'',1,0,1,0,'2000','1-999-000-000','','Middle Country Rd 79',3,0,'p_first,p_bold,p_border,p_bg,p_special');
INSERT INTO #__djcf_items VALUES(2,2,614,'Luxury Lakeside Living','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras nisi dolor, convallis ac pellentesque nec, semper suscipit nisi. Aenean non tempus purus. Pellentesque aliquam tortor nec mi tempus eget fermentum quam placerat. Fusce vitae tortor justo. Suspendisse a vestibulum urna. Nullam rutrum erat consequat orci rutrum a suscipit mi pretium. Nam nisl lacus, vulputate vel cursus a, tincidunt non lorem.</p>','Donec ut quam felis. Cras egestas, quam in plac erat dictum, erat mauris inte rdum est nec.','2_2.jpg;','2012-10-29 16:49:25','2015-11-05 16:48:00','0000-00-00 00:00:00',20,0,'',1,0,1,0,'560 000','1-999-000-000','','Broad St 56',3,0,'');
INSERT INTO #__djcf_items VALUES(3,3,614,'Sunny Apartment','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras nisi dolor, convallis ac pellentesque nec, semper suscipit nisi. Aenean non tempus purus. Pellentesque aliquam tortor nec mi tempus eget fermentum quam placerat. Fusce vitae tortor justo. Suspendisse a vestibulum urna. Nullam rutrum erat consequat orci rutrum a suscipit mi pretium. Nam nisl lacus, vulputate vel cursus a, tincidunt non lorem.</p>','Donec ut quam felis. Cras egestas, quam in plac erat dictum, erat mauris inte rdum est nec.','3_4.jpg;','2012-10-29 16:50:19','2015-11-05 16:49:00','0000-00-00 00:00:00',1,0,'',1,0,1,0,'450 000','1-888-888-888','','15th Court St ',3,0,'');
INSERT INTO #__djcf_items VALUES(4,3,614,'Victoria Gardens','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras nisi dolor, convallis ac pellentesque nec, semper suscipit nisi. Aenean non tempus purus. Pellentesque aliquam tortor nec mi tempus eget fermentum quam placerat. Fusce vitae tortor justo. Suspendisse a vestibulum urna. Nullam rutrum erat consequat orci rutrum a suscipit mi pretium. Nam nisl lacus, vulputate vel cursus a, tincidunt non lorem.</p>','Donec ut quam felis. Cras egestas, quam in plac erat dictum, erat mauris inte rdum est nec.','4_5.jpg;','2012-10-29 16:51:19','2015-11-05 16:50:00','0000-00-00 00:00:00',6,0,'',0,0,1,0,'720 000','1-999-000-222','','56th Westchester Ave',3,0,'');
INSERT INTO #__djcf_items VALUES(5,5,614,'Garage for Rent','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras nisi dolor, convallis ac pellentesque nec, semper suscipit nisi. Aenean non tempus purus. Pellentesque aliquam tortor nec mi tempus eget fermentum quam placerat. Fusce vitae tortor justo. Suspendisse a vestibulum urna. Nullam rutrum erat consequat orci rutrum a suscipit mi pretium. Nam nisl lacus, vulputate vel cursus a, tincidunt non lorem.</p>','Donec ut quam felis. Cras egestas, quam in plac erat dictum, erat mauris inte rdum est nec.','5_9.jpg;','2012-10-29 16:52:18','2015-11-05 16:51:00','0000-00-00 00:00:00',23,0,'',1,0,1,0,'500','1-999-000-222','','Front St 33',3,0,'p_special');
INSERT INTO #__djcf_items VALUES(6,5,614,'Bedroom Furnishes','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras nisi dolor, convallis ac pellentesque nec, semper suscipit nisi. Aenean non tempus purus. Pellentesque aliquam tortor nec mi tempus eget fermentum quam placerat. Fusce vitae tortor justo. Suspendisse a vestibulum urna. Nullam rutrum erat consequat orci rutrum a suscipit mi pretium. Nam nisl lacus, vulputate vel cursus a, tincidunt non lorem.</p>','Donec ut quam felis. Cras egestas, quam in plac erat dictum, erat mauris inte rdum est nec.','6_8.jpg;','2012-10-29 16:54:34','2015-11-05 16:53:00','0000-00-00 00:00:00',13,0,'',1,0,1,0,'300','1-999-000-222','','Forest Hill Rd 70',3,0,'p_border');



DROP TABLE IF EXISTS #__djcf_items_abuse;

CREATE TABLE `#__djcf_items_abuse` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `message` text NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__djcf_itemsask;

CREATE TABLE `#__djcf_itemsask` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `ip_address` varchar(50) NOT NULL,
  `message` text NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__djcf_payments;

CREATE TABLE `#__djcf_payments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `item_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `method` varchar(255) NOT NULL,
  `transaction_id` int(11) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `status` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__djcf_promotions;

CREATE TABLE `#__djcf_promotions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `label` varchar(255) NOT NULL,
  `description` varchar(255) NOT NULL,
  `price` float(12,2) NOT NULL,
  `points` int(11) NOT NULL,
  `published` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

INSERT INTO #__djcf_promotions VALUES(1,'p_first','COM_DJCLASSIFIEDS_PROMOTION_FIRST','COM_DJCLASSIFIEDS_PROMOTION_FIRST_DESC','4.00',0,1);
INSERT INTO #__djcf_promotions VALUES(2,'p_bold','COM_DJCLASSIFIEDS_PROMOTION_BOLD','COM_DJCLASSIFIEDS_PROMOTION_BOLD_DESC','1.00',0,1);
INSERT INTO #__djcf_promotions VALUES(3,'p_border','COM_DJCLASSIFIEDS_PROMOTION_BORDER','COM_DJCLASSIFIEDS_PROMOTION_BORDER_DESC','2.00',0,1);
INSERT INTO #__djcf_promotions VALUES(4,'p_bg','COM_DJCLASSIFIEDS_PROMOTION_BG','COM_DJCLASSIFIEDS_PROMOTION_BG_DESC','5.00',0,1);
INSERT INTO #__djcf_promotions VALUES(5,'p_special','COM_DJCLASSIFIEDS_PROMOTION_SPECIAL','COM_DJCLASSIFIEDS_PROMOTION_SPECIAL_DESC','5.00',0,1);



DROP TABLE IF EXISTS #__djcf_regions;

CREATE TABLE `#__djcf_regions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `parent_id` int(11) NOT NULL DEFAULT '0',
  `country` int(11) NOT NULL DEFAULT '0',
  `city` int(11) NOT NULL DEFAULT '0',
  `published` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

INSERT INTO #__djcf_regions VALUES(1,'North America',0,0,0,1);
INSERT INTO #__djcf_regions VALUES(2,'United States',1,1,0,1);
INSERT INTO #__djcf_regions VALUES(3,'New York',2,0,1,1);



DROP TABLE IF EXISTS #__djimageslider;

CREATE TABLE `#__djimageslider` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL DEFAULT '',
  `image` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `catid` (`catid`,`published`)
) AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;

INSERT INTO #__djimageslider VALUES(8,78,'Sunny Apartment','sunny-apartment','images/modules/slider/4.jpg','<p>Lorem ipsum dolor sit.</p>',1,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'0000-00-00 00:00:00',3,'{\"link_type\":\"url\",\"link_menu\":\"435\",\"link_url\":\"index.php\\/dj-catalog2\\/list-of-items-table\\/item\\/2-apartments\\/5-light-and-sunny-apartment\",\"link_article\":\"\",\"link_target\":\"\"}');
INSERT INTO #__djimageslider VALUES(7,78,'Luxury Lakeside','luxury-lakeside','images/modules/slider/2.jpg','<p>Lorem ipsum dolor sit.</p>',1,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'0000-00-00 00:00:00',2,'{\"link_type\":\"url\",\"link_menu\":\"435\",\"link_url\":\"index.php\\/dj-catalog2\\/list-of-items-table\\/item\\/1-homes\\/3-luxury-lakeside-living\",\"link_article\":\"\",\"link_target\":\"\"}');
INSERT INTO #__djimageslider VALUES(6,78,'The Secret Garden','the-secret-garden','images/modules/slider/1.jpg','<p>Lorem ipsum dolor sit.</p>',1,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'0000-00-00 00:00:00',1,'{\"link_type\":\"url\",\"link_menu\":\"435\",\"link_url\":\"index.php\\/dj-catalog2\\/single-product-view\\/item\\/1-homes\\/1-the-secret-garden\",\"link_article\":\"\",\"link_target\":\"\"}');
INSERT INTO #__djimageslider VALUES(9,78,'Victoria Gardens','victoria-gardens','images/modules/slider/5.jpg','<p>Lorem ipsum dolor sit.</p>',1,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'0000-00-00 00:00:00',4,'{\"link_type\":\"url\",\"link_menu\":\"435\",\"link_url\":\"index.php\\/dj-catalog2\\/list-of-items-table\\/item\\/2-apartments\\/4-victoria-gardens-penthouse\",\"link_article\":\"\",\"link_target\":\"\"}');
INSERT INTO #__djimageslider VALUES(10,78,'Bedroom Furnishes','bedroom-furnishes','images/modules/slider/8.jpg','<p>Lorem ipsum dolor sit.</p>',1,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'0000-00-00 00:00:00',5,'{\"link_type\":\"url\",\"link_menu\":\"435\",\"link_url\":\"index.php\\/dj-catalog2\\/list-of-items-table\\/item\\/3-other\\/6-bedroom-furnishes\",\"link_article\":\"\",\"link_target\":\"\"}');
INSERT INTO #__djimageslider VALUES(11,78,'Garage for Rent','garage-for-rent','images/modules/slider/9.jpg','<p>Lorem ipsum dolor sit.</p>',1,'0000-00-00 00:00:00','0000-00-00 00:00:00',0,'0000-00-00 00:00:00',6,'{\"link_type\":\"url\",\"link_menu\":\"435\",\"link_url\":\"index.php\\/dj-catalog2\\/list-of-items-table\\/item\\/3-other\\/7-garage-for-rent\",\"link_article\":\"\",\"link_target\":\"\"}');



DROP TABLE IF EXISTS #__extensions;

CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) AUTO_INCREMENT=10052 DEFAULT CHARSET=utf8;

INSERT INTO #__extensions VALUES(1,'com_mailto','component','com_mailto','',0,1,1,1,'{\"legacy\":false,\"name\":\"com_mailto\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MAILTO_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(2,'com_wrapper','component','com_wrapper','',0,1,1,1,'{\"legacy\":false,\"name\":\"com_wrapper\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(3,'com_admin','component','com_admin','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_admin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_ADMIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(4,'com_banners','component','com_banners','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_banners\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(5,'com_cache','component','com_cache','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_cache\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(6,'com_categories','component','com_categories','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_categories\",\"type\":\"component\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(7,'com_checkin','component','com_checkin','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_checkin\",\"type\":\"component\",\"creationDate\":\"Unknown\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CHECKIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(8,'com_contact','component','com_contact','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_contact\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONTACT_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"presentation_style\":\"sliders\",\"show_name\":\"1\",\"show_position\":\"1\",\"show_email\":\"0\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"1\",\"show_telephone\":\"1\",\"show_mobile\":\"1\",\"show_fax\":\"1\",\"show_webpage\":\"1\",\"show_misc\":\"1\",\"show_image\":\"1\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"contact_icons\":\"0\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"\",\"icon_fax\":\"\",\"icon_misc\":\"\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"0\",\"show_fax_headings\":\"0\",\"allow_vcard_headings\":\"0\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_category_crumb\":\"0\",\"metakey\":\"\",\"metadesc\":\"\",\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(9,'com_cpanel','component','com_cpanel','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_cpanel\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CPANEL_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10,'com_installer','component','com_installer','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_installer\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_INSTALLER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(11,'com_languages','component','com_languages','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_languages\",\"type\":\"component\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(12,'com_login','component','com_login','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_login\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(13,'com_media','component','com_media','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_media\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MEDIA_XML_DESCRIPTION\",\"group\":\"\"}','{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\",\"enable_flash\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(14,'com_menus','component','com_menus','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_menus\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MENUS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(15,'com_messages','component','com_messages','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_messages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MESSAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(16,'com_modules','component','com_modules','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_modules\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_MODULES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(17,'com_newsfeeds','component','com_newsfeeds','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_newsfeeds\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_word_count\":\"0\",\"show_headings\":\"1\",\"show_name\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"display_num\":\"\",\"show_pagination_limit\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_cat_items\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(18,'com_plugins','component','com_plugins','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_plugins\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_PLUGINS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(19,'com_search','component','com_search','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_search\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','{\"enabled\":\"0\",\"show_date\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(20,'com_templates','component','com_templates','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_templates\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(21,'com_weblinks','component','com_weblinks','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_weblinks\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_comp_description\":\"1\",\"comp_description\":\"\",\"show_link_hits\":\"1\",\"show_link_description\":\"1\",\"show_other_cats\":\"0\",\"show_headings\":\"0\",\"show_numbers\":\"0\",\"show_report\":\"1\",\"count_clicks\":\"1\",\"target\":\"0\",\"link_icons\":\"\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(22,'com_content','component','com_content','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_content\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"1\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"1\",\"show_item_navigation\":\"1\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"1\",\"readmore_limit\":\"100\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"1\",\"show_noauth\":\"0\",\"show_publishing_options\":\"1\",\"show_article_options\":\"1\",\"show_urls_images_frontend\":\"0\",\"show_urls_images_backend\":\"1\",\"targeta\":0,\"targetb\":0,\"targetc\":0,\"float_intro\":\"left\",\"float_fulltext\":\"left\",\"category_layout\":\"_:blog\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"1\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"0\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"0\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"orderby_pri\":\"order\",\"orderby_sec\":\"rdate\",\"order_date\":\"published\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(23,'com_config','component','com_config','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_config\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_CONFIG_XML_DESCRIPTION\",\"group\":\"\"}','{\"filters\":{\"1\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"NH\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"10\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"12\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"NONE\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(24,'com_redirect','component','com_redirect','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_redirect\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(25,'com_users','component','com_users','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_users\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_USERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"guest_usergroup\":\"13\",\"sendpassword\":\"1\",\"useractivation\":\"1\",\"mail_to_admin\":\"0\",\"captcha\":\"\",\"frontend_userparams\":\"1\",\"site_language\":\"0\",\"change_login_name\":\"0\",\"reset_count\":\"10\",\"reset_time\":\"1\",\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(27,'com_finder','component','com_finder','',1,1,0,0,'{\"legacy\":false,\"name\":\"com_finder\",\"type\":\"component\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_description\":\"1\",\"description_length\":255,\"allow_empty_query\":\"0\",\"show_url\":\"1\",\"show_advanced\":\"1\",\"expand_advanced\":\"0\",\"show_date_filters\":\"0\",\"highlight_terms\":\"1\",\"opensearch_name\":\"\",\"opensearch_description\":\"\",\"batch_size\":\"50\",\"memory_table_limit\":30000,\"title_multiplier\":\"1.7\",\"text_multiplier\":\"0.7\",\"meta_multiplier\":\"1.2\",\"path_multiplier\":\"2.0\",\"misc_multiplier\":\"0.3\",\"stemmer\":\"snowball\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(28,'com_joomlaupdate','component','com_joomlaupdate','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_joomlaupdate\",\"type\":\"component\",\"creationDate\":\"February 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(100,'PHPMailer','library','phpmailer','',0,1,1,1,'{\"legacy\":false,\"name\":\"PHPMailer\",\"type\":\"library\",\"creationDate\":\"2001\",\"author\":\"PHPMailer\",\"copyright\":\"(c) 2001-2003, Brent R. Matzelle, (c) 2004-2009, Andy Prevost. All Rights Reserved., (c) 2010-2011, Jim Jagielski. All Rights Reserved.\",\"authorEmail\":\"jimjag@gmail.com\",\"authorUrl\":\"https:\\/\\/code.google.com\\/a\\/apache-extras.org\\/p\\/phpmailer\\/\",\"version\":\"5.2\",\"description\":\"LIB_PHPMAILER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(101,'SimplePie','library','simplepie','',0,1,1,1,'{\"legacy\":false,\"name\":\"SimplePie\",\"type\":\"library\",\"creationDate\":\"2004\",\"author\":\"SimplePie\",\"copyright\":\"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/simplepie.org\\/\",\"version\":\"1.2\",\"description\":\"LIB_SIMPLEPIE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(102,'phputf8','library','phputf8','',0,1,1,1,'{\"legacy\":false,\"name\":\"phputf8\",\"type\":\"library\",\"creationDate\":\"2006\",\"author\":\"Harry Fuecks\",\"copyright\":\"Copyright various authors\",\"authorEmail\":\"hfuecks@gmail.com\",\"authorUrl\":\"http:\\/\\/sourceforge.net\\/projects\\/phputf8\",\"version\":\"0.5\",\"description\":\"LIB_PHPUTF8_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(103,'Joomla! Platform','library','joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"Joomla! Platform\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"11.4\",\"description\":\"LIB_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(200,'mod_articles_archive','module','mod_articles_archive','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_archive\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(201,'mod_articles_latest','module','mod_articles_latest','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LATEST_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(202,'mod_articles_popular','module','mod_articles_popular','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_articles_popular\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(203,'mod_banners','module','mod_banners','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_banners\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(204,'mod_breadcrumbs','module','mod_breadcrumbs','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_breadcrumbs\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_BREADCRUMBS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(205,'mod_custom','module','mod_custom','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(206,'mod_feed','module','mod_feed','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(207,'mod_footer','module','mod_footer','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_footer\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FOOTER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(208,'mod_login','module','mod_login','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(209,'mod_menu','module','mod_menu','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(210,'mod_articles_news','module','mod_articles_news','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_articles_news\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(211,'mod_random_image','module','mod_random_image','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_random_image\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_RANDOM_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(212,'mod_related_items','module','mod_related_items','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_related_items\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_RELATED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(213,'mod_search','module','mod_search','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_search\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(214,'mod_stats','module','mod_stats','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_stats\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(215,'mod_syndicate','module','mod_syndicate','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_syndicate\",\"type\":\"module\",\"creationDate\":\"May 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SYNDICATE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(216,'mod_users_latest','module','mod_users_latest','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_users_latest\",\"type\":\"module\",\"creationDate\":\"December 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_USERS_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(217,'mod_weblinks','module','mod_weblinks','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_weblinks\",\"type\":\"module\",\"creationDate\":\"July 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(218,'mod_whosonline','module','mod_whosonline','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_whosonline\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WHOSONLINE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(219,'mod_wrapper','module','mod_wrapper','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_wrapper\",\"type\":\"module\",\"creationDate\":\"October 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(220,'mod_articles_category','module','mod_articles_category','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_category\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(221,'mod_articles_categories','module','mod_articles_categories','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_categories\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(222,'mod_languages','module','mod_languages','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_languages\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(223,'mod_finder','module','mod_finder','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_finder\",\"type\":\"module\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(300,'mod_custom','module','mod_custom','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(301,'mod_feed','module','mod_feed','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(302,'mod_latest','module','mod_latest','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(303,'mod_logged','module','mod_logged','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_logged\",\"type\":\"module\",\"creationDate\":\"January 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGGED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(304,'mod_login','module','mod_login','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"March 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(305,'mod_menu','module','mod_menu','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(307,'mod_popular','module','mod_popular','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_popular\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(308,'mod_quickicon','module','mod_quickicon','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_quickicon\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_QUICKICON_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(309,'mod_status','module','mod_status','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_status\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_STATUS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(310,'mod_submenu','module','mod_submenu','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_submenu\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_SUBMENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(311,'mod_title','module','mod_title','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_title\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_TITLE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(312,'mod_toolbar','module','mod_toolbar','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_toolbar\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_TOOLBAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(313,'mod_multilangstatus','module','mod_multilangstatus','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_multilangstatus\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_MULTILANGSTATUS_XML_DESCRIPTION\",\"group\":\"\"}','{\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(314,'mod_version','module','mod_version','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_version\",\"type\":\"module\",\"creationDate\":\"January 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_VERSION_XML_DESCRIPTION\",\"group\":\"\"}','{\"format\":\"short\",\"product\":\"1\",\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(400,'plg_authentication_gmail','plugin','gmail','authentication',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_authentication_gmail\",\"type\":\"plugin\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_GMAIL_XML_DESCRIPTION\",\"group\":\"\"}','{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}','','',0,'0000-00-00 00:00:00',1,0);
INSERT INTO #__extensions VALUES(401,'plg_authentication_joomla','plugin','joomla','authentication',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_authentication_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_AUTH_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(402,'plg_authentication_ldap','plugin','ldap','authentication',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_authentication_ldap\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LDAP_XML_DESCRIPTION\",\"group\":\"\"}','{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}','','',0,'0000-00-00 00:00:00',3,0);
INSERT INTO #__extensions VALUES(404,'plg_content_emailcloak','plugin','emailcloak','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_emailcloak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\"}','','',0,'0000-00-00 00:00:00',1,0);
INSERT INTO #__extensions VALUES(405,'plg_content_geshi','plugin','geshi','content',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_content_geshi\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"qbnz.com\\/highlighter\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_GESHI_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0);
INSERT INTO #__extensions VALUES(406,'plg_content_loadmodule','plugin','loadmodule','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\"}','{\"style\":\"xhtml\"}','','',0,'2011-09-18 15:22:50',0,0);
INSERT INTO #__extensions VALUES(407,'plg_content_pagebreak','plugin','pagebreak','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"title\":\"1\",\"article_index\":\"1\",\"article_index_text\":\"\",\"multipage_toc\":\"1\",\"showall\":\"1\",\"style\":\"tabs\"}','','',0,'0000-00-00 00:00:00',4,0);
INSERT INTO #__extensions VALUES(408,'plg_content_pagenavigation','plugin','pagenavigation','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_pagenavigation\",\"type\":\"plugin\",\"creationDate\":\"January 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_PAGENAVIGATION_XML_DESCRIPTION\",\"group\":\"\"}','{\"position\":\"1\"}','','',0,'0000-00-00 00:00:00',5,0);
INSERT INTO #__extensions VALUES(409,'plg_content_vote','plugin','vote','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_vote\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_VOTE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0);
INSERT INTO #__extensions VALUES(410,'plg_editors_codemirror','plugin','codemirror','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_codemirror\",\"type\":\"plugin\",\"creationDate\":\"28 March 2011\",\"author\":\"Marijn Haverbeke\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"PLG_CODEMIRROR_XML_DESCRIPTION\",\"group\":\"\"}','{\"linenumbers\":\"0\",\"tabmode\":\"indent\"}','','',0,'0000-00-00 00:00:00',1,0);
INSERT INTO #__extensions VALUES(411,'plg_editors_none','plugin','none','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_none\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"2.5.0\",\"description\":\"PLG_NONE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0);
INSERT INTO #__extensions VALUES(412,'plg_editors_tinymce','plugin','tinymce','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_tinymce\",\"type\":\"plugin\",\"creationDate\":\"2005-2012\",\"author\":\"Moxiecode Systems AB\",\"copyright\":\"Moxiecode Systems AB\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"tinymce.moxiecode.com\\/\",\"version\":\"3.5.4.1\",\"description\":\"PLG_TINY_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\",\"skin\":\"0\",\"entity_encoding\":\"raw\",\"lang_mode\":\"0\",\"lang_code\":\"en\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"extended_elements\":\"\",\"toolbar\":\"top\",\"toolbar_align\":\"left\",\"html_height\":\"550\",\"html_width\":\"750\",\"resizing\":\"true\",\"resize_horizontal\":\"false\",\"element_path\":\"1\",\"fonts\":\"1\",\"paste\":\"1\",\"searchreplace\":\"1\",\"insertdate\":\"1\",\"format_date\":\"%Y-%m-%d\",\"inserttime\":\"1\",\"format_time\":\"%H:%M:%S\",\"colors\":\"1\",\"table\":\"1\",\"smilies\":\"1\",\"media\":\"1\",\"hr\":\"1\",\"directionality\":\"1\",\"fullscreen\":\"1\",\"style\":\"1\",\"layer\":\"1\",\"xhtmlxtras\":\"1\",\"visualchars\":\"1\",\"nonbreaking\":\"1\",\"template\":\"1\",\"blockquote\":\"1\",\"wordcount\":\"1\",\"advimage\":\"1\",\"advlink\":\"1\",\"advlist\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"inlinepopups\":\"1\",\"custom_plugin\":\"\",\"custom_button\":\"\"}','','',0,'0000-00-00 00:00:00',3,0);
INSERT INTO #__extensions VALUES(413,'plg_editors-xtd_article','plugin','article','editors-xtd',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors-xtd_article\",\"type\":\"plugin\",\"creationDate\":\"October 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_ARTICLE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0);
INSERT INTO #__extensions VALUES(414,'plg_editors-xtd_image','plugin','image','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_image\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0);
INSERT INTO #__extensions VALUES(415,'plg_editors-xtd_pagebreak','plugin','pagebreak','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0);
INSERT INTO #__extensions VALUES(416,'plg_editors-xtd_readmore','plugin','readmore','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_readmore\",\"type\":\"plugin\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_READMORE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0);
INSERT INTO #__extensions VALUES(417,'plg_search_categories','plugin','categories','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_categories\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(418,'plg_search_contacts','plugin','contacts','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_contacts\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(419,'plg_search_content','plugin','content','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_content\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(420,'plg_search_newsfeeds','plugin','newsfeeds','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(421,'plg_search_weblinks','plugin','weblinks','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_weblinks\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(422,'plg_system_languagefilter','plugin','languagefilter','system',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_system_languagefilter\",\"type\":\"plugin\",\"creationDate\":\"July 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0);
INSERT INTO #__extensions VALUES(423,'plg_system_p3p','plugin','p3p','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_p3p\",\"type\":\"plugin\",\"creationDate\":\"September 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_P3P_XML_DESCRIPTION\",\"group\":\"\"}','{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}','','',0,'0000-00-00 00:00:00',2,0);
INSERT INTO #__extensions VALUES(424,'plg_system_cache','plugin','cache','system',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_system_cache\",\"type\":\"plugin\",\"creationDate\":\"February 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','{\"browsercache\":\"0\",\"cachetime\":\"15\"}','','',0,'0000-00-00 00:00:00',9,0);
INSERT INTO #__extensions VALUES(425,'plg_system_debug','plugin','debug','system',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_system_debug\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_DEBUG_XML_DESCRIPTION\",\"group\":\"\"}','{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}','','',0,'0000-00-00 00:00:00',4,0);
INSERT INTO #__extensions VALUES(426,'plg_system_log','plugin','log','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_log\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_LOG_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0);
INSERT INTO #__extensions VALUES(427,'plg_system_redirect','plugin','redirect','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_redirect\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0);
INSERT INTO #__extensions VALUES(428,'plg_system_remember','plugin','remember','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_remember\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_REMEMBER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',7,0);
INSERT INTO #__extensions VALUES(429,'plg_system_sef','plugin','sef','system',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_system_sef\",\"type\":\"plugin\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SEF_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',8,0);
INSERT INTO #__extensions VALUES(430,'plg_system_logout','plugin','logout','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_logout\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0);
INSERT INTO #__extensions VALUES(431,'plg_user_contactcreator','plugin','contactcreator','user',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_user_contactcreator\",\"type\":\"plugin\",\"creationDate\":\"August 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTACTCREATOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}','','',0,'0000-00-00 00:00:00',1,0);
INSERT INTO #__extensions VALUES(432,'plg_user_joomla','plugin','joomla','user',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_user_joomla\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2009 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_USER_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{\"autoregister\":\"1\"}','','',0,'0000-00-00 00:00:00',2,0);
INSERT INTO #__extensions VALUES(433,'plg_user_profile','plugin','profile','user',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_user_profile\",\"type\":\"plugin\",\"creationDate\":\"January 2008\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_USER_PROFILE_XML_DESCRIPTION\",\"group\":\"\"}','{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(434,'plg_extension_joomla','plugin','joomla','extension',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_extension_joomla\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0);
INSERT INTO #__extensions VALUES(435,'plg_content_joomla','plugin','joomla','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(436,'plg_system_languagecode','plugin','languagecode','system',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_system_languagecode\",\"type\":\"plugin\",\"creationDate\":\"November 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',10,0);
INSERT INTO #__extensions VALUES(437,'plg_quickicon_joomlaupdate','plugin','joomlaupdate','quickicon',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_quickicon_joomlaupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(438,'plg_quickicon_extensionupdate','plugin','extensionupdate','quickicon',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_quickicon_extensionupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(439,'plg_captcha_recaptcha','plugin','recaptcha','captcha',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_captcha_recaptcha\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION\",\"group\":\"\"}','{\"public_key\":\"\",\"private_key\":\"\",\"theme\":\"clean\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(440,'plg_system_highlight','plugin','highlight','system',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_system_highlight\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',7,0);
INSERT INTO #__extensions VALUES(441,'plg_content_finder','plugin','finder','content',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_content_finder\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(442,'plg_finder_categories','plugin','categories','finder',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_finder_categories\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0);
INSERT INTO #__extensions VALUES(443,'plg_finder_contacts','plugin','contacts','finder',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_finder_contacts\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0);
INSERT INTO #__extensions VALUES(444,'plg_finder_content','plugin','content','finder',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_finder_content\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0);
INSERT INTO #__extensions VALUES(445,'plg_finder_newsfeeds','plugin','newsfeeds','finder',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_finder_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0);
INSERT INTO #__extensions VALUES(446,'plg_finder_weblinks','plugin','weblinks','finder',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_finder_weblinks\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0);
INSERT INTO #__extensions VALUES(500,'atomic','template','atomic','',0,1,1,0,'{\"legacy\":false,\"name\":\"atomic\",\"type\":\"template\",\"creationDate\":\"10\\/10\\/09\",\"author\":\"Ron Severdia\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"contact@kontentdesign.com\",\"authorUrl\":\"http:\\/\\/www.kontentdesign.com\",\"version\":\"2.5.0\",\"description\":\"TPL_ATOMIC_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(502,'bluestork','template','bluestork','',1,1,1,0,'{\"legacy\":false,\"name\":\"bluestork\",\"type\":\"template\",\"creationDate\":\"07\\/02\\/09\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"TPL_BLUESTORK_XML_DESCRIPTION\",\"group\":\"\"}','{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\",\"textBig\":\"0\",\"highContrast\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(503,'beez_20','template','beez_20','',0,1,1,0,'{\"legacy\":false,\"name\":\"beez_20\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"2.5.0\",\"description\":\"TPL_BEEZ2_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(504,'hathor','template','hathor','',1,1,1,0,'{\"legacy\":false,\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"hathor@tarrconsulting.com\",\"authorUrl\":\"http:\\/\\/www.tarrconsulting.com\",\"version\":\"2.5.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(505,'beez5','template','beez5','',0,1,1,0,'{\"legacy\":false,\"name\":\"beez5\",\"type\":\"template\",\"creationDate\":\"21 May 2010\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"2.5.0\",\"description\":\"TPL_BEEZ5_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"html5\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(600,'English (United Kingdom)','language','en-GB','',0,1,1,1,'{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.5\",\"description\":\"en-GB site language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(601,'English (United Kingdom)','language','en-GB','',1,1,1,1,'{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.5\",\"description\":\"en-GB administrator language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(700,'files_joomla','file','joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"November 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.8\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(800,'PKG_JOOMLA','package','pkg_joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"PKG_JOOMLA\",\"type\":\"package\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PKG_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10000,'dj-real-estate02','template','dj-real-estate02','',0,1,1,0,'{\"legacy\":false,\"name\":\"dj-real-estate02\",\"type\":\"template\",\"creationDate\":\"25\\/07\\/2012\",\"author\":\"joomla-monster.com\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"joomla-monster@design-joomla.eu\",\"authorUrl\":\"joomla-monster.com\",\"version\":\"2.5.0\",\"description\":\"\\n\\t<head>\\n\\t\\t<link href=\'http:\\/\\/fonts.googleapis.com\\/css?family=Droid+Serif\' rel=\'stylesheet\' type=\'text\\/css\'>\\n\\t\\t<style>\\n\\t\\t\\tspan.readonly.mod-desc {\\n\\t\\t\\t\\tclear: both;\\n\\t\\t\\t}\\n\\t\\t\\t.jm-row {\\n\\t\\t\\t\\tdisplay: inline-block;\\n\\t\\t\\t\\tclear: both;\\n\\t\\t\\t\\twidth: 100%;\\n\\t\\t\\t\\tfont-weight: normal;\\n\\t\\t\\t\\tfont-size: 12px;\\n\\t\\t\\t\\tcolor: #444444;\\n\\t\\t\\t}\\n\\t\\t\\t.jm-row a:link,\\n\\t\\t\\t.jm-row a:visited {\\n\\t\\t\\t\\tcolor: #e46a1a;\\n\\t\\t\\t}\\n\\t\\t\\t.jm-row a:hover {\\n\\t\\t\\t\\ttext-decoration: underline;\\n\\t\\t\\t}\\n\\t\\t\\t#jm-left {\\n\\t\\t\\t\\tfloat: left;\\n\\t\\t\\t\\twidth: 49%;\\n\\t\\t\\t\\tmin-width: 250px;\\n\\t\\t\\t\\tpadding-bottom: 30px;\\n\\t\\t\\t}\\n\\t\\t\\t#jm-right {\\n\\t\\t\\t\\tfloat: right;\\n\\t\\t\\t\\twidth: 49%;\\n\\t\\t\\t\\tmin-width: 300px;\\n\\t\\t\\t\\tfont-family: \'Droid Serif\', serif;\\n\\t\\t\\t\\tfont-size: 14px;\\n\\t\\t\\t\\tcolor: #272a2c;\\n\\t\\t\\t\\tpadding: 0 0 30px;\\n\\t\\t\\t\\ttext-align: left;\\n\\t\\t\\t}\\n\\t\\t\\t#jm-right div {\\n\\t\\t\\t\\tpadding: 0 0 0 40px;\\n\\t\\t\\t}\\n\\t\\t\\t#jm-left a {\\n\\t\\t\\t\\tdisplay: block;\\n\\t\\t\\t\\tmargin: 0 0 15px;\\n\\t\\t\\t}\\n\\t\\t\\t.jm-row img {\\n\\t\\t\\t\\tfloat: none;\\n\\t\\t\\t\\tmargin: 0;\\n\\t\\t\\t}\\n\\t\\t\\t#jm-left span {\\n\\t\\t\\t\\tfont-family: \'Droid Serif\', serif;\\n\\t\\t\\t\\tfont-size: 14px;\\n\\t\\t\\t\\tcolor: #272a2c;\\n\\t\\t\\t\\tdisplay: block;\\n\\t\\t\\t}\\n\\t\\t\\t#jm-right span {\\n\\t\\t\\t\\tfont-size: 18px;\\n\\t\\t\\t\\tcolor: #137baf;\\n\\t\\t\\t}\\n\\t\\t\\t#jm-right div.jm-version {\\n\\t\\t\\t\\tcolor: #999999;\\n\\t\\t\\t\\tfont-size: 12px;\\n\\t\\t\\t\\tpadding: 5px 0 0 145px;\\n\\t\\t\\t}\\n\\t\\t\\t.jm-col {\\n\\t\\t\\t\\tfloat: left;\\n\\t\\t\\t\\tpadding: 0 20px 0 0;\\n\\t\\t\\t\\tmargin: 0 20px 20px 0;\\n\\t\\t\\t\\tborder-right: 1px solid #e4e4e4;\\n\\t\\t\\t}\\n\\t\\t\\t.jm-col:last-child {\\n\\t\\t\\t\\tborder: none;\\n\\t\\t\\t\\tpadding: 0;\\n\\t\\t\\t\\tmargin: 0 0 20px;\\n\\t\\t\\t}\\n\\t\\t<\\/style>\\n\\t<\\/head>\\n\\t<body>\\n\\t\\t<div class=\\\"jm-row\\\">\\n\\t\\t\\t<div id=\\\"jm-left\\\">\\n\\t\\t\\t\\t<a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.joomla-monster.com\\\"><img src=\\\"http:\\/\\/joomla-monster.com\\/images\\/jm-logo.png\\\" \\/><\\/a>\\n\\t\\t\\t\\t<span>Templates for Joomla! CMS<\\/span>\\n\\t\\t\\t<\\/div>\\t\\t\\n\\t\\t\\t<div id=\\\"jm-right\\\">\\n\\t\\t\\t\\t<div>Template <span>DJ-Real-Estate02<\\/span><br\\/><\\/div>\\n\\t\\t\\t\\t<div class=\\\"jm-version\\\">Template version: EF 1.00<\\/div>\\n\\t\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t\\t<div class=\\\"jm-row\\\">\\n\\t\\t\\t<div class=\\\"jm-col\\\">Our site: <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.joomla-monster.com\\\">www.joomla-monster.com<\\/a><\\/div>\\n\\t\\t\\t<div class=\\\"jm-col\\\">DJ-Extensions: <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.dj-extensions.com\\\">www.dj-extensions.com<\\/a><\\/div>\\n\\t\\t\\t<div class=\\\"jm-col\\\">Custom Joomla services: <a target=\\\"_blank\\\" href=\\\"http:\\/\\/www.design-joomla.eu\\\">www.design-joomla.eu<\\/a><\\/div>\\n\\t\\t<\\/div>\\n\\t<\\/body>\\n\\t\",\"group\":\"\"}','{\"StyleSwitcher\":\"0\",\"TemplateStyle\":\"1\",\"fontSizeSwitcher\":\"1\",\"TemplateWidth\":\"960\",\"TabletWidth\":\"800\",\"MobileWidth\":\"480\",\"SchemeOption\":\"left-content_right\",\"ColumnLeftWidth\":\"25\",\"ColumnRightWidth\":\"25\",\"bodyText\":\"#424242\",\"fontSizeSelector\":\"12\",\"bodyFontChooser\":\"0\",\"djmenuFontSizeSelector\":\"13\",\"djmenuFontChooser\":\"0\",\"headingsFontSizeSelector\":\"24\",\"headingsFontChooser\":\"0\",\"articlesFontSizeSelector\":\"24\",\"articlesFontChooser\":\"0\",\"GoogleAnalytics\":\"1\",\"CssCompress\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10001,'DJ-Menu','module','mod_djmenu','',0,1,0,0,'{\"legacy\":false,\"name\":\"DJ-Menu\",\"type\":\"module\",\"creationDate\":\"January 2011\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"1.6.4.stable\",\"description\":\"MOD_DJMENU_MODULE_DESC\",\"group\":\"\"}','{\"menu\":\"mainmenu\",\"endLevel\":\"0\",\"css\":\"1\",\"moo\":\"1\",\"wrapper\":\"\",\"select\":\"0\",\"height_fx\":\"1\",\"width_fx\":\"1\",\"opacity_fx\":\"1\",\"height_fx_sub\":\"1\",\"width_fx_sub\":\"1\",\"opacity_fx_sub\":\"1\",\"effect\":\"cubic\",\"duration\":\"\",\"delay\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10002,'com_djimageslider','component','com_djimageslider','',1,1,0,0,'{\"legacy\":false,\"name\":\"com_djimageslider\",\"type\":\"component\",\"creationDate\":\"August 2012\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2012 DJ-Extensions.com, All rights reserved.\",\"authorEmail\":\"contact@dj-extensions.com\",\"authorUrl\":\"http:\\/\\/dj-extensions.com\",\"version\":\"2.0.4.stable\",\"description\":\"DJ-ImageSlider component\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10003,'DJ-ImageSlider','module','mod_djimageslider','',0,1,0,0,'{\"legacy\":false,\"name\":\"DJ-ImageSlider\",\"type\":\"module\",\"creationDate\":\"August 2012\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2012 DJ-Extensions.com, All rights reserved.\",\"authorEmail\":\"contact@dj-extensions.com\",\"authorUrl\":\"http:\\/\\/dj-extensions.com\",\"version\":\"2.0.4.stable\",\"description\":\"DJ-ImageSlider Module\",\"group\":\"\"}','{\"slider_source\":\"0\",\"slider_type\":\"0\",\"link_image\":\"1\",\"image_folder\":\"images\\/sampledata\\/fruitshop\",\"link\":\"\",\"show_title\":\"1\",\"show_desc\":\"1\",\"show_readmore\":\"0\",\"readmore_text\":\"\",\"link_title\":\"1\",\"link_desc\":\"0\",\"limit_desc\":\"\",\"image_width\":\"240\",\"image_height\":\"180\",\"fit_to\":\"0\",\"visible_images\":\"3\",\"space_between_images\":\"10\",\"max_images\":\"20\",\"sort_by\":\"1\",\"effect\":\"Cubic\",\"autoplay\":\"1\",\"show_buttons\":\"1\",\"show_arrows\":\"1\",\"show_custom_nav\":\"0\",\"desc_width\":\"\",\"desc_bottom\":\"0\",\"desc_horizontal\":\"0\",\"left_arrow\":\"\",\"right_arrow\":\"\",\"play_button\":\"\",\"pause_button\":\"\",\"arrows_top\":\"30\",\"arrows_horizontal\":\"5\",\"effect_type\":\"0\",\"duration\":\"\",\"delay\":\"\",\"preload\":\"800\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10004,'dj-imageslider','package','pkg_dj-imageslider','',0,1,1,0,'{\"legacy\":false,\"name\":\"DJ-ImageSlider Package\",\"type\":\"package\",\"creationDate\":\"August 2012\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2012 DJ-Extensions.com, All rights reserved.\",\"authorEmail\":\"contact@dj-extensions.com\",\"authorUrl\":\"http:\\/\\/dj-extensions.com\",\"version\":\"2.0.4.stable\",\"description\":\"\\n\\t\\t<style> #right-text {font-family:Arial, Helvetica, sans-serif;\\tfont-size:11px;\\t} #right-text a:link, #right-text a:visited {color:#4991c1;font-weight:bold; font-size: 13px;} #right-text a:hover {text-decoration:underline;}\\t#right-text h2 {color:#fa9539;text-transform:uppercase;\\tfont-size:16px;\\tpadding:0;\\tmargin:2px 0;}\\t#right-text p {padding:0;margin:4px 0;}\\t#left-logo {float:left;width:270px;height:120px;display:block;} #left-logo img {margin: 40px 20px;} #right-text {float:left;width:400px;}<\\/style>\\n\\t\\n\\t\\t<div id=\\\"left-logo\\\">\\n\\t\\t\\t<a target=\\\"_blank\\\" href=\\\"http:\\/\\/dj-extensions.com\\\"><img src=\\\"http:\\/\\/new.dj-extensions.com\\/templates\\/dj-extensions\\/images\\/logo.png\\\" alt=\\\"DJ-Extensions.com\\\" \\/><\\/a>\\n\\t\\t<\\/div>\\n\\t\\t\\n\\t\\t<div id=\\\"right-text\\\">\\n\\t\\t\\t<h2>Thank you for installing DJ-ImageSlider!<\\/h2>\\n\\t\\t\\t<p>The DJ-ImageSlider extension allows you to display image slides with title and short description linked to any menu item, article or custom url address.<\\/p>\\n\\t\\t\\t<p>If you want to learn how to use DJ-ImageSlider please read <a target=\\\"_blank\\\" href=\\\"http:\\/\\/dj-extensions.com\\/documentation\\\">Documentation<\\/a> and search our <a target=\\\"_blank\\\" href=\\\"http:\\/\\/dj-extensions.com\\/forum\\\">Support Forum<\\/a><br \\/><br \\/>Check out our other extensions at <a target=\\\"_blank\\\" href=\\\"http:\\/\\/dj-extensions.com\\\">DJ-Extensions.com<\\/a><\\/p>\\n\\t\\t<\\/div>\\n\\t\\n\\t\\t\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10005,'djclassifieds','component','com_djclassifieds','',1,1,0,0,'{\"legacy\":false,\"name\":\"DJ Classifieds\",\"type\":\"component\",\"creationDate\":\"July 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"design-joomla.com\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.com\",\"version\":\"2.1.1\",\"description\":\"DJ Classifieds - Advertising Component\",\"group\":\"\"}','{\"exp_days\":\"7\",\"durations_list\":\"1\",\"notify_days\":\"3\",\"notify_days_trigger\":\"1\",\"autopublish\":\"1\",\"promotion\":\"1\",\"user_type\":\"1\",\"notify_admin\":\"0\",\"notify_user_email\":\"\",\"abuse_reporting\":\"1\",\"favourite\":\"1\",\"unit_price\":\"EUR\",\"unit_price_position\":\"0\",\"show_contact\":\"1\",\"show_regions\":\"1\",\"show_googlemap\":\"1\",\"gm_zoom\":\"10\",\"show_gm_driving\":\"0\",\"gm_icon\":\"0\",\"include_css\":\"0\",\"limit_djitem_show\":\"4\",\"blog_columns_number\":\"2\",\"blog_desc_position\":\"right\",\"img_limit\":\"5\",\"img_maxsize\":\"0\",\"introdesc_char_limit\":\"120\",\"show_adsn_cat\":\"1\",\"show_subcats\":\"1\",\"subcats_dir\":\"0\",\"desc_editor\":\"1\",\"allow_htmltags\":\"1\",\"allowed_htmltags\":\"div;p;span;strong;i;b;em;ul;li;ol;br\",\"showitem_jump\":\"0\",\"category_jump\":\"0\",\"title_breadcrumb\":\"1\",\"tooltip_img\":\"1\",\"tooltip_title\":\"1\",\"tooltip_images\":\"3\",\"tooltip_price\":\"1\",\"items_ordering\":\"date_e\",\"items_ordering_dir\":\"desc\",\"column_loc\":\"1\",\"column_price\":\"1\",\"column_date_a\":\"1\",\"column_date_e\":\"0\",\"column_displayed\":\"0\",\"ask_seller\":\"1\",\"ask_seller_type\":\"0\",\"showaddetails\":\"1\",\"show_start_date\":\"1\",\"showauthor\":\"1\",\"cattree_type\":\"cat\",\"cattree_cols\":\"3\",\"cattree_levels\":\"0\",\"cattree_ic\":\"1\",\"rss_feed\":\"1\",\"icon_new\":\"1\",\"icon_new_time\":\"3\",\"sb_position\":\"top\",\"sb_code\":\"<div class=\\\"addthis_toolbox addthis_default_style \\\" style=\\\"\\\"><a class=\\\"addthis_button_preferred_1\\\"><\\/a><a class=\\\"addthis_button_preferred_2\\\"><\\/a><a class=\\\"addthis_button_preferred_3\\\"><\\/a><a class=\\\"addthis_button_preferred_4\\\"><\\/a><a class=\\\"addthis_button_compact\\\"><\\/a><a class=\\\"addthis_counter addthis_bubble_style\\\"><\\/a><\\/div><script type=\\\"text\\/javascript\\\" src=\\\"http:\\/\\/s7.addthis.com\\/js\\/250\\/addthis_widget.js#pubid=xa-501a7c83604a8bb4\\\"><\\/script>\",\"th_width\":\"270\",\"th_height\":\"180\",\"bigth_width\":\"600\",\"bigth_height\":\"0\",\"smallth_width\":\"70\",\"smallth_height\":\"50\",\"middleth_width\":\"150\",\"middleth_height\":\"110\",\"catth_width\":\"68\",\"catth_height\":\"50\",\"ask_limit_one\":\"5\",\"ask_limit_hour\":\"15\",\"captcha\":\"0\",\"terms\":\"1\",\"terms_article_id\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10006,'DJClassifieds Items','module','mod_djclassifieds_items','',0,1,0,0,'{\"legacy\":true,\"name\":\"DJClassifieds Items\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.\",\"authorEmail\":\"contact@design-jooma.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.1\",\"description\":\"DJ Classifieds Items module\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"items_nr\":\"7\",\"columns_nr\":\"1\",\"items_ord\":\"0\",\"only_promoted\":\"0\",\"fallow_category\":\"0\",\"items_ids\":\"\",\"show_img\":\"1\",\"show_title\":\"1\",\"show_date\":\"1\",\"show_cat\":\"1\",\"cat_link\":\"1\",\"show_price\":\"1\",\"show_description\":\"1\",\"desc_source\":\"0\",\"desc_link\":\"0\",\"char_desc_nr\":\"50\",\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10007,'DJClassifieds Maps','module','mod_djclassifieds_maps','',0,1,0,0,'{\"legacy\":true,\"name\":\"DJClassifieds Maps\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.\",\"authorEmail\":\"contact@design-jooma.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.0.1\",\"description\":\"DJ Classifieds Google Maps module\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"map_width\":\"500px\",\"map_height\":\"400px\",\"items_limit\":\"20\",\"start_address\":\"England, London\",\"start_zoom\":\"10\",\"items_ord\":\"0\",\"fallow_category\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10008,'DJClassifieds Menu','module','mod_djclassifieds_menu','',0,1,0,0,'{\"legacy\":true,\"name\":\"DJClassifieds Menu\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.\",\"authorEmail\":\"contact@design-jooma.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.0.2\",\"description\":\"DJ Classifieds Menu module\",\"group\":\"\"}','{\"moduleclass_sfx\":\"_menu\",\"max_level\":\"0\",\"new_ad_link\":\"2\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10009,'DJClassifieds Search','module','mod_djclassifieds_search','',0,1,0,0,'{\"legacy\":true,\"name\":\"DJClassifieds Search\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.\",\"authorEmail\":\"contact@design-jooma.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.1\",\"description\":\"DJ Classifieds Search module\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"show_cat\":\"1\",\"show_loc\":\"1\",\"show_input\":\"1\",\"show_price\":\"0\",\"show_reset\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10010,'DJClassifieds User Menu','module','mod_djclassifieds_user_menu','',0,1,0,0,'{\"legacy\":true,\"name\":\"DJClassifieds User Menu\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.\",\"authorEmail\":\"contact@design-jooma.eu\",\"authorUrl\":\"http:\\/\\/dj-extensions.com\",\"version\":\"2.0.1\",\"description\":\"DJ Classifieds User menu module\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"new_ad_link\":\"1\",\"user_ads_link\":\"1\",\"user_fav_link\":\"1\",\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10011,'DJ Classifieds Authorize.net payment','plugin','djcfAuthorizeNET','djclassifiedspayment',0,1,1,0,'{\"legacy\":false,\"name\":\"DJ Classifieds Authorize.net payment\",\"type\":\"plugin\",\"creationDate\":\"September 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.\",\"authorEmail\":\"contact@design-jooma.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.1\",\"description\":\"DJ Classifieds Authorize.net payment\",\"group\":\"\"}','{\"login_id\":\"\",\"transaction_key\":\"\",\"account_type\":\"test\",\"currency_code\":\"USD\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10012,'DJ Classifieds Paypal payment','plugin','djcfPaypal','djclassifiedspayment',0,1,1,0,'{\"legacy\":false,\"name\":\"DJ Classifieds Paypal payment\",\"type\":\"plugin\",\"creationDate\":\"September 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.\",\"authorEmail\":\"contact@design-jooma.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.1\",\"description\":\"DJ Classifieds Paypal payment\",\"group\":\"\"}','{\"email_id\":\"1343424\",\"test\":\"1\",\"currency_code\":\"USD\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10013,'DJ Classifieds PayU payment','plugin','djcfPayU','djclassifiedspayment',0,1,1,0,'{\"legacy\":false,\"name\":\"DJ Classifieds PayU payment\",\"type\":\"plugin\",\"creationDate\":\"September 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.\",\"authorEmail\":\"contact@design-jooma.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.1\",\"description\":\"DJ Classifieds PayU payment\",\"group\":\"\"}','{\"pos_id\":\"\",\"md5_key\":\"\",\"md5_key2\":\"\",\"pos_auth_key\":\"\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10014,'DJ Classifieds Przelewy24 payment','plugin','djcfPrzelewy24','djclassifiedspayment',0,1,1,0,'{\"legacy\":false,\"name\":\"DJ Classifieds Przelewy24 payment\",\"type\":\"plugin\",\"creationDate\":\"September 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.\",\"authorEmail\":\"contact@design-jooma.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.1\",\"description\":\"DJ Classifieds Przelewy24 payment\",\"group\":\"\"}','{\"p24_id\":\"434234\",\"p24_crc\":\"23423424\",\"test\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10015,'dj-classifieds','package','pkg_dj-classifieds','',0,1,1,0,'{\"legacy\":false,\"name\":\"DJ-Classifieds Package\",\"type\":\"package\",\"creationDate\":\"November 2011\",\"author\":\"DJ-Extensions.com\",\"copyright\":\"Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/dj-extensions.com\",\"version\":\"2.1.2\",\"description\":\"DJ-Classifieds All-in-one Package\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10040,'com_djcatalog2','component','com_djcatalog2','',1,1,0,0,'{\"legacy\":false,\"name\":\"com_djcatalog2\",\"type\":\"component\",\"creationDate\":\"23 September 2012\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.2.12\",\"description\":\"\",\"group\":\"\"}','{\"theme\":\"dj-real-estate02\",\"price_unit\":\"$\",\"thousand_separator\":\"0\",\"decimal_separator\":\"0\",\"decimals\":\"2\",\"unit_side\":\"1\",\"show_footer\":\"0\",\"product_catalogue\":\"0\",\"showcatdesc\":\"1\",\"showsubcategories_label\":\"1\",\"showsubcategories\":\"1\",\"category_columns\":\"3\",\"category_show_intro\":\"1\",\"category_intro_trunc\":\"0\",\"category_intro_length\":\"0\",\"image_link_subcategory\":\"1\",\"showreadmore_subcategory\":\"1\",\"limit_items_show\":\"8\",\"list_layout\":\"items\",\"items_columns\":\"2\",\"items_default_order\":\"i.ordering\",\"items_default_order_dir\":\"asc\",\"featured_only\":\"0\",\"featured_first\":\"0\",\"show_category_filter\":\"1\",\"show_producer_filter\":\"1\",\"show_search\":\"1\",\"show_category_orderby\":\"1\",\"show_producer_orderby\":\"1\",\"show_name_orderby\":\"1\",\"show_price_orderby\":\"1\",\"show_date_orderby\":\"1\",\"show_category_name\":\"1\",\"show_producer_name\":\"3\",\"show_price\":\"1\",\"items_show_intro\":\"1\",\"items_intro_trunc\":\"1\",\"items_intro_length\":\"160\",\"image_link_item\":\"1\",\"showreadmore_item\":\"1\",\"show_category_name_item\":\"1\",\"show_producer_name_item\":\"3\",\"show_price_item\":\"1\",\"related_items_columns\":\"2\",\"related_items_count\":\"2\",\"resize\":\"3\",\"crop_alignment_h\":\"m\",\"crop_alignment_v\":\"m\",\"fp_width\":\"310\",\"fp_height\":\"210\",\"width\":\"294\",\"height\":\"190\",\"th_width\":\"310\",\"th_height\":\"200\",\"smallth_width\":\"90\",\"smallth_height\":\"60\",\"smallth_spacing_v\":\"4\",\"smallth_spacing_h\":\"4\",\"smallth_padding_h\":\"4\",\"category_resize\":\"\",\"category_width\":\"\",\"category_height\":\"\",\"category_th_width\":\"\",\"category_th_height\":\"\",\"category_smallth_width\":\"\",\"category_smallth_height\":\"\",\"category_smallth_spacing_v\":\"\",\"category_smallth_spacing_h\":\"\",\"category_smallth_padding_h\":\"\",\"producer_resize\":\"\",\"producer_width\":\"\",\"producer_height\":\"\",\"producer_th_width\":\"\",\"producer_th_height\":\"\",\"producer_smallth_width\":\"\",\"producer_smallth_height\":\"\",\"producer_smallth_spacing_v\":\"\",\"producer_smallth_spacing_h\":\"\",\"producer_smallth_padding_h\":\"\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10044,'mod_djc2relateditems','module','mod_djc2relateditems','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_djc2relateditems\",\"type\":\"module\",\"creationDate\":\"October 2011\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights\\n\\t\\treserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.3\",\"description\":\"MOD_DJC2RELATEDITEMS_DESC\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"featured_only\":\"0\",\"featured_first\":\"0\",\"orderby\":\"0\",\"orderdir\":\"0\",\"items_limit\":\"0\",\"thumbnail\":\"medium\",\"show_category_name\":\"1\",\"show_producer_name\":\"3\",\"show_price\":\"1\",\"items_show_intro\":\"1\",\"items_intro_trunc\":\"0\",\"items_intro_length\":\"0\",\"showreadmore_item\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10041,'mod_djc2categories','module','mod_djc2categories','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_djc2categories\",\"type\":\"module\",\"creationDate\":\"January 2011\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights\\n\\t\\treserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.3\",\"description\":\"MOD_DJC2CATEGORIES_DESC\",\"group\":\"\"}','{\"moduleclass_sfx\":\"_menu\",\"expand\":\"0\",\"parent_category\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10042,'mod_djc2frontpage','module','mod_djc2frontpage','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_djc2frontpage\",\"type\":\"module\",\"creationDate\":\"November 2011\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights\\n\\t\\treserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.5\",\"description\":\"MOD_DJC2FRONTPAGE_MODULE_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"showtitle\":\"1\",\"linktitle\":\"1\",\"showcattitle\":\"1\",\"showpagination\":\"1\",\"orderby\":\"0\",\"orderbydir\":\"0\",\"featured_only\":\"0\",\"featured_first\":\"0\",\"@spacer\":\"\",\"catsw\":\"0\",\"catid\":\"0\",\"cols\":\"1\",\"rows\":\"3\",\"trunc\":\"0\",\"trunclimit\":\"0\",\"showreadmore\":\"1\",\"readmoretext\":\"\",\"showfooter\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10043,'mod_djc2items','module','mod_djc2items','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_djc2items\",\"type\":\"module\",\"creationDate\":\"November 2011\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.3\",\"description\":\"MOD_DJC2ITEMS_DESC\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"featured_only\":\"0\",\"featured_first\":\"0\",\"orderby\":\"0\",\"orderdir\":\"0\",\"catid\":\"0\",\"items_limit\":\"0\",\"thumbnail\":\"medium\",\"show_category_name\":\"1\",\"show_producer_name\":\"3\",\"show_price\":\"1\",\"items_show_intro\":\"1\",\"items_intro_trunc\":\"0\",\"items_intro_length\":\"0\",\"showreadmore_item\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10051,'dj-catalog2','package','pkg_dj-catalog2','',0,1,1,0,'{\"legacy\":false,\"name\":\"DJ-Catalog2 Package\",\"type\":\"package\",\"creationDate\":\"September 2012\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/dj-extensions.com\",\"version\":\"2.2.13\",\"description\":\"DJ-Catalog2 All-in-one Package\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10045,'mod_djc2producers','module','mod_djc2producers','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_djc2producers\",\"type\":\"module\",\"creationDate\":\"January 2011\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights\\n\\t\\treserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.3\",\"description\":\"MOD_DJC2PRODUCERS_DESC\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"filter\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10046,'mod_djc2search','module','mod_djc2search','',0,1,0,0,'{\"legacy\":false,\"name\":\"mod_djc2search\",\"type\":\"module\",\"creationDate\":\"January 2011\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights\\n\\t\\treserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"1.1\",\"description\":\"MOD_DJC2SEARCH\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"filter\":\"1\",\"show_label\":\"1\",\"show_button\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10047,'plg_djcatalog2_addthis','plugin','addthis','djcatalog2',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_djcatalog2_addthis\",\"type\":\"plugin\",\"creationDate\":\"January 2011\",\"author\":\"AddThis, LLC; Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2009 AddThis, LLC; 2010 Blue Constant Media LTD\",\"authorEmail\":\"\",\"authorUrl\":\"www.addthis.com\",\"version\":\"2.3\",\"description\":\"PLG_DJCATALOG2_ADDTHIS_ADDTHISDESC\",\"group\":\"\"}','{\"pub_id\":\"\",\"button_style\":\"sm-plus\",\"custom_url\":\"\",\"addthis_button_language\":\"en\",\"addthis_brand\":\"\",\"addthis_header_color\":\"\",\"addthis_header_background\":\"\",\"addthis_options\":\"\",\"alignment\":\"right\",\"addthis_offset_top\":\"\",\"addthis_offset_left\":\"\",\"addthis_hover_delay\":\"\",\"addthis_hide_embed\":\"1\",\"addthis_language\":\"\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10048,'plg_djcatalog2_pagebreak','plugin','pagebreak','djcatalog2',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_djcatalog2_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"January 2011\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.3\",\"description\":\"PLG_DJCATALOG2_PAGEBREAK_DJCATALOGPAGEBREAK\",\"group\":\"\"}','{\"enabled\":\"1\",\"accordion\":\"2\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10049,'plg_search_djcatalog2','plugin','djcatalog2','search',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_search_djcatalog2\",\"type\":\"plugin\",\"creationDate\":\"January 2011\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"2.3\",\"description\":\"PLG_SEARCH_DJCATALOG2_DJPLGSEARCHDESC\",\"group\":\"\"}','{\"search_limit\":\"50\"}','','',0,'0000-00-00 00:00:00',0,0);
INSERT INTO #__extensions VALUES(10050,'XMAP - DJCatalog2 Plugin','plugin','com_djcatalog2','xmap',0,0,1,0,'{\"legacy\":false,\"name\":\"XMAP - DJCatalog2 Plugin\",\"type\":\"plugin\",\"creationDate\":\"January 2012\",\"author\":\"Blue Constant Media LTD\",\"copyright\":\"Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.\",\"authorEmail\":\"contact@design-joomla.eu\",\"authorUrl\":\"http:\\/\\/design-joomla.eu\",\"version\":\"1.1.beta\",\"description\":\"PLG_XMAP_COM_DJCATALOG2_DESC\",\"group\":\"\"}','{\"include_products\":\"1\",\"cat_priority\":\"0.5\",\"cat_changefreq\":\"weekly\",\"link_priority\":\"0.5\",\"link_changefreq\":\"weekly\"}','','',0,'0000-00-00 00:00:00',0,0);



DROP TABLE IF EXISTS #__finder_filters;

CREATE TABLE `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links;

CREATE TABLE `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_terms0;

CREATE TABLE `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_terms1;

CREATE TABLE `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_terms2;

CREATE TABLE `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_terms3;

CREATE TABLE `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_terms4;

CREATE TABLE `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_terms5;

CREATE TABLE `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_terms6;

CREATE TABLE `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_terms7;

CREATE TABLE `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_terms8;

CREATE TABLE `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_terms9;

CREATE TABLE `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_termsa;

CREATE TABLE `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_termsb;

CREATE TABLE `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_termsc;

CREATE TABLE `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_termsd;

CREATE TABLE `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_termse;

CREATE TABLE `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_links_termsf;

CREATE TABLE `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_taxonomy;

CREATE TABLE `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO #__finder_taxonomy VALUES(1,0,'ROOT',0,0,0);



DROP TABLE IF EXISTS #__finder_taxonomy_map;

CREATE TABLE `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_terms;

CREATE TABLE `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_terms_common;

CREATE TABLE `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) DEFAULT CHARSET=utf8;

INSERT INTO #__finder_terms_common VALUES('a','en');
INSERT INTO #__finder_terms_common VALUES('about','en');
INSERT INTO #__finder_terms_common VALUES('after','en');
INSERT INTO #__finder_terms_common VALUES('ago','en');
INSERT INTO #__finder_terms_common VALUES('all','en');
INSERT INTO #__finder_terms_common VALUES('am','en');
INSERT INTO #__finder_terms_common VALUES('an','en');
INSERT INTO #__finder_terms_common VALUES('and','en');
INSERT INTO #__finder_terms_common VALUES('ani','en');
INSERT INTO #__finder_terms_common VALUES('any','en');
INSERT INTO #__finder_terms_common VALUES('are','en');
INSERT INTO #__finder_terms_common VALUES('aren\'t','en');
INSERT INTO #__finder_terms_common VALUES('as','en');
INSERT INTO #__finder_terms_common VALUES('at','en');
INSERT INTO #__finder_terms_common VALUES('be','en');
INSERT INTO #__finder_terms_common VALUES('but','en');
INSERT INTO #__finder_terms_common VALUES('by','en');
INSERT INTO #__finder_terms_common VALUES('for','en');
INSERT INTO #__finder_terms_common VALUES('from','en');
INSERT INTO #__finder_terms_common VALUES('get','en');
INSERT INTO #__finder_terms_common VALUES('go','en');
INSERT INTO #__finder_terms_common VALUES('how','en');
INSERT INTO #__finder_terms_common VALUES('if','en');
INSERT INTO #__finder_terms_common VALUES('in','en');
INSERT INTO #__finder_terms_common VALUES('into','en');
INSERT INTO #__finder_terms_common VALUES('is','en');
INSERT INTO #__finder_terms_common VALUES('isn\'t','en');
INSERT INTO #__finder_terms_common VALUES('it','en');
INSERT INTO #__finder_terms_common VALUES('its','en');
INSERT INTO #__finder_terms_common VALUES('me','en');
INSERT INTO #__finder_terms_common VALUES('more','en');
INSERT INTO #__finder_terms_common VALUES('most','en');
INSERT INTO #__finder_terms_common VALUES('must','en');
INSERT INTO #__finder_terms_common VALUES('my','en');
INSERT INTO #__finder_terms_common VALUES('new','en');
INSERT INTO #__finder_terms_common VALUES('no','en');
INSERT INTO #__finder_terms_common VALUES('none','en');
INSERT INTO #__finder_terms_common VALUES('not','en');
INSERT INTO #__finder_terms_common VALUES('noth','en');
INSERT INTO #__finder_terms_common VALUES('nothing','en');
INSERT INTO #__finder_terms_common VALUES('of','en');
INSERT INTO #__finder_terms_common VALUES('off','en');
INSERT INTO #__finder_terms_common VALUES('often','en');
INSERT INTO #__finder_terms_common VALUES('old','en');
INSERT INTO #__finder_terms_common VALUES('on','en');
INSERT INTO #__finder_terms_common VALUES('onc','en');
INSERT INTO #__finder_terms_common VALUES('once','en');
INSERT INTO #__finder_terms_common VALUES('onli','en');
INSERT INTO #__finder_terms_common VALUES('only','en');
INSERT INTO #__finder_terms_common VALUES('or','en');
INSERT INTO #__finder_terms_common VALUES('other','en');
INSERT INTO #__finder_terms_common VALUES('our','en');
INSERT INTO #__finder_terms_common VALUES('ours','en');
INSERT INTO #__finder_terms_common VALUES('out','en');
INSERT INTO #__finder_terms_common VALUES('over','en');
INSERT INTO #__finder_terms_common VALUES('page','en');
INSERT INTO #__finder_terms_common VALUES('she','en');
INSERT INTO #__finder_terms_common VALUES('should','en');
INSERT INTO #__finder_terms_common VALUES('small','en');
INSERT INTO #__finder_terms_common VALUES('so','en');
INSERT INTO #__finder_terms_common VALUES('some','en');
INSERT INTO #__finder_terms_common VALUES('than','en');
INSERT INTO #__finder_terms_common VALUES('thank','en');
INSERT INTO #__finder_terms_common VALUES('that','en');
INSERT INTO #__finder_terms_common VALUES('the','en');
INSERT INTO #__finder_terms_common VALUES('their','en');
INSERT INTO #__finder_terms_common VALUES('theirs','en');
INSERT INTO #__finder_terms_common VALUES('them','en');
INSERT INTO #__finder_terms_common VALUES('then','en');
INSERT INTO #__finder_terms_common VALUES('there','en');
INSERT INTO #__finder_terms_common VALUES('these','en');
INSERT INTO #__finder_terms_common VALUES('they','en');
INSERT INTO #__finder_terms_common VALUES('this','en');
INSERT INTO #__finder_terms_common VALUES('those','en');
INSERT INTO #__finder_terms_common VALUES('thus','en');
INSERT INTO #__finder_terms_common VALUES('time','en');
INSERT INTO #__finder_terms_common VALUES('times','en');
INSERT INTO #__finder_terms_common VALUES('to','en');
INSERT INTO #__finder_terms_common VALUES('too','en');
INSERT INTO #__finder_terms_common VALUES('true','en');
INSERT INTO #__finder_terms_common VALUES('under','en');
INSERT INTO #__finder_terms_common VALUES('until','en');
INSERT INTO #__finder_terms_common VALUES('up','en');
INSERT INTO #__finder_terms_common VALUES('upon','en');
INSERT INTO #__finder_terms_common VALUES('use','en');
INSERT INTO #__finder_terms_common VALUES('user','en');
INSERT INTO #__finder_terms_common VALUES('users','en');
INSERT INTO #__finder_terms_common VALUES('veri','en');
INSERT INTO #__finder_terms_common VALUES('version','en');
INSERT INTO #__finder_terms_common VALUES('very','en');
INSERT INTO #__finder_terms_common VALUES('via','en');
INSERT INTO #__finder_terms_common VALUES('want','en');
INSERT INTO #__finder_terms_common VALUES('was','en');
INSERT INTO #__finder_terms_common VALUES('way','en');
INSERT INTO #__finder_terms_common VALUES('were','en');
INSERT INTO #__finder_terms_common VALUES('what','en');
INSERT INTO #__finder_terms_common VALUES('when','en');
INSERT INTO #__finder_terms_common VALUES('where','en');
INSERT INTO #__finder_terms_common VALUES('whi','en');
INSERT INTO #__finder_terms_common VALUES('which','en');
INSERT INTO #__finder_terms_common VALUES('who','en');
INSERT INTO #__finder_terms_common VALUES('whom','en');
INSERT INTO #__finder_terms_common VALUES('whose','en');
INSERT INTO #__finder_terms_common VALUES('why','en');
INSERT INTO #__finder_terms_common VALUES('wide','en');
INSERT INTO #__finder_terms_common VALUES('will','en');
INSERT INTO #__finder_terms_common VALUES('with','en');
INSERT INTO #__finder_terms_common VALUES('within','en');
INSERT INTO #__finder_terms_common VALUES('without','en');
INSERT INTO #__finder_terms_common VALUES('would','en');
INSERT INTO #__finder_terms_common VALUES('yes','en');
INSERT INTO #__finder_terms_common VALUES('yet','en');
INSERT INTO #__finder_terms_common VALUES('you','en');
INSERT INTO #__finder_terms_common VALUES('your','en');
INSERT INTO #__finder_terms_common VALUES('yours','en');



DROP TABLE IF EXISTS #__finder_tokens;

CREATE TABLE `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_tokens_aggregate;

CREATE TABLE `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__finder_types;

CREATE TABLE `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__languages;

CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL DEFAULT '',
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_access` (`access`),
  KEY `idx_ordering` (`ordering`)
) AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

INSERT INTO #__languages VALUES(1,'en-GB','English (UK)','English (UK)','en','en','','','','',1,0,1);



DROP TABLE IF EXISTS #__menu;

CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) AUTO_INCREMENT=503 DEFAULT CHARSET=utf8;

INSERT INTO #__menu VALUES(1,'','Menu_Item_Root','root','','','','',1,0,0,0,0,0,'0000-00-00 00:00:00',0,0,'',0,'',0,347,0,'*',0);
INSERT INTO #__menu VALUES(2,'menu','com_banners','Banners','','Banners','index.php?option=com_banners','component',0,1,1,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',239,248,0,'*',1);
INSERT INTO #__menu VALUES(3,'menu','com_banners','Banners','','Banners/Banners','index.php?option=com_banners','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',240,241,0,'*',1);
INSERT INTO #__menu VALUES(4,'menu','com_banners_categories','Categories','','Banners/Categories','index.php?option=com_categories&extension=com_banners','component',0,2,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:banners-cat',0,'',242,243,0,'*',1);
INSERT INTO #__menu VALUES(5,'menu','com_banners_clients','Clients','','Banners/Clients','index.php?option=com_banners&view=clients','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners-clients',0,'',244,245,0,'*',1);
INSERT INTO #__menu VALUES(6,'menu','com_banners_tracks','Tracks','','Banners/Tracks','index.php?option=com_banners&view=tracks','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners-tracks',0,'',246,247,0,'*',1);
INSERT INTO #__menu VALUES(7,'menu','com_contact','Contacts','','Contacts','index.php?option=com_contact','component',0,1,1,8,0,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',249,254,0,'*',1);
INSERT INTO #__menu VALUES(8,'menu','com_contact','Contacts','','Contacts/Contacts','index.php?option=com_contact','component',0,7,2,8,0,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',250,251,0,'*',1);
INSERT INTO #__menu VALUES(9,'menu','com_contact_categories','Categories','','Contacts/Categories','index.php?option=com_categories&extension=com_contact','component',0,7,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:contact-cat',0,'',252,253,0,'*',1);
INSERT INTO #__menu VALUES(10,'menu','com_messages','Messaging','','Messaging','index.php?option=com_messages','component',0,1,1,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages',0,'',255,260,0,'*',1);
INSERT INTO #__menu VALUES(11,'menu','com_messages_add','New Private Message','','Messaging/New Private Message','index.php?option=com_messages&task=message.add','component',0,10,2,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages-add',0,'',256,257,0,'*',1);
INSERT INTO #__menu VALUES(12,'menu','com_messages_read','Read Private Message','','Messaging/Read Private Message','index.php?option=com_messages','component',0,10,2,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages-read',0,'',258,259,0,'*',1);
INSERT INTO #__menu VALUES(13,'menu','com_newsfeeds','News Feeds','','News Feeds','index.php?option=com_newsfeeds','component',0,1,1,17,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',261,266,0,'*',1);
INSERT INTO #__menu VALUES(14,'menu','com_newsfeeds_feeds','Feeds','','News Feeds/Feeds','index.php?option=com_newsfeeds','component',0,13,2,17,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',262,263,0,'*',1);
INSERT INTO #__menu VALUES(15,'menu','com_newsfeeds_categories','Categories','','News Feeds/Categories','index.php?option=com_categories&extension=com_newsfeeds','component',0,13,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds-cat',0,'',264,265,0,'*',1);
INSERT INTO #__menu VALUES(16,'menu','com_redirect','Redirect','','Redirect','index.php?option=com_redirect','component',0,1,1,24,0,0,'0000-00-00 00:00:00',0,0,'class:redirect',0,'',279,280,0,'*',1);
INSERT INTO #__menu VALUES(17,'menu','com_search','Basic Search','','Basic Search','index.php?option=com_search','component',0,1,1,19,0,0,'0000-00-00 00:00:00',0,0,'class:search',0,'',271,272,0,'*',1);
INSERT INTO #__menu VALUES(18,'menu','com_weblinks','Weblinks','','Weblinks','index.php?option=com_weblinks','component',0,1,1,21,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',273,278,0,'*',1);
INSERT INTO #__menu VALUES(19,'menu','com_weblinks_links','Links','','Weblinks/Links','index.php?option=com_weblinks','component',0,18,2,21,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',274,275,0,'*',1);
INSERT INTO #__menu VALUES(20,'menu','com_weblinks_categories','Categories','','Weblinks/Categories','index.php?option=com_categories&extension=com_weblinks','component',0,18,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks-cat',0,'',276,277,0,'*',1);
INSERT INTO #__menu VALUES(21,'menu','com_finder','Smart Search','','Smart Search','index.php?option=com_finder','component',0,1,1,27,0,0,'0000-00-00 00:00:00',0,0,'class:finder',0,'',267,268,0,'*',1);
INSERT INTO #__menu VALUES(22,'menu','com_joomlaupdate','Joomla! Update','','Joomla! Update','index.php?option=com_joomlaupdate','component',0,1,1,28,0,0,'0000-00-00 00:00:00',0,0,'class:joomlaupdate',0,'',269,270,0,'*',1);
INSERT INTO #__menu VALUES(201,'usermenu','Your Profile','your-profile','','your-profile','index.php?option=com_users&view=profile','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,2,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',287,288,0,'*',0);
INSERT INTO #__menu VALUES(207,'top','Joomla.org','joomlaorg','','joomlaorg','http://joomla.org','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}',285,286,0,'*',0);
INSERT INTO #__menu VALUES(227,'aboutjoomla','Weblinks Categories','weblinks-categories','','using-joomla/extensions/components/weblinks-component/weblinks-categories','index.php?option=com_weblinks&view=categories&id=18','component',1,265,5,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',55,56,0,'*',0);
INSERT INTO #__menu VALUES(229,'aboutjoomla','Single Contact','single-contact','','using-joomla/extensions/components/contact-component/single-contact','index.php?option=com_contact&view=contact&id=1','component',1,270,5,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_crumb\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',45,46,0,'*',0);
INSERT INTO #__menu VALUES(233,'mainmenu','Login','login','','login','index.php?option=com_users&view=login','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',237,238,0,'*',0);
INSERT INTO #__menu VALUES(234,'parks','Park Blog','park-blog','','park-blog','index.php?option=com_content&view=category&layout=blog&id=27','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',114,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',291,292,0,'en-GB',0);
INSERT INTO #__menu VALUES(238,'mainmenu','Sample Sites','sample-sites','','sample-sites','index.php?option=com_content&view=article&id=38','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',315,320,0,'*',0);
INSERT INTO #__menu VALUES(242,'parks','Write a Blog Post','write-a-blog-post','','write-a-blog-post','index.php?option=com_content&view=form&layout=edit','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,3,'',114,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',293,294,0,'en-GB',0);
INSERT INTO #__menu VALUES(243,'parks','Parks Home','parks-home','','parks-home','index.php?option=com_content&view=article&id=6','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',114,'{\"show_noauth\":\"\",\"show_title\":\"0\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',289,290,0,'en-GB',0);
INSERT INTO #__menu VALUES(244,'parks','Image Gallery','image-gallery','','image-gallery','index.php?option=com_content&view=categories&id=28','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',114,'{\"show_base_description\":\"1\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"drill_down_layout\":\"1\",\"show_category_title\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',295,300,0,'en-GB',0);
INSERT INTO #__menu VALUES(249,'aboutjoomla','Submit a Weblink','submit-a-weblink','','using-joomla/extensions/components/weblinks-component/submit-a-weblink','index.php?option=com_weblinks&view=form&layout=edit','component',1,265,5,21,0,0,'0000-00-00 00:00:00',0,3,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',51,52,0,'*',0);
INSERT INTO #__menu VALUES(251,'aboutjoomla','Contact Categories','contact-categories','','using-joomla/extensions/components/contact-component/contact-categories','index.php?option=com_contact&view=categories&id=16','component',1,270,5,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"filter_field\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"presentation_style\":\"sliders\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"1\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',41,42,0,'*',0);
INSERT INTO #__menu VALUES(252,'aboutjoomla','News Feed Categories','new-feed-categories','','using-joomla/extensions/components/news-feeds-component/new-feed-categories','index.php?option=com_newsfeeds&view=categories&id=0','component',1,267,5,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"1\",\"categories_description\":\"Because this links to the root category the \"uncategorised\" category is displayed. \",\"maxLevel\":\"-1\",\"show_empty_categories\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"show_cat_num_articles\":\"1\",\"display_num\":\"\",\"show_headings\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',59,60,0,'*',0);
INSERT INTO #__menu VALUES(253,'aboutjoomla','News Feed Category','news-feed-category','','using-joomla/extensions/components/news-feeds-component/news-feed-category','index.php?option=com_newsfeeds&view=category&id=17','component',1,267,5,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',63,64,0,'*',0);
INSERT INTO #__menu VALUES(254,'aboutjoomla','Single News Feed','single-news-feed','','using-joomla/extensions/components/news-feeds-component/single-news-feed','index.php?option=com_newsfeeds&view=newsfeed&id=4','component',1,267,5,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',61,62,0,'*',0);
INSERT INTO #__menu VALUES(255,'aboutjoomla','Search','search','','using-joomla/extensions/components/search-component/search','index.php?option=com_search&view=search','component',1,276,5,19,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"search_areas\":\"1\",\"show_date\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',81,82,0,'*',0);
INSERT INTO #__menu VALUES(256,'aboutjoomla','Archived Articles','archived-articles','','using-joomla/extensions/components/content-component/archived-articles','index.php?option=com_content&view=archive','component',1,266,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"orderby_sec\":\"\",\"order_date\":\"\",\"display_num\":\"\",\"filter_field\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',35,36,0,'*',0);
INSERT INTO #__menu VALUES(257,'aboutjoomla','Single Article','single-article','','using-joomla/extensions/components/content-component/single-article','index.php?option=com_content&view=article&id=6','component',1,266,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',25,26,0,'*',0);
INSERT INTO #__menu VALUES(259,'aboutjoomla','Article Category Blog','article-category-blog','','using-joomla/extensions/components/content-component/article-category-blog','index.php?option=com_content&view=category&layout=blog&id=27','component',1,266,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',29,30,0,'*',0);
INSERT INTO #__menu VALUES(260,'aboutjoomla','Article Category List','article-category-list','','using-joomla/extensions/components/content-component/article-category-list','index.php?option=com_content&view=category&id=19','component',1,266,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"alpha\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',31,32,0,'*',0);
INSERT INTO #__menu VALUES(262,'aboutjoomla','Featured Articles','featured-articles','','using-joomla/extensions/components/content-component/featured-articles','index.php?option=com_content&view=featured','component',1,266,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',33,34,0,'*',0);
INSERT INTO #__menu VALUES(263,'aboutjoomla','Submit Article','submit-article','','using-joomla/extensions/components/content-component/submit-article','index.php?option=com_content&view=form&layout=edit','component',1,266,5,22,0,0,'0000-00-00 00:00:00',0,3,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',37,38,0,'*',0);
INSERT INTO #__menu VALUES(265,'aboutjoomla','Weblinks Component','weblinks-component','','using-joomla/extensions/components/weblinks-component','index.php?option=com_content&view=article&id=54','component',1,268,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',50,57,0,'*',0);
INSERT INTO #__menu VALUES(266,'aboutjoomla','Content Component','content-component','','using-joomla/extensions/components/content-component','index.php?option=com_content&view=article&id=10','component',1,268,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"article-allow_ratings\":\"\",\"article-allow_comments\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',24,39,0,'*',0);
INSERT INTO #__menu VALUES(267,'aboutjoomla','News Feeds Component','news-feeds-component','','using-joomla/extensions/components/news-feeds-component','index.php?option=com_content&view=article&id=60','component',1,268,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"Newsfeeds Categories View \",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',58,65,0,'*',0);
INSERT INTO #__menu VALUES(268,'aboutjoomla','Components','components','','using-joomla/extensions/components','index.php?option=com_content&view=category&layout=blog&id=21','component',1,277,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"7\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"0\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_readmore\":\"\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',23,88,0,'*',0);
INSERT INTO #__menu VALUES(270,'aboutjoomla','Contact Component','contact-component','','using-joomla/extensions/components/contact-component','index.php?option=com_content&view=article&id=9','component',1,268,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',40,49,0,'*',0);
INSERT INTO #__menu VALUES(271,'aboutjoomla','Users Component','users-component','','using-joomla/extensions/components/users-component','index.php?option=com_content&view=article&id=52','component',1,268,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',66,79,0,'*',0);
INSERT INTO #__menu VALUES(272,'aboutjoomla','Article Categories','article-categories','','using-joomla/extensions/components/content-component/article-categories','index.php?option=com_content&view=categories&id=14','component',1,266,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"category_layout\":\"\",\"show_headings\":\"\",\"show_date\":\"\",\"date_format\":\"\",\"filter_field\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',27,28,0,'*',0);
INSERT INTO #__menu VALUES(273,'aboutjoomla','Administrator Components','administrator-components','','using-joomla/extensions/components/administrator-components','index.php?option=com_content&view=article&id=1','component',1,268,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',86,87,0,'*',0);
INSERT INTO #__menu VALUES(274,'aboutjoomla','Weblinks Single Category','weblinks-single-category','','using-joomla/extensions/components/weblinks-component/weblinks-single-category','index.php?option=com_weblinks&view=category&id=32','component',1,265,5,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"orderby_pri\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',53,54,0,'*',0);
INSERT INTO #__menu VALUES(275,'aboutjoomla','Contact Single Category','contact-single-category','','using-joomla/extensions/components/contact-component/contact-single-category','index.php?option=com_contact&view=category&catid=26&id=36','component',1,270,5,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"20\",\"show_headings\":\"\",\"filter_field\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"presentation_style\":\"sliders\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"1\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',43,44,0,'*',0);
INSERT INTO #__menu VALUES(276,'aboutjoomla','Search Components','search-component','','using-joomla/extensions/components/search-component','index.php?option=com_content&view=article&id=39','component',1,268,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',80,85,0,'*',0);
INSERT INTO #__menu VALUES(277,'aboutjoomla','Using Extensions','extensions','','using-joomla/extensions','index.php?option=com_content&view=categories&id=20','component',1,280,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"1\",\"categories_description\":\"\",\"maxLevelcat\":\"1\",\"show_empty_categories_cat\":\"1\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"0\",\"drill_down_layout\":\"0\",\"show_category_title\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"1\",\"show_empty_categories\":\"1\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',22,187,0,'*',0);
INSERT INTO #__menu VALUES(278,'aboutjoomla','The Joomla! Project','the-joomla-project','','the-joomla-project','index.php?option=com_content&view=article&id=48','component',0,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"1\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"1\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',203,204,0,'*',0);
INSERT INTO #__menu VALUES(279,'aboutjoomla','The Joomla! Community','the-joomla-community','','the-joomla-community','index.php?option=com_content&view=article&id=47','component',0,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"0\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',205,206,0,'*',0);
INSERT INTO #__menu VALUES(280,'aboutjoomla','Subpage','using-joomla','','using-joomla','index.php?option=com_content&view=article&id=53','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"1\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',21,194,0,'*',0);
INSERT INTO #__menu VALUES(281,'aboutjoomla','Modules','modules','','using-joomla/extensions/modules','index.php?option=com_content&view=category&id=22','component',1,277,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"1\",\"show_empty_categories\":\"1\",\"show_no_articles\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"1\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"\",\"show_readmore\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',89,148,0,'*',0);
INSERT INTO #__menu VALUES(282,'aboutjoomla','Templates','templates','','using-joomla/extensions/templates','index.php?option=com_content&view=category&id=23','component',1,277,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"maxLevel\":\"2\",\"show_empty_categories\":\"1\",\"show_no_articles\":\"0\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"0\",\"filter_field\":\"hide\",\"show_headings\":\"0\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"0\",\"list_show_author\":\"0\",\"show_pagination\":\"0\",\"show_pagination_results\":\"\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"Templates\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',149,168,0,'*',0);
INSERT INTO #__menu VALUES(283,'aboutjoomla','Languages','languages','','using-joomla/extensions/languages','index.php?option=com_content&view=category&layout=blog&id=24','component',1,277,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"show_category_title\":\"1\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',169,170,0,'*',0);
INSERT INTO #__menu VALUES(284,'aboutjoomla','Plugins','plugins','','using-joomla/extensions/plugins','index.php?option=com_content&view=category&layout=blog&id=25','component',1,277,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_category_title\":\"1\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"7\",\"num_columns\":\"1\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',171,186,0,'*',0);
INSERT INTO #__menu VALUES(285,'aboutjoomla','Typography Atomic','typography-atomic','','using-joomla/extensions/templates/atomic/typography-atomic','index.php?option=com_content&view=article&id=49','component',1,422,5,22,0,0,'0000-00-00 00:00:00',0,1,'',3,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',163,164,0,'*',0);
INSERT INTO #__menu VALUES(290,'mainmenu','Articles','articles','','site-map/articles','index.php?option=com_content&view=categories&id=0','component',1,294,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories_description\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"category_layout\":\"\",\"show_headings\":\"\",\"show_date\":\"\",\"date_format\":\"\",\"filter_field\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"article-allow_ratings\":\"\",\"article-allow_comments\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',196,197,0,'*',0);
INSERT INTO #__menu VALUES(294,'mainmenu','Site Map','site-map','','site-map','index.php?option=com_content&view=article&id=42','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',195,202,0,'*',0);
INSERT INTO #__menu VALUES(296,'parks','Park Links','park-links','','park-links','index.php?option=com_weblinks&view=category&id=31','component',1,1,1,21,0,0,'0000-00-00 00:00:00',0,1,'',114,'{\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"0\",\"orderby_pri\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',301,302,0,'en-GB',0);
INSERT INTO #__menu VALUES(300,'aboutjoomla','Latest Users','latest-users','','using-joomla/extensions/modules/user-modules/latest-users','index.php?option=com_content&view=article&id=66','component',1,412,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',113,114,0,'*',0);
INSERT INTO #__menu VALUES(301,'aboutjoomla','Who\'s Online','whos-online','','using-joomla/extensions/modules/user-modules/whos-online','index.php?option=com_content&view=article&id=56','component',1,412,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',115,116,0,'*',0);
INSERT INTO #__menu VALUES(302,'aboutjoomla','Most Read','most-read','','using-joomla/extensions/modules/content-modules/most-read','index.php?option=com_content&view=article&id=30','component',1,411,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',97,98,0,'*',0);
INSERT INTO #__menu VALUES(303,'aboutjoomla','Menu','menu','','using-joomla/extensions/modules/navigation-modules/menu','index.php?option=com_content&view=article&id=29','component',1,415,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',91,92,0,'*',0);
INSERT INTO #__menu VALUES(304,'aboutjoomla','Statistics','statistics','','using-joomla/extensions/modules/utility-modules/statistics','index.php?option=com_content&view=article&id=44','component',1,414,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',137,138,0,'*',0);
INSERT INTO #__menu VALUES(305,'aboutjoomla','Banner','banner','','using-joomla/extensions/modules/display-modules/banner','index.php?option=com_content&view=article&id=7','component',1,413,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',123,124,0,'*',0);
INSERT INTO #__menu VALUES(306,'aboutjoomla','Search','search','','using-joomla/extensions/modules/utility-modules/search','index.php?option=com_content&view=article&id=40','component',1,414,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',139,140,0,'*',0);
INSERT INTO #__menu VALUES(307,'aboutjoomla','Random Image','random-image','','using-joomla/extensions/modules/display-modules/random-image','index.php?option=com_content&view=article&id=36','component',1,413,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',121,122,0,'*',0);
INSERT INTO #__menu VALUES(309,'aboutjoomla','News Flash','news-flash','','using-joomla/extensions/modules/content-modules/news-flash','index.php?option=com_content&view=article&id=31','component',1,411,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',99,100,0,'*',0);
INSERT INTO #__menu VALUES(310,'aboutjoomla','Latest Articles','latest-articles','','using-joomla/extensions/modules/content-modules/latest-articles','index.php?option=com_content&view=article&id=27','component',1,411,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',101,102,0,'*',0);
INSERT INTO #__menu VALUES(311,'aboutjoomla','Syndicate','syndicate','','using-joomla/extensions/modules/utility-modules/syndicate','index.php?option=com_content&view=article&id=45','component',1,414,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',135,136,0,'*',0);
INSERT INTO #__menu VALUES(312,'aboutjoomla','Login','login','','using-joomla/extensions/modules/user-modules/login','index.php?option=com_content&view=article&id=28','component',1,412,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',117,118,0,'*',0);
INSERT INTO #__menu VALUES(313,'aboutjoomla','Wrapper','wrapper','','using-joomla/extensions/modules/utility-modules/wrapper','index.php?option=com_content&view=article&id=59','component',1,414,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',143,144,0,'*',0);
INSERT INTO #__menu VALUES(316,'aboutjoomla','Home Page Atomic','home-page-atomic','','using-joomla/extensions/templates/atomic/home-page-atomic','index.php?option=com_content&view=featured','component',1,422,5,22,0,0,'0000-00-00 00:00:00',0,1,'',3,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',165,166,0,'*',0);
INSERT INTO #__menu VALUES(317,'aboutjoomla','System','system','','using-joomla/extensions/plugins/system','index.php?option=com_content&view=article&id=46','component',1,284,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',184,185,0,'*',0);
INSERT INTO #__menu VALUES(318,'aboutjoomla','Authentication','authentication','','using-joomla/extensions/plugins/authentication','index.php?option=com_content&view=article&id=5','component',1,284,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',172,173,0,'*',0);
INSERT INTO #__menu VALUES(319,'aboutjoomla','Content','content','','using-joomla/extensions/plugins/content','index.php?option=com_content&view=article&id=62','component',1,284,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',174,175,0,'*',0);
INSERT INTO #__menu VALUES(320,'aboutjoomla','Editors','editors','','using-joomla/extensions/plugins/editors','index.php?option=com_content&view=article&id=14','component',1,284,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',176,177,0,'*',0);
INSERT INTO #__menu VALUES(321,'aboutjoomla','Editors Extended','editors-extended','','using-joomla/extensions/plugins/editors-extended','index.php?option=com_content&view=article&id=15','component',1,284,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',178,179,0,'*',0);
INSERT INTO #__menu VALUES(322,'aboutjoomla','Search','search','','using-joomla/extensions/plugins/search','index.php?option=com_content&view=article&id=41','component',1,284,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',180,181,0,'*',0);
INSERT INTO #__menu VALUES(323,'aboutjoomla','User','user','','using-joomla/extensions/plugins/user','index.php?option=com_content&view=article&id=51','component',1,284,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',182,183,0,'*',0);
INSERT INTO #__menu VALUES(324,'aboutjoomla','Footer','footer','','using-joomla/extensions/modules/display-modules/footer','index.php?option=com_content&view=article&id=19','component',1,413,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',127,128,0,'*',0);
INSERT INTO #__menu VALUES(325,'aboutjoomla','Archive','archive','','using-joomla/extensions/modules/content-modules/archive','index.php?option=com_content&view=article&id=2','component',1,411,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',103,104,0,'*',0);
INSERT INTO #__menu VALUES(326,'aboutjoomla','Related Items','related-items','','using-joomla/extensions/modules/content-modules/related-items','index.php?option=com_content&view=article&id=37','component',1,411,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',105,106,0,'*',0);
INSERT INTO #__menu VALUES(399,'parks','Animals','animals','','image-gallery/animals','index.php?option=com_content&view=category&layout=blog&id=72','component',1,244,2,22,0,0,'0000-00-00 00:00:00',0,1,'',114,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"0\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"6\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"0\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"1\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',296,297,0,'en-GB',0);
INSERT INTO #__menu VALUES(400,'parks','Scenery','scenery','','image-gallery/scenery','index.php?option=com_content&view=category&layout=blog&id=73','component',1,244,2,22,0,0,'0000-00-00 00:00:00',0,1,'',114,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"0\",\"show_category\":\"1\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"1\",\"show_readmore\":\"1\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',298,299,0,'en-GB',0);
INSERT INTO #__menu VALUES(402,'aboutjoomla','Login Form','login-form','','using-joomla/extensions/components/users-component/login-form','index.php?option=com_users&view=login','component',1,271,5,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',67,68,0,'*',0);
INSERT INTO #__menu VALUES(403,'aboutjoomla','User Profile','user-profile','','using-joomla/extensions/components/users-component/user-profile','index.php?option=com_users&view=profile','component',1,271,5,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',69,70,0,'*',0);
INSERT INTO #__menu VALUES(404,'aboutjoomla','Edit User Profile','edit-user-profile','','using-joomla/extensions/components/users-component/edit-user-profile','index.php?option=com_users&view=profile&layout=edit','component',1,271,5,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',71,72,0,'*',0);
INSERT INTO #__menu VALUES(405,'aboutjoomla','Registration Form','registration-form','','using-joomla/extensions/components/users-component/registration-form','index.php?option=com_users&view=registration','component',1,271,5,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',73,74,0,'*',0);
INSERT INTO #__menu VALUES(406,'aboutjoomla','Username Reminder Request','username-reminder','','using-joomla/extensions/components/users-component/username-reminder','index.php?option=com_users&view=remind','component',1,271,5,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',75,76,0,'*',0);
INSERT INTO #__menu VALUES(409,'aboutjoomla','Password Reset','password-reset','','using-joomla/extensions/components/users-component/password-reset','index.php?option=com_users&view=reset','component',1,271,5,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',77,78,0,'*',0);
INSERT INTO #__menu VALUES(410,'aboutjoomla','Feed Display','feed-display','','using-joomla/extensions/modules/display-modules/feed-display','index.php?option=com_content&view=article&id=16','component',1,413,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',125,126,0,'*',0);
INSERT INTO #__menu VALUES(411,'aboutjoomla','Content Modules','content-modules','','using-joomla/extensions/modules/content-modules','index.php?option=com_content&view=category&id=64','component',1,281,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"0\",\"show_category_title\":\"1\",\"page_subheading\":\"\",\"show_empty_categories\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"0\",\"show_headings\":\"0\",\"list_show_title\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"0\",\"list_show_author\":\"0\",\"filter_field\":\"hide\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"0\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',96,111,0,'*',0);
INSERT INTO #__menu VALUES(412,'aboutjoomla','User Modules','user-modules','','using-joomla/extensions/modules/user-modules','index.php?option=com_content&view=category&id=65','component',1,281,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"0\",\"show_category_title\":\"1\",\"page_subheading\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"0\",\"show_headings\":\"0\",\"list_show_title\":\"1\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"0\",\"list_show_author\":\"0\",\"filter_field\":\"hide\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"0\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',112,119,0,'*',0);
INSERT INTO #__menu VALUES(413,'aboutjoomla','Display Modules','display-modules','','using-joomla/extensions/modules/display-modules','index.php?option=com_content&view=category&id=66','component',1,281,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"0\",\"show_category_title\":\"1\",\"page_subheading\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"show_cat_num_articles\":\"\",\"display_num\":\"0\",\"show_headings\":\"0\",\"list_show_title\":\"1\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"0\",\"list_show_author\":\"0\",\"filter_field\":\"hide\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"0\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',120,133,0,'*',0);
INSERT INTO #__menu VALUES(414,'aboutjoomla','Utility Modules','utility-modules','','using-joomla/extensions/modules/utility-modules','index.php?option=com_content&view=category&id=67','component',1,281,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"0\",\"show_category_title\":\"1\",\"page_subheading\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"show_cat_num_articles\":\"\",\"display_num\":\"0\",\"show_headings\":\"0\",\"list_show_title\":\"0\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"0\",\"list_show_author\":\"0\",\"filter_field\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"order\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"0\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',134,147,0,'*',0);
INSERT INTO #__menu VALUES(415,'aboutjoomla','Navigation Modules','navigation-modules','','using-joomla/extensions/modules/navigation-modules','index.php?option=com_content&view=category&id=75','component',1,281,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"\",\"show_category_title\":\"\",\"page_subheading\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"list_show_title\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"filter_field\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',90,95,0,'*',0);
INSERT INTO #__menu VALUES(416,'aboutjoomla','Breadcrumbs','breadcrumbs','','using-joomla/extensions/modules/navigation-modules/breadcrumbs','index.php?option=com_content&view=article&id=61','component',1,415,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',93,94,0,'*',0);
INSERT INTO #__menu VALUES(417,'aboutjoomla','Weblinks','weblinks','','using-joomla/extensions/modules/display-modules/weblinks','index.php?option=com_content&view=article&id=55','component',1,413,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',129,130,0,'*',0);
INSERT INTO #__menu VALUES(418,'aboutjoomla','Custom HTML','custom-html','','using-joomla/extensions/modules/display-modules/custom-html','index.php?option=com_content&view=article&id=12','component',1,413,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',131,132,0,'*',0);
INSERT INTO #__menu VALUES(419,'aboutjoomla','Beez 2','beez-2','','using-joomla/extensions/templates/beez-2','index.php?option=com_content&view=category&layout=blog&id=69','component',1,282,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',150,155,0,'*',0);
INSERT INTO #__menu VALUES(422,'aboutjoomla','Atomic','atomic','','using-joomla/extensions/templates/atomic','index.php?option=com_content&view=category&layout=blog&id=68','component',1,282,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"2\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',162,167,0,'*',0);
INSERT INTO #__menu VALUES(423,'aboutjoomla','Typography Beez 2','typography-beez-2','','using-joomla/extensions/templates/beez-2/typography-beez-2','index.php?option=com_content&view=article&id=49','component',1,419,5,22,0,0,'0000-00-00 00:00:00',0,1,'',4,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',151,152,0,'*',0);
INSERT INTO #__menu VALUES(424,'aboutjoomla','Home Page Beez 2','home-page-beez-2','','using-joomla/extensions/templates/beez-2/home-page-beez-2','index.php?option=com_content&view=featured','component',1,419,5,22,0,0,'0000-00-00 00:00:00',0,1,'',4,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"2\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',153,154,0,'*',0);
INSERT INTO #__menu VALUES(427,'fruitshop','Fruit Encyclopedia','fruit-encyclopedia','','fruit-encyclopedia','index.php?option=com_contact&view=categories&id=37','component',1,1,1,8,0,0,'0000-00-00 00:00:00',0,1,'',6,'{\"show_base_description\":\"1\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"1\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"0\",\"show_position_headings\":\"\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"0\",\"show_mobile_headings\":\"0\",\"show_fax_headings\":\"0\",\"show_suburb_headings\":\"0\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"1\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\" categories-listalphabet\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',305,306,0,'*',0);
INSERT INTO #__menu VALUES(429,'fruitshop','Welcome','welcome','Fruit store front page','welcome','index.php?option=com_content&view=article&id=20','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',6,'{\"show_noauth\":\"\",\"show_title\":\"0\",\"link_titles\":\"0\",\"show_intro\":\"1\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',303,304,0,'*',0);
INSERT INTO #__menu VALUES(430,'fruitshop','Contact Us','contact-us','','contact-us','index.php?option=com_contact&view=category&catid=47&id=36','component',1,1,1,8,0,0,'0000-00-00 00:00:00',0,1,'',6,'{\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"20\",\"show_headings\":\"0\",\"filter_field\":\"hide\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"1\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',309,310,0,'*',0);
INSERT INTO #__menu VALUES(431,'fruitshop','Growers','growers','','growers','index.php?option=com_content&view=category&layout=blog&id=30','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',6,'{\"maxLevel\":\"0\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_category_title\":\"1\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"5\",\"num_intro_articles\":\"0\",\"num_columns\":\"1\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"alpha\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',307,308,0,'*',0);
INSERT INTO #__menu VALUES(432,'fruitshop','Login ','shop-login','','shop-login','index.php?option=com_users&view=login','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,1,'',6,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',311,312,0,'*',0);
INSERT INTO #__menu VALUES(433,'fruitshop','Directions','directions','','directions','index.php?option=com_content&view=article&id=13','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',6,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',313,314,0,'*',0);
INSERT INTO #__menu VALUES(435,'aboutjoomla','Home','homepage','','homepage','index.php?option=com_content&view=featured','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"2\",\"num_columns\":\"2\",\"num_links\":\"0\",\"multi_column_order\":\"1\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"0\",\"show_pagination_results\":\"0\",\"show_title\":\"1\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"0\",\"link_author\":\"0\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"\",\"show_readmore\":\"1\",\"show_readmore_title\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"show_feed_link\":\"1\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',1,2,1,'*',0);
INSERT INTO #__menu VALUES(436,'aboutjoomla','Getting Help','getting-help','','using-joomla/getting-help','index.php?option=com_content&view=article&id=21','component',1,280,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',190,191,0,'*',0);
INSERT INTO #__menu VALUES(437,'aboutjoomla','Getting Started','getting-started','','getting-started','index.php?option=com_content&view=article&id=22','component',0,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"1\",\"link_titles\":\"0\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',3,4,0,'*',0);
INSERT INTO #__menu VALUES(438,'mainmenu','Weblinks','weblinks','','site-map/weblinks','index.php?option=com_weblinks&view=categories&id=0','component',1,294,2,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories_description\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"orderby_pri\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"article-allow_ratings\":\"\",\"article-allow_comments\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',198,199,0,'*',0);
INSERT INTO #__menu VALUES(439,'mainmenu','Contacts','contacts','','site-map/contacts','index.php?option=com_contact&view=categories&id=0','component',1,294,2,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories_description\":\"\",\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"filter_field\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"1\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"article-allow_ratings\":\"\",\"article-allow_comments\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',200,201,0,'*',0);
INSERT INTO #__menu VALUES(443,'aboutjoomla','Article Categories','article-categories-view','','using-joomla/extensions/modules/content-modules/article-categories-view','index.php?option=com_content&view=article&id=3','component',1,411,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',107,108,0,'*',0);
INSERT INTO #__menu VALUES(444,'top','Sample Sites','sample-sites-2','','sample-sites-2','index.php?Itemid=','alias',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"aliasoptions\":\"238\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}',283,284,0,'*',0);
INSERT INTO #__menu VALUES(445,'mainmenu','Parks','parks','','sample-sites/parks','index.php?Itemid=','alias',1,238,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"aliasoptions\":\"243\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}',316,317,0,'*',0);
INSERT INTO #__menu VALUES(446,'mainmenu','Shop','shop','','sample-sites/shop','index.php?Itemid=','alias',1,238,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"aliasoptions\":\"429\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}',318,319,0,'*',0);
INSERT INTO #__menu VALUES(447,'aboutjoomla','Language Switcher','language-switcher','','using-joomla/extensions/modules/utility-modules/language-switcher','index.php?option=com_content&view=article&id=26','component',1,414,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',141,142,0,'*',0);
INSERT INTO #__menu VALUES(448,'mainmenu','Site Administrator','site-administrator','','site-administrator','administrator','url',1,1,1,0,0,0,'0000-00-00 00:00:00',1,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}',321,322,0,'*',0);
INSERT INTO #__menu VALUES(449,'usermenu','Submit an Article','submit-an-article','','submit-an-article','index.php?option=com_content&view=form&layout=edit','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,3,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',323,324,0,'*',0);
INSERT INTO #__menu VALUES(450,'usermenu','Submit a Web Link','submit-a-web-link','','submit-a-web-link','index.php?option=com_weblinks&view=form&layout=edit','component',1,1,1,21,0,0,'0000-00-00 00:00:00',0,3,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',325,326,0,'*',0);
INSERT INTO #__menu VALUES(452,'aboutjoomla','Featured Contacts','featured-contacts','','using-joomla/extensions/components/contact-component/featured-contacts','index.php?option=com_contact&view=featured&id=16','component',1,270,5,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"-1\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"filter_field\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"presentation_style\":\"sliders\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"1\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',47,48,0,'*',0);
INSERT INTO #__menu VALUES(453,'aboutjoomla','Parameters','parameters','','using-joomla/parameters','index.php?option=com_content&view=article&id=32','component',1,280,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"1\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_category\":\"1\",\"link_category\":\"1\",\"show_parent_category\":\"1\",\"link_parent_category\":\"1\",\"show_author\":\"1\",\"link_author\":\"1\",\"show_create_date\":\"1\",\"show_modify_date\":\"1\",\"show_publish_date\":\"1\",\"show_item_navigation\":\"1\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"1\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',188,189,0,'*',0);
INSERT INTO #__menu VALUES(455,'mainmenu','Example Pages','example-pages','','example-pages','index.php?Itemid=','alias',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"aliasoptions\":\"268\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}',327,328,0,'*',0);
INSERT INTO #__menu VALUES(456,'aboutjoomla','Beez5','beez5','','using-joomla/extensions/templates/beez5','index.php?option=com_content&view=category&layout=blog&id=70','component',1,282,4,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_category_title\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',156,161,0,'*',0);
INSERT INTO #__menu VALUES(457,'aboutjoomla','Typography Beez5','typography-beez-5','','using-joomla/extensions/templates/beez5/typography-beez-5','index.php?option=com_content&view=article&id=49','component',1,456,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',157,158,0,'*',0);
INSERT INTO #__menu VALUES(458,'aboutjoomla','Home Page Beez5','home-page-beez5','','using-joomla/extensions/templates/beez5/home-page-beez5','index.php?option=com_content&view=featured','component',1,456,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"3\",\"num_columns\":\"3\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"front\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',159,160,0,'*',0);
INSERT INTO #__menu VALUES(459,'aboutjoomla','Article Category','article-category','','using-joomla/extensions/modules/content-modules/article-category','index.php?option=com_content&view=article&id=4','component',1,411,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"robots\":\"\",\"rights\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"secure\":0}',109,110,0,'*',0);
INSERT INTO #__menu VALUES(462,'fruitshop','Add a recipe','add-a-recipe','','add-a-recipe','index.php?option=com_content&view=form&layout=edit','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,4,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":1,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',329,330,0,'*',0);
INSERT INTO #__menu VALUES(463,'fruitshop','Recipes','recipes','','recipes','index.php?option=com_content&view=category&id=76','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',6,'{\"maxLevel\":\"0\",\"show_category_title\":\"1\",\"page_subheading\":\"\",\"show_empty_categories\":\"0\",\"show_description\":\"1\",\"show_description_image\":\"\",\"show_cat_num_articles\":\"\",\"display_num\":\"\",\"show_headings\":\"\",\"list_show_title\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"filter_field\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_limit\":\"\",\"show_noauth\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_readmore\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"show_page_heading\":0,\"page_title\":\"\",\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',331,332,0,'*',0);
INSERT INTO #__menu VALUES(464,'top','Home','home','','home','index.php?Itemid=','alias',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"aliasoptions\":\"435\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}',281,282,0,'*',0);
INSERT INTO #__menu VALUES(466,'aboutjoomla','Smart Search','smart-search','','using-joomla/extensions/components/search-component/smart-search','index.php?option=com_finder&view=search&q=&f=','component',1,276,5,27,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_date_filters\":\"\",\"show_advanced\":\"\",\"expand_advanced\":\"\",\"show_description\":\"\",\"description_length\":255,\"show_url\":\"\",\"show_pagination_limit\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"allow_empty_query\":\"0\",\"search_order\":\"\",\"show_feed\":\"0\",\"show_feed_text\":\"0\",\"show_feed_link\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',83,84,0,'*',0);
INSERT INTO #__menu VALUES(467,'aboutjoomla','Smart Search','smart-search','','using-joomla/extensions/modules/utility-modules/smart-search','index.php?option=com_content&view=article&id=70','component',1,414,5,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',145,146,0,'*',0);
INSERT INTO #__menu VALUES(468,'main','COM_DJIMAGESLIDER','com-djimageslider','','com-djimageslider','index.php?option=com_djimageslider','component',0,1,1,10002,0,0,'0000-00-00 00:00:00',0,1,'components/com_djimageslider/assets/icon-16-djimageslider.png',0,'',333,338,0,'',1);
INSERT INTO #__menu VALUES(469,'main','COM_DJIMAGESLIDER_SLIDES','com-djimageslider-slides','','com-djimageslider/com-djimageslider-slides','index.php?option=com_djimageslider&view=items','component',0,468,2,10002,0,0,'0000-00-00 00:00:00',0,1,'components/com_djimageslider/assets/icon-16-menu-slides.png',0,'',334,335,0,'',1);
INSERT INTO #__menu VALUES(470,'main','COM_DJIMAGESLIDER_CATEGORIES','com-djimageslider-categories','','com-djimageslider/com-djimageslider-categories','index.php?option=com_categories&extension=com_djimageslider','component',0,468,2,10002,0,0,'0000-00-00 00:00:00',0,1,'class:category',0,'',336,337,0,'',1);
INSERT INTO #__menu VALUES(471,'main','COM_DJCLASSIFIEDS','com-djclassifieds','','com-djclassifieds','index.php?option=com_djclassifieds','component',0,1,1,10005,0,0,'0000-00-00 00:00:00',0,1,'components/com_djclassifieds/images/icon-16-djclassifieds.png',0,'',339,340,0,'',1);
INSERT INTO #__menu VALUES(472,'aboutjoomla','DJ-Classifieds','dj-classifieds','','dj-classifieds','index.php?option=com_djclassifieds&view=items&layout=blog&cid=0','component',1,1,1,10005,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',207,220,0,'*',0);
INSERT INTO #__menu VALUES(473,'aboutjoomla','Add item','add-item','','dj-classifieds/add-item','index.php?option=com_djclassifieds&view=additem','component',1,472,2,10005,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',208,209,0,'*',0);
INSERT INTO #__menu VALUES(474,'aboutjoomla','Category tree','category-tree','','dj-classifieds/category-tree','index.php?option=com_djclassifieds&view=categories','component',1,472,2,10005,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"cattree_cols\":\"\",\"cattree_levels\":\"\",\"cattree_ic\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',210,211,0,'*',0);
INSERT INTO #__menu VALUES(475,'aboutjoomla','Single ad view','single-ad-view','','dj-classifieds/single-ad-view','index.php?option=com_djclassifieds&view=item&id=1','component',1,472,2,10005,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',212,213,0,'*',0);
INSERT INTO #__menu VALUES(476,'aboutjoomla','Category blog layout','category-blog-layout','','dj-classifieds/category-blog-layout','index.php?option=com_djclassifieds&view=items&layout=blog&cid=0','component',1,472,2,10005,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',214,215,0,'*',0);
INSERT INTO #__menu VALUES(477,'aboutjoomla','Category table layout','category-table-layout','','dj-classifieds/category-table-layout','index.php?option=com_djclassifieds&view=items&cid=0','component',1,472,2,10005,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',216,217,0,'*',0);
INSERT INTO #__menu VALUES(478,'aboutjoomla','User items','user-items','','dj-classifieds/user-items','index.php?option=com_djclassifieds&view=useritems','component',1,472,2,10005,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',218,219,0,'*',0);
INSERT INTO #__menu VALUES(490,'main','COM_DJCATALOG2','com-djcatalog2','','com-djcatalog2','index.php?option=com_djcatalog2','component',0,1,1,10040,0,0,'0000-00-00 00:00:00',0,1,'components/com_djcatalog2/images/icon-16-djcatalog.png',0,'',341,342,0,'',1);
INSERT INTO #__menu VALUES(480,'aboutjoomla','DJ-Catalog2','dj-catalog2','','dj-catalog2','index.php?option=com_djcatalog2&view=items&cid=0&pid=','component',1,1,1,10040,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"product_catalogue\":\"\",\"showcatdesc\":\"\",\"showsubcategories_label\":\"\",\"showsubcategories\":\"\",\"category_columns\":\"\",\"category_show_intro\":\"\",\"category_intro_trunc\":\"\",\"category_intro_length\":\"\",\"image_link_subcategory\":\"\",\"showreadmore_subcategory\":\"\",\"limit_items_show\":\"4\",\"list_layout\":\"\",\"items_columns\":\"\",\"items_default_order\":\"\",\"items_default_order_dir\":\"\",\"featured_only\":\"\",\"featured_first\":\"\",\"show_category_filter\":\"\",\"show_producer_filter\":\"\",\"show_search\":\"\",\"show_category_orderby\":\"\",\"show_producer_orderby\":\"\",\"show_name_orderby\":\"\",\"show_price_orderby\":\"\",\"show_date_orderby\":\"\",\"show_category_name\":\"\",\"show_producer_name\":\"\",\"show_price\":\"\",\"items_show_intro\":\"\",\"items_intro_trunc\":\"\",\"items_intro_length\":\"\",\"image_link_item\":\"\",\"showreadmore_item\":\"\",\"show_category_name_item\":\"\",\"show_producer_name_item\":\"\",\"show_price_item\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',221,230,0,'*',0);
INSERT INTO #__menu VALUES(481,'aboutjoomla','Single product view','single-product-view','','dj-catalog2/single-product-view','index.php?option=com_djcatalog2&view=item&id=1','component',1,480,2,10040,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_name_item\":\"\",\"show_producer_name_item\":\"\",\"show_price_item\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',222,223,0,'*',0);
INSERT INTO #__menu VALUES(482,'aboutjoomla','List of items (table)','list-of-items-table','','dj-catalog2/list-of-items-table','index.php?option=com_djcatalog2&view=items&cid=0&pid=1','component',1,480,2,10040,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"product_catalogue\":\"\",\"showcatdesc\":\"\",\"showsubcategories_label\":\"\",\"showsubcategories\":\"\",\"category_columns\":\"\",\"category_show_intro\":\"\",\"category_intro_trunc\":\"\",\"category_intro_length\":\"\",\"image_link_subcategory\":\"\",\"showreadmore_subcategory\":\"\",\"limit_items_show\":\"\",\"list_layout\":\"table\",\"items_columns\":\"\",\"items_default_order\":\"\",\"items_default_order_dir\":\"\",\"featured_only\":\"\",\"featured_first\":\"\",\"show_category_filter\":\"\",\"show_producer_filter\":\"\",\"show_search\":\"\",\"show_category_orderby\":\"\",\"show_producer_orderby\":\"\",\"show_name_orderby\":\"\",\"show_price_orderby\":\"\",\"show_date_orderby\":\"\",\"show_category_name\":\"\",\"show_producer_name\":\"\",\"show_price\":\"\",\"items_show_intro\":\"\",\"items_intro_trunc\":\"1\",\"items_intro_length\":\"50\",\"image_link_item\":\"\",\"showreadmore_item\":\"\",\"show_category_name_item\":\"\",\"show_producer_name_item\":\"\",\"show_price_item\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',226,227,0,'*',0);
INSERT INTO #__menu VALUES(483,'aboutjoomla','List of items (blog/grid)','list-of-items-blog-grid','','dj-catalog2/list-of-items-blog-grid','index.php?option=com_djcatalog2&view=items&cid=0&pid=','component',1,480,2,10040,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"product_catalogue\":\"\",\"showcatdesc\":\"\",\"showsubcategories_label\":\"\",\"showsubcategories\":\"\",\"category_columns\":\"\",\"category_show_intro\":\"\",\"category_intro_trunc\":\"\",\"category_intro_length\":\"\",\"image_link_subcategory\":\"\",\"showreadmore_subcategory\":\"\",\"limit_items_show\":\"4\",\"list_layout\":\"\",\"items_columns\":\"\",\"items_default_order\":\"\",\"items_default_order_dir\":\"\",\"featured_only\":\"\",\"featured_first\":\"\",\"show_category_filter\":\"\",\"show_producer_filter\":\"\",\"show_search\":\"\",\"show_category_orderby\":\"\",\"show_producer_orderby\":\"\",\"show_name_orderby\":\"\",\"show_price_orderby\":\"\",\"show_date_orderby\":\"\",\"show_category_name\":\"\",\"show_producer_name\":\"\",\"show_price\":\"\",\"items_show_intro\":\"\",\"items_intro_trunc\":\"\",\"items_intro_length\":\"\",\"image_link_item\":\"\",\"showreadmore_item\":\"\",\"show_category_name_item\":\"\",\"show_producer_name_item\":\"\",\"show_price_item\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',224,225,0,'*',0);
INSERT INTO #__menu VALUES(484,'aboutjoomla','Single producer view','single-producer-view','','dj-catalog2/single-producer-view','index.php?option=com_djcatalog2&view=producer&pid=1','component',1,480,2,10040,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',228,229,0,'*',0);
INSERT INTO #__menu VALUES(485,'aboutjoomla','Typography','typography','','2012-11-08-10-30-46/typography','index.php?option=com_content&view=article&id=71','component',1,493,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',12,13,0,'*',0);
INSERT INTO #__menu VALUES(486,'aboutjoomla','RTL Languages','rtl','','rtl','','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',231,236,0,'*',0);
INSERT INTO #__menu VALUES(487,'aboutjoomla','RTL Languages','2012-10-30-22-08-13','','rtl/2012-10-30-22-08-13','?direction=rtl','url',1,486,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',234,235,0,'*',0);
INSERT INTO #__menu VALUES(488,'aboutjoomla','LTR Languages','2012-10-30-22-08-47','','rtl/2012-10-30-22-08-47','?direction=ltr','url',1,486,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',232,233,0,'*',0);
INSERT INTO #__menu VALUES(491,'top-login','Singup','singup','','singup','index.php?option=com_users&view=registration','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,5,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',343,344,0,'*',0);
INSERT INTO #__menu VALUES(492,'top-login','Login','log-in','','log-in','index.php?option=com_users&view=login','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,5,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',345,346,0,'*',0);
INSERT INTO #__menu VALUES(493,'aboutjoomla','Template Features','2012-11-08-10-30-46','','2012-11-08-10-30-46','http://www.joomla-monster.com/knowledge-base-area/templates-documentation/templates-for-joomla-2-5/dj-real-estate02','url',1,1,1,0,0,0,'0000-00-00 00:00:00',1,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',5,20,0,'*',0);
INSERT INTO #__menu VALUES(494,'aboutjoomla','Template Parameters','2012-11-08-10-31-41','','2012-11-08-10-30-46/2012-11-08-10-31-41','http://www.joomla-monster.com/knowledge-base-area/templates-documentation/general-info/framework-ver-ef-1-00','url',1,493,2,0,0,0,'0000-00-00 00:00:00',1,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',6,7,0,'*',0);
INSERT INTO #__menu VALUES(495,'aboutjoomla','All Template\'s Positions','2012-11-08-10-32-25','','2012-11-08-10-30-46/2012-11-08-10-32-25','http://www.joomla-monster.com/knowledge-base-area/templates-documentation/templates-for-joomla-2-5/dj-real-estate02/template-layout','url',1,493,2,0,0,0,'0000-00-00 00:00:00',1,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',8,9,0,'*',0);
INSERT INTO #__menu VALUES(496,'aboutjoomla','Module Suffixes','2012-11-08-10-33-08','','2012-11-08-10-30-46/2012-11-08-10-33-08','http://www.joomla-monster.com/knowledge-base-area/templates-documentation/templates-for-joomla-2-5/dj-real-estate02/module-suffixes','url',1,493,2,0,0,0,'0000-00-00 00:00:00',1,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',10,11,0,'*',0);
INSERT INTO #__menu VALUES(497,'aboutjoomla','Install Demo Copy','2012-11-08-10-34-09','','2012-11-08-10-30-46/2012-11-08-10-34-09','http://www.joomla-monster.com/knowledge-base-area/general-questions/regarding-our-store/what-is-a-quickstart','url',1,493,2,0,0,0,'0000-00-00 00:00:00',1,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',14,15,0,'*',0);
INSERT INTO #__menu VALUES(498,'aboutjoomla','What You Get After Purchase?','2012-11-08-10-34-41','','2012-11-08-10-30-46/2012-11-08-10-34-41','http://www.joomla-monster.com/knowledge-base-area/general-questions/regarding-our-store/description-of-the-download-area','url',1,493,2,0,0,0,'0000-00-00 00:00:00',1,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',16,17,0,'*',0);
INSERT INTO #__menu VALUES(499,'aboutjoomla','Joomla Templates','2012-11-08-10-35-11','','2012-11-08-10-30-46/2012-11-08-10-35-11','http://www.joomla-monster.com/all-templates','url',1,493,2,0,0,0,'0000-00-00 00:00:00',1,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',18,19,0,'*',0);
INSERT INTO #__menu VALUES(502,'aboutjoomla','Promotions','promotions','','using-joomla/promotions','index.php?option=com_content&view=article&id=72','component',1,280,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"0\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"urls_position\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',192,193,0,'*',0);



DROP TABLE IF EXISTS #__menu_types;

CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;

INSERT INTO #__menu_types VALUES(2,'usermenu','User Menu','A Menu for logged-in Users');
INSERT INTO #__menu_types VALUES(3,'top','Top','Links for major types of users');
INSERT INTO #__menu_types VALUES(4,'aboutjoomla','About Joomla','All about Joomla!');
INSERT INTO #__menu_types VALUES(5,'parks','Australian Parks','Main menu for a site about Australian  parks');
INSERT INTO #__menu_types VALUES(6,'mainmenu','Main Menu','Simple Home Menu');
INSERT INTO #__menu_types VALUES(7,'fruitshop','Fruit Shop','Menu for the sample shop site.');
INSERT INTO #__menu_types VALUES(8,'top-login','Top Login','Top Login');



DROP TABLE IF EXISTS #__messages;

CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__messages_cfg;

CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__modules;

CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) AUTO_INCREMENT=194 DEFAULT CHARSET=utf8;

INSERT INTO #__modules VALUES(1,'Main Menu','','',1,'bottom-menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"aboutjoomla\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(2,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'',1,'*');
INSERT INTO #__modules VALUES(3,'Popular Articles','','',3,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_popular',3,1,'{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*');
INSERT INTO #__modules VALUES(4,'Recently Added Articles','','',4,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_latest',3,1,'{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*');
INSERT INTO #__modules VALUES(8,'Toolbar','','',1,'toolbar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_toolbar',3,1,'',1,'*');
INSERT INTO #__modules VALUES(9,'Quick Icons','','',1,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_quickicon',3,1,'',1,'*');
INSERT INTO #__modules VALUES(10,'Logged-in Users','','',2,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_logged',3,1,'{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*');
INSERT INTO #__modules VALUES(12,'Admin Menu','','',1,'menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',3,1,'{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}',1,'*');
INSERT INTO #__modules VALUES(13,'Admin Submenu','','',1,'submenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_submenu',3,1,'',1,'*');
INSERT INTO #__modules VALUES(14,'User Status','','',2,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_status',3,1,'',1,'*');
INSERT INTO #__modules VALUES(15,'Title','','',1,'title',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_title',3,1,'',1,'*');
INSERT INTO #__modules VALUES(16,'Login Form','','',7,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'{\"greeting\":\"1\",\"name\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(17,'Breadcrumbs','','',1,'position-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_breadcrumbs',1,1,'{\"moduleclass_sfx\":\"\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showComponent\":\"1\",\"separator\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(79,'Multilanguage status','','',1,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_multilangstatus',3,1,'{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',1,'*');
INSERT INTO #__modules VALUES(86,'Joomla Version','','',1,'footer',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_version',3,1,'{\"format\":\"short\",\"product\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',1,'*');
INSERT INTO #__modules VALUES(18,'Book Store','','',1,'position-10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_banners',1,0,'{\"target\":\"1\",\"count\":\"1\",\"cid\":\"3\",\"catid\":[\"\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"Books!\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(19,'User Menu','','',3,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',2,1,'{\"menutype\":\"usermenu\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(20,'Top','','',1,'position-1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"top\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(22,'Australian Parks ','','',2,'position-5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"parks\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'en-GB');
INSERT INTO #__modules VALUES(23,'About Joomla!','','',4,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_menu',1,1,'{\"menutype\":\"aboutjoomla\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(68,'About Parks','','<p>The Parks sample site is designed as a simple site that can be routinely updated from the front end of Joomla!.</p><p>As a site, it is largely focused on a blog which can be updated using the front end article submission.</p><p>New weblinks can also be added through the front end.</p><p>A simple image gallery uses com_content with thumbnails displayed in a blog layout and full size images shown in article layout.</p><p>The Parks site features the language switch module. All of the content and modules are tagged as English (en-GB). If a second language pack is added with sample data this can be filtered using the language switch.</p><p>Parks uses HTML5 which is a major web standard (along with XHTML which is used in other areas of sample data).</p>',2,'position-4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(67,'Extensions','','',2,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_menu',1,1,'{\"menutype\":\"aboutjoomla\",\"startLevel\":\"1\",\"endLevel\":\"6\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"-menu\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(25,'Site Map','','',1,'sitemapload',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"mainmenu\",\"startLevel\":\"2\",\"endLevel\":\"3\",\"showAllChildren\":\"1\",\"tag_id\":\"\",\"class_sfx\":\"sitemap\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(26,'This Site','','',5,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"1\",\"endLevel\":\"1\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(27,'Archived Articles','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_archive',1,1,'{\"count\":\"10\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(28,'Latest News','','',1,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\" white-ms\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(29,'Articles Most Read','','',19,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_articles_popular',1,1,'{\"catid\":[\"26\",\"29\"],\"count\":\"5\",\"show_front\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"border-ms\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(30,'Feed Display','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_feed',1,1,'{\"rssurl\":\"http:\\/\\/community.joomla.org\\/blogs\\/community.feed?type=rss\",\"rssrtl\":\"0\",\"rsstitle\":\"1\",\"rssdesc\":\"1\",\"rssimage\":\"1\",\"rssitems\":\"3\",\"rssitemdesc\":\"1\",\"word_count\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(31,'News Flash','','',18,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_articles_news',1,1,'{\"catid\":[\"19\"],\"image\":\"0\",\"item_title\":\"0\",\"link_titles\":\"\",\"item_heading\":\"h4\",\"showLastSeparator\":\"1\",\"readmore\":\"1\",\"count\":\"1\",\"ordering\":\"a.publish_up\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(33,'Random Image','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_random_image',1,1,'{\"type\":\"jpg\",\"folder\":\"images\\/sampledata\\/parks\\/animals\",\"link\":\"\",\"width\":\"180\",\"height\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(34,'Articles Related Items','','',17,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_related_items',1,1,'{\"showDate\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"blank\",\"owncache\":\"1\"}',0,'*');
INSERT INTO #__modules VALUES(35,'Search','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_search',1,1,'{\"label\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"opensearch\":\"1\",\"opensearch_title\":\"\",\"set_itemid\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(36,'Statistics','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_stats',1,1,'{\"serverinfo\":\"1\",\"siteinfo\":\"1\",\"counter\":\"1\",\"increase\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(37,'Syndicate Feeds','','',1,'syndicateload',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_syndicate',1,1,'{\"text\":\"Feed Entries\",\"format\":\"rss\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(38,'Users Latest','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_users_latest',1,1,'{\"shownumber\":\"5\",\"linknames\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(39,'Who\'s Online','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_whosonline',1,1,'{\"showmode\":\"2\",\"linknames\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(40,'Wrapper','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_wrapper',1,1,'{\"url\":\"http:\\/\\/www.youtube.com\\/embed\\/vb2eObvmvdI\",\"add\":\"1\",\"scrolling\":\"auto\",\"width\":\"640\",\"height\":\"390\",\"height_auto\":\"1\",\"target\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(41,'Footer','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_footer',1,1,'{\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(44,'Login','','',1,'top-bar2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',2,1,'{\"pretext\":\"\",\"posttext\":\"\",\"login\":\"280\",\"logout\":\"280\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(45,'Menu Example','','',16,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_menu',1,1,'{\"menutype\":\"aboutjoomla\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(47,'Latest Park Blogs','','',6,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"count\":\"5\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"show_front\":\"1\",\"catid\":\"35\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'en-GB');
INSERT INTO #__modules VALUES(48,'Custom HTML','','<p>This is a custom html module. That means you can enter whatever content you want.</p>',1,'right-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"border-ms\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(49,'Weblinks','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_weblinks',1,1,'{\"catid\":\"32\",\"count\":\"5\",\"ordering\":\"title\",\"direction\":\"asc\",\"target\":\"3\",\"description\":\"0\",\"hits\":\"0\",\"count_clicks\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(52,'Breadcrumbs','','',1,'breadcrumbs',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_breadcrumbs',1,0,'{\"showHere\":\"1\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(61,'Articles Categories','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_categories',1,1,'{\"parent\":\"29\",\"show_description\":\"0\",\"show_children\":\"0\",\"count\":\"0\",\"maxlevel\":\"0\",\"layout\":\"_:default\",\"item_heading\":\"4\",\"moduleclass_sfx\":\"\",\"owncache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(56,'Banners','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_banners',1,1,'{\"target\":\"1\",\"count\":\"1\",\"cid\":\"1\",\"catid\":[\"15\"],\"tag_search\":\"0\",\"ordering\":\"random\",\"header_text\":\"\",\"footer_text\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(57,'Fruit Shop','','',3,'position-5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"fruitshop\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(58,'Special!','','<h1>This week we have a special, half price on delicious oranges!</h1><div>Only for our special customers!</div><div>Use the code: Joomla! when ordering</div><p><em>This module can only be seen by people in the customers group or higher.</em></p>',1,'position-12',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',4,1,'{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(62,'Language Switcher','','',3,'position-4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_languages',1,1,'{\"header_text\":\"\",\"footer_text\":\"\",\"image\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(63,'Search','','',1,'position-0',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_search',1,1,'{\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"1\",\"button_text\":\"\",\"set_itemid\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(64,'Language Switcher','','',1,'languageswitcherload',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_languages',1,1,'{\"header_text\":\"\",\"footer_text\":\"\",\"image\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(65,'About Fruit Shop','','<p>The Fruit Shop site shows a number of Joomla! features.</p><p>The template uses classes in cascading style sheets to change the layout of items, such as creating the horizontal alphabetical list in the Fruit Encyclopedia.</p><p> </p>',1,'position-4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(69,'Articles Category','','',1,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_category',1,1,'{\"mode\":\"normal\",\"show_on_article_page\":\"1\",\"show_front\":\"show\",\"count\":\"0\",\"category_filtering_type\":\"1\",\"catid\":[\"72\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"author_filtering_type\":\"1\",\"created_by\":[\"\"],\"author_alias_filtering_type\":\"1\",\"created_by_alias\":[\"\"],\"excluded_articles\":\"\",\"date_filtering\":\"off\",\"date_field\":\"a.created\",\"start_date_range\":\"\",\"end_date_range\":\"\",\"relative_date\":\"30\",\"article_ordering\":\"a.title\",\"article_ordering_direction\":\"ASC\",\"article_grouping\":\"none\",\"article_grouping_direction\":\"ksort\",\"month_year_format\":\"F Y\",\"item_heading\":\"4\",\"link_titles\":\"1\",\"show_date\":\"0\",\"show_date_field\":\"created\",\"show_date_format\":\"Y-m-d H:i:s\",\"show_category\":\"0\",\"show_hits\":\"0\",\"show_author\":\"0\",\"show_introtext\":\"0\",\"introtext_limit\":\"100\",\"show_readmore\":\"0\",\"show_readmore_title\":\"1\",\"readmore_limit\":\"15\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"owncache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(70,'Search (Atomic Template)','','',1,'atomic-search',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_search',1,0,'{\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"set_itemid\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(71,'Top Menu (Atomic Template)','','',1,'atomic-topmenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"aboutjoomla\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');
INSERT INTO #__modules VALUES(72,'Top Quote (Atomic Template)','','<hr />\r\n<h2 class=\"alt\">Powerful Content Management and a Simple Extensible Framework.</h2>\r\n<hr />',1,'atomic-topquote',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(73,'Bottom Left Column (Atomic Template)','','<h6>This is a nested column</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>',1,'atomic-bottomleft',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(74,'Bottom Middle Column (Atomic Template)','','<h6>This is another nested column</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>',1,'atomic-bottommiddle',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(75,'Sidebar (Atomic Template)','','<h3>A <span class=\"alt\">Simple</span> Sidebar</h3>\r\n<p>Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>\r\n<p class=\"quiet\">Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>\r\n<h5>Incremental leading</h5>\r\n<p class=\"incr\">Vestibulum ante ipsum primis in faucibus orci luctus vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus.</p>\r\n<p class=\"incr\">Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>',1,'atomic-sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(76,'Login (Atomic Template)','','',2,'atomic-sidebar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,0,'{\"pretext\":\"\",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(77,'Shop','','',1,'position-11',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_banners',1,0,'{\"target\":\"1\",\"count\":\"1\",\"cid\":\"2\",\"catid\":[\"15\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"Shop!\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(78,'Contribute','','',1,'position-9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_banners',1,0,'{\"target\":\"1\",\"count\":\"1\",\"cid\":\"1\",\"catid\":[\"15\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"Contribute! \",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(84,'Smart Search Module','','',2,'',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_finder',1,1,'{\"searchfilter\":\"\",\"show_autosuggest\":\"1\",\"show_advanced\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"field_size\":20,\"alt_label\":\"\",\"show_label\":\"0\",\"label_pos\":\"top\",\"show_button\":\"0\",\"button_pos\":\"right\",\"opensearch\":\"1\",\"opensearch_title\":\"\"}',0,'*');
INSERT INTO #__modules VALUES(87,'Header','','<p style=\"text-align: center; margin: 0;\"><img src=\"images/modules/header.png\" border=\"0\" style=\"margin-bottom: -4px; border: 0px;\" /></p>',1,'header',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(88,'Social','','<p class=\"jm-icons\"><a href=\"index.php\" style=\"display: inline-block;\"><span class=\"jm-facebook\" style=\"margin: 5px 5px;\"> </span></a><a href=\"index.php\" style=\"display: inline-block;\"><span class=\"jm-twitter\" style=\"margin: 5px 5px;\"> </span></a><a href=\"index.php\" style=\"display: inline-block;\"><span class=\"jm-google\" style=\"margin: 5px 5px;\"> </span></a><a href=\"index.php\" style=\"display: inline-block;\"><span class=\"jm-pinterest\" style=\"margin: 5px 5px;\"> </span></a><a href=\"index.php\" style=\"display: inline-block;\"><span class=\"jm-rss\" style=\"margin: 5px 5px;\"> </span></a></p>',1,'top-bar1',614,'2012-11-13 13:19:50','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(89,'DJ-Menu','','',1,'dj-menu-top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djmenu',1,1,'{\"menu\":\"aboutjoomla\",\"endLevel\":\"0\",\"css\":\"0\",\"moo\":\"1\",\"wrapper\":\"\",\"select\":\"1\",\"height_fx\":\"1\",\"width_fx\":\"1\",\"opacity_fx\":\"1\",\"height_fx_sub\":\"1\",\"width_fx_sub\":\"1\",\"opacity_fx_sub\":\"1\",\"effect\":\"cubic\",\"duration\":\"\",\"delay\":\"\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(186,'Popular Classifieds','','',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djclassifieds_items',1,1,'{\"moduleclass_sfx\":\" white-ms\",\"items_nr\":\"3\",\"columns_nr\":\"1\",\"items_ord\":\"1\",\"only_promoted\":\"0\",\"fallow_category\":\"0\",\"items_ids\":\"\",\"show_img\":\"1\",\"show_title\":\"1\",\"show_date\":\"1\",\"show_cat\":\"0\",\"cat_link\":\"1\",\"show_price\":\"1\",\"show_description\":\"1\",\"desc_source\":\"0\",\"desc_link\":\"0\",\"char_desc_nr\":\"0\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(185,'Recent Classifieds','','',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djclassifieds_items',1,1,'{\"moduleclass_sfx\":\" white-ms\",\"items_nr\":\"3\",\"columns_nr\":\"1\",\"items_ord\":\"0\",\"only_promoted\":\"0\",\"fallow_category\":\"0\",\"items_ids\":\"\",\"show_img\":\"1\",\"show_title\":\"1\",\"show_date\":\"1\",\"show_cat\":\"0\",\"cat_link\":\"1\",\"show_price\":\"1\",\"show_description\":\"1\",\"desc_source\":\"0\",\"desc_link\":\"0\",\"char_desc_nr\":\"0\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(191,'Promote Your Advert','','<div class=\"dj-image-hover\">\r\n<div class=\"view view-second\"><a href=\"index.php/using-joomla/promotions\"><img src=\"images/modules/paper.png\" border=\"0\" /></a>\r\n<div class=\"mask\">\r\n<h2><a href=\"index.php/using-joomla/promotions\">Promote Your Advert</a></h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin hendrerit vehicula odio, non porta lacus facilisis sit amet. Donec faucibus purus ante, nec imperdiet lorem.</p>\r\n<a class=\"readmore\" href=\"index.php/using-joomla/promotions\">Read More</a></div>\r\n</div>\r\n</div>',21,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(188,'Real Estate Catalog','','',1,'content-bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djc2frontpage',1,1,'{\"moduleclass_sfx\":\"\",\"showtitle\":\"1\",\"linktitle\":\"1\",\"showcattitle\":\"1\",\"showpagination\":\"1\",\"orderby\":\"2\",\"orderbydir\":\"0\",\"featured_only\":\"0\",\"featured_first\":\"0\",\"catsw\":\"0\",\"catid\":[\"1\",\"2\",\"3\"],\"cols\":\"1\",\"rows\":\"3\",\"trunc\":\"0\",\"trunclimit\":\"0\",\"showreadmore\":\"1\",\"readmoretext\":\"\",\"showfooter\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(189,'Best Offers From Your Region!','','<div class=\"dj-image-hover\">\r\n<div class=\"view view-first\"><a href=\"index.php/dj-classifieds\"><img src=\"images/modules/map.png\" border=\"0\" /></a>\r\n<div class=\"mask\">\r\n<h2><a href=\"index.php/dj-classifieds\">Classifieds From Your Region</a></h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Proin hendrerit vehicula odio, non porta lacus facilisis sit amet. Donec faucibus purus ante, nec imperdiet lorem.</p>\r\n<a class=\"readmore\" href=\"index.php/dj-classifieds\">Read More</a></div>\r\n</div>\r\n</div>',1,'content-top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(176,'Popular Ads','','',24,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djclassifieds_items',1,1,'{\"moduleclass_sfx\":\" white-ms\",\"items_nr\":\"3\",\"columns_nr\":\"1\",\"items_ord\":\"1\",\"only_promoted\":\"0\",\"fallow_category\":\"0\",\"items_ids\":\"\",\"show_img\":\"1\",\"show_title\":\"1\",\"show_date\":\"0\",\"show_cat\":\"0\",\"cat_link\":\"1\",\"show_price\":\"1\",\"show_description\":\"1\",\"desc_source\":\"0\",\"desc_link\":\"0\",\"char_desc_nr\":\"50\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(192,'Gallery','','',23,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djimageslider',1,1,'{\"slider_source\":\"1\",\"slider_type\":\"1\",\"link_image\":\"1\",\"image_folder\":\"images\\/sampledata\\/fruitshop\",\"link\":\"\",\"category\":\"78\",\"show_title\":\"1\",\"show_desc\":\"0\",\"show_readmore\":\"0\",\"readmore_text\":\"\",\"link_title\":\"1\",\"link_desc\":\"0\",\"limit_desc\":\"\",\"image_width\":\"224\",\"image_height\":\"149\",\"fit_to\":\"0\",\"visible_images\":\"1\",\"space_between_images\":\"10\",\"max_images\":\"3\",\"sort_by\":\"0\",\"effect\":\"Cubic\",\"autoplay\":\"1\",\"show_buttons\":\"0\",\"show_arrows\":\"0\",\"show_custom_nav\":\"1\",\"desc_width\":\"\",\"desc_bottom\":\"0\",\"desc_horizontal\":\"0\",\"left_arrow\":\"\",\"right_arrow\":\"\",\"play_button\":\"\",\"pause_button\":\"\",\"arrows_top\":\"30\",\"arrows_horizontal\":\"5\",\"effect_type\":\"0\",\"duration\":\"\",\"delay\":\"\",\"preload\":\"800\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(193,'Gallery','','',23,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djimageslider',1,1,'{\"slider_source\":\"1\",\"slider_type\":\"1\",\"link_image\":\"1\",\"image_folder\":\"images\\/sampledata\\/fruitshop\",\"link\":\"\",\"category\":\"78\",\"show_title\":\"1\",\"show_desc\":\"0\",\"show_readmore\":\"0\",\"readmore_text\":\"\",\"link_title\":\"1\",\"link_desc\":\"0\",\"limit_desc\":\"\",\"image_width\":\"224\",\"image_height\":\"149\",\"fit_to\":\"0\",\"visible_images\":\"2\",\"space_between_images\":\"10\",\"max_images\":\"4\",\"sort_by\":\"0\",\"effect\":\"Cubic\",\"autoplay\":\"1\",\"show_buttons\":\"0\",\"show_arrows\":\"0\",\"show_custom_nav\":\"1\",\"desc_width\":\"\",\"desc_bottom\":\"0\",\"desc_horizontal\":\"0\",\"left_arrow\":\"\",\"right_arrow\":\"\",\"play_button\":\"\",\"pause_button\":\"\",\"arrows_top\":\"30\",\"arrows_horizontal\":\"5\",\"effect_type\":\"0\",\"duration\":\"\",\"delay\":\"\",\"preload\":\"800\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(175,'Copyrights','','<p>Copyrights. All rights reserved.</p>',1,'copyrights',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(187,'Random Classifieds','','',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djclassifieds_items',1,1,'{\"moduleclass_sfx\":\" white-ms\",\"items_nr\":\"3\",\"columns_nr\":\"1\",\"items_ord\":\"2\",\"only_promoted\":\"0\",\"fallow_category\":\"0\",\"items_ids\":\"\",\"show_img\":\"1\",\"show_title\":\"1\",\"show_date\":\"1\",\"show_cat\":\"0\",\"cat_link\":\"1\",\"show_price\":\"1\",\"show_description\":\"1\",\"desc_source\":\"0\",\"desc_link\":\"0\",\"char_desc_nr\":\"0\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(181,'How to Post an Ad','','<p class=\"jm-block second\" style=\"line-height: 40px;\"><span>1</span><strong>Singup</strong></p>\r\n<p class=\"jm-block second\" style=\"line-height: 40px;\"><span>2</span><strong>Add your Ad</strong></p>\r\n<p class=\"jm-block second\" style=\"min-height: 35px; padding-top: 5px;\"><span>3</span><strong>Promote your Ad</strong><br />Optionally</p>\r\n<p class=\"jm-block second\" style=\"line-height: 40px;\"><span>4</span><strong>Confirmation</strong></p>',10,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(190,'Advertise for Free!','','<div class=\"dj-image-hover\" style=\"text-align: center;\">\r\n<div class=\"view view-third\"><a href=\"index.php/dj-classifieds/add-item\"><img src=\"images/modules/advertise.png\" border=\"0\" /></a>\r\n<div class=\"mask\">\r\n<h2><a href=\"index.php/dj-classifieds/add-item\">Advertise for Free!</a></h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit.</p>\r\n<a class=\"readmore\" href=\"index.php/dj-classifieds/add-item\">Read More</a></div>\r\n</div>\r\n</div>',1,'content-top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(180,'Featured Items','','',14,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djc2items',1,1,'{\"moduleclass_sfx\":\" border-ms\",\"featured_only\":\"0\",\"featured_first\":\"0\",\"orderby\":\"i.ordering\",\"orderdir\":\"asc\",\"items_limit\":\"1\",\"thumbnail\":\"medium\",\"show_category_name\":\"1\",\"show_producer_name\":\"3\",\"show_price\":\"1\",\"items_show_intro\":\"1\",\"items_intro_trunc\":\"1\",\"items_intro_length\":\"50\",\"showreadmore_item\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(178,'Search for Classifieds (3)','','',8,'top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_djclassifieds_search',1,1,'{\"moduleclass_sfx\":\"horizontal_search white-ms\",\"show_cat\":\"1\",\"show_loc\":\"1\",\"show_input\":\"1\",\"show_price\":\"1\",\"show_reset\":\"1\"}',0,'*');
INSERT INTO #__modules VALUES(177,'Search for Classifieds (2)','','',7,'top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_djclassifieds_search',1,1,'{\"moduleclass_sfx\":\"horizontal_search white-ms\",\"show_cat\":\"1\",\"show_loc\":\"1\",\"show_input\":\"1\",\"show_price\":\"1\",\"show_reset\":\"1\"}',0,'*');
INSERT INTO #__modules VALUES(125,'top','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',6,'top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(126,'top','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',5,'top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(127,'top','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',4,'top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(128,'content-top1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'content-top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(129,'content-top1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'content-top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(130,'content-top2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'content-top2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(131,'content-bottom1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'content-bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(132,'content-bottom2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'content-bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(133,'content-bottom2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'content-bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(134,'left-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',15,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(135,'left-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',12,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(136,'left-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',9,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(137,'left-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',7,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(138,'right-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'right-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(139,'right-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'right-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(140,'right-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'right-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(141,'left-column','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',6,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(142,'bottom1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(143,'bottom1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(144,'bottom1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(145,'bottom1','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(146,'bottom2','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(147,'top','','<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum fermentum libero et justo sodales posuere. Aliquam arcu leo, aliquet eget venenatis a, semper sit amet neque.</p>',3,'top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"backgroundimage\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*');
INSERT INTO #__modules VALUES(149,'Real Estate Gallery','','',2,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djimageslider',1,1,'{\"slider_source\":\"1\",\"slider_type\":\"0\",\"link_image\":\"0\",\"image_folder\":\"images\\/sampledata\\/fruitshop\",\"link\":\"\",\"category\":\"78\",\"show_title\":\"1\",\"show_desc\":\"0\",\"show_readmore\":\"0\",\"readmore_text\":\"\",\"link_title\":\"1\",\"link_desc\":\"0\",\"limit_desc\":\"\",\"image_width\":\"220\",\"image_height\":\"147\",\"fit_to\":\"0\",\"visible_images\":\"4\",\"space_between_images\":\"10\",\"max_images\":\"20\",\"sort_by\":\"1\",\"effect\":\"Cubic\",\"autoplay\":\"1\",\"show_buttons\":\"0\",\"show_arrows\":\"0\",\"show_custom_nav\":\"1\",\"desc_width\":\"\",\"desc_bottom\":\"0\",\"desc_horizontal\":\"0\",\"left_arrow\":\"\",\"right_arrow\":\"\",\"play_button\":\"\",\"pause_button\":\"\",\"arrows_top\":\"30\",\"arrows_horizontal\":\"5\",\"effect_type\":\"0\",\"duration\":\"\",\"delay\":\"\",\"preload\":\"800\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"  border-ms\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*');
INSERT INTO #__modules VALUES(150,'Recent Ads','','',22,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djclassifieds_items',1,1,'{\"moduleclass_sfx\":\" white-ms\",\"items_nr\":\"3\",\"columns_nr\":\"1\",\"items_ord\":\"0\",\"only_promoted\":\"0\",\"fallow_category\":\"0\",\"items_ids\":\"\",\"show_img\":\"1\",\"show_title\":\"1\",\"show_date\":\"0\",\"show_cat\":\"0\",\"cat_link\":\"1\",\"show_price\":\"1\",\"show_description\":\"1\",\"desc_source\":\"0\",\"desc_link\":\"0\",\"char_desc_nr\":\"50\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(151,'Classifieds From Your Region','','',1,'content-top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djclassifieds_maps',1,1,'{\"moduleclass_sfx\":\" \",\"map_width\":\"100%\",\"map_height\":\"400px\",\"items_limit\":\"20\",\"start_address\":\"New York, US\",\"start_zoom\":\"10\",\"items_ord\":\"0\",\"fallow_category\":\"1\"}',0,'*');
INSERT INTO #__modules VALUES(152,'Ads Categories','','',2,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djclassifieds_menu',1,1,'{\"moduleclass_sfx\":\"_menu  white-ms\",\"max_level\":\"0\",\"new_ad_link\":\"2\"}',0,'*');
INSERT INTO #__modules VALUES(153,'Search for Classifieds','','',1,'top',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djclassifieds_search',1,1,'{\"moduleclass_sfx\":\"horizontal_search white-ms\",\"show_cat\":\"1\",\"show_loc\":\"1\",\"show_input\":\"1\",\"show_price\":\"1\",\"show_reset\":\"1\"}',0,'*');
INSERT INTO #__modules VALUES(154,'User Menu','','',1,'top-bar3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djclassifieds_user_menu',2,1,'{\"moduleclass_sfx\":\"\",\"new_ad_link\":\"1\",\"user_ads_link\":\"1\",\"user_fav_link\":\"1\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(161,'Recent Classifieds','','',1,'content-bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djclassifieds_items',1,1,'{\"moduleclass_sfx\":\" border-ms\",\"items_nr\":\"3\",\"columns_nr\":\"3\",\"items_ord\":\"0\",\"only_promoted\":\"0\",\"fallow_category\":\"0\",\"items_ids\":\"\",\"show_img\":\"1\",\"show_title\":\"1\",\"show_date\":\"0\",\"show_cat\":\"0\",\"cat_link\":\"1\",\"show_price\":\"1\",\"show_description\":\"1\",\"desc_source\":\"0\",\"desc_link\":\"0\",\"char_desc_nr\":\"0\",\"cache\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(168,'Real Estate Categories','','',3,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djc2categories',1,1,'{\"moduleclass_sfx\":\"_menu\",\"expand\":\"0\",\"parent_category\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(169,'Real Estate Catalog','','',1,'content-top2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djc2frontpage',1,1,'{\"moduleclass_sfx\":\"\",\"showtitle\":\"1\",\"linktitle\":\"1\",\"showcattitle\":\"1\",\"showpagination\":\"1\",\"orderby\":\"2\",\"orderbydir\":\"0\",\"featured_only\":\"0\",\"featured_first\":\"0\",\"catsw\":\"0\",\"catid\":[\"1\",\"2\",\"3\"],\"cols\":\"1\",\"rows\":\"3\",\"trunc\":\"0\",\"trunclimit\":\"0\",\"showreadmore\":\"1\",\"readmoretext\":\"\",\"showfooter\":\"0\"}',0,'*');
INSERT INTO #__modules VALUES(170,'Featured Items','','',13,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djc2items',1,1,'{\"moduleclass_sfx\":\" white-ms\",\"featured_only\":\"0\",\"featured_first\":\"0\",\"orderby\":\"i.ordering\",\"orderdir\":\"asc\",\"items_limit\":\"2\",\"thumbnail\":\"medium\",\"show_category_name\":\"1\",\"show_producer_name\":\"3\",\"show_price\":\"1\",\"items_show_intro\":\"1\",\"items_intro_trunc\":\"1\",\"items_intro_length\":\"120\",\"showreadmore_item\":\"1\"}',0,'*');
INSERT INTO #__modules VALUES(171,'Related Items','','',11,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djc2relateditems',1,1,'{\"moduleclass_sfx\":\" white-ms\",\"featured_only\":\"0\",\"featured_first\":\"0\",\"orderby\":\"i.ordering\",\"orderdir\":\"0\",\"items_limit\":\"1\",\"thumbnail\":\"medium\",\"show_category_name\":\"1\",\"show_producer_name\":\"3\",\"show_price\":\"1\",\"items_show_intro\":\"1\",\"items_intro_trunc\":\"1\",\"items_intro_length\":\"90\",\"showreadmore_item\":\"1\"}',0,'*');
INSERT INTO #__modules VALUES(172,'Real Estate Companies','','',5,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djc2producers',1,1,'{\"moduleclass_sfx\":\"\",\"filter\":\"1\"}',0,'*');
INSERT INTO #__modules VALUES(173,'Search for Real Estates','','',8,'left-column',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_djc2search',1,1,'{\"moduleclass_sfx\":\"\",\"filter\":\"1\",\"show_label\":\"0\",\"show_button\":\"1\"}',0,'*');
INSERT INTO #__modules VALUES(174,'Top Login','','',1,'top-bar3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,1,'{\"menutype\":\"top-login\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*');



DROP TABLE IF EXISTS #__modules_menu;

CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) DEFAULT CHARSET=utf8;

INSERT INTO #__modules_menu VALUES(1,0);
INSERT INTO #__modules_menu VALUES(2,0);
INSERT INTO #__modules_menu VALUES(3,0);
INSERT INTO #__modules_menu VALUES(4,0);
INSERT INTO #__modules_menu VALUES(6,0);
INSERT INTO #__modules_menu VALUES(7,0);
INSERT INTO #__modules_menu VALUES(8,0);
INSERT INTO #__modules_menu VALUES(9,0);
INSERT INTO #__modules_menu VALUES(10,0);
INSERT INTO #__modules_menu VALUES(12,0);
INSERT INTO #__modules_menu VALUES(13,0);
INSERT INTO #__modules_menu VALUES(14,0);
INSERT INTO #__modules_menu VALUES(15,0);
INSERT INTO #__modules_menu VALUES(16,205);
INSERT INTO #__modules_menu VALUES(16,435);
INSERT INTO #__modules_menu VALUES(17,0);
INSERT INTO #__modules_menu VALUES(18,0);
INSERT INTO #__modules_menu VALUES(19,-463);
INSERT INTO #__modules_menu VALUES(19,-462);
INSERT INTO #__modules_menu VALUES(19,-433);
INSERT INTO #__modules_menu VALUES(19,-432);
INSERT INTO #__modules_menu VALUES(19,-431);
INSERT INTO #__modules_menu VALUES(19,-430);
INSERT INTO #__modules_menu VALUES(19,-429);
INSERT INTO #__modules_menu VALUES(19,-427);
INSERT INTO #__modules_menu VALUES(19,-400);
INSERT INTO #__modules_menu VALUES(19,-399);
INSERT INTO #__modules_menu VALUES(19,-296);
INSERT INTO #__modules_menu VALUES(19,-244);
INSERT INTO #__modules_menu VALUES(19,-243);
INSERT INTO #__modules_menu VALUES(19,-242);
INSERT INTO #__modules_menu VALUES(19,-234);
INSERT INTO #__modules_menu VALUES(20,0);
INSERT INTO #__modules_menu VALUES(22,231);
INSERT INTO #__modules_menu VALUES(22,234);
INSERT INTO #__modules_menu VALUES(22,238);
INSERT INTO #__modules_menu VALUES(22,242);
INSERT INTO #__modules_menu VALUES(22,243);
INSERT INTO #__modules_menu VALUES(22,244);
INSERT INTO #__modules_menu VALUES(22,296);
INSERT INTO #__modules_menu VALUES(22,399);
INSERT INTO #__modules_menu VALUES(22,400);
INSERT INTO #__modules_menu VALUES(23,-463);
INSERT INTO #__modules_menu VALUES(23,-462);
INSERT INTO #__modules_menu VALUES(23,-433);
INSERT INTO #__modules_menu VALUES(23,-432);
INSERT INTO #__modules_menu VALUES(23,-431);
INSERT INTO #__modules_menu VALUES(23,-430);
INSERT INTO #__modules_menu VALUES(23,-429);
INSERT INTO #__modules_menu VALUES(23,-427);
INSERT INTO #__modules_menu VALUES(23,-400);
INSERT INTO #__modules_menu VALUES(23,-399);
INSERT INTO #__modules_menu VALUES(23,-296);
INSERT INTO #__modules_menu VALUES(23,-244);
INSERT INTO #__modules_menu VALUES(23,-243);
INSERT INTO #__modules_menu VALUES(23,-242);
INSERT INTO #__modules_menu VALUES(23,-238);
INSERT INTO #__modules_menu VALUES(23,-234);
INSERT INTO #__modules_menu VALUES(25,294);
INSERT INTO #__modules_menu VALUES(26,-463);
INSERT INTO #__modules_menu VALUES(26,-462);
INSERT INTO #__modules_menu VALUES(26,-433);
INSERT INTO #__modules_menu VALUES(26,-432);
INSERT INTO #__modules_menu VALUES(26,-431);
INSERT INTO #__modules_menu VALUES(26,-430);
INSERT INTO #__modules_menu VALUES(26,-429);
INSERT INTO #__modules_menu VALUES(26,-427);
INSERT INTO #__modules_menu VALUES(26,-400);
INSERT INTO #__modules_menu VALUES(26,-399);
INSERT INTO #__modules_menu VALUES(26,-296);
INSERT INTO #__modules_menu VALUES(26,-244);
INSERT INTO #__modules_menu VALUES(26,-243);
INSERT INTO #__modules_menu VALUES(26,-242);
INSERT INTO #__modules_menu VALUES(26,-238);
INSERT INTO #__modules_menu VALUES(26,-234);
INSERT INTO #__modules_menu VALUES(27,325);
INSERT INTO #__modules_menu VALUES(28,201);
INSERT INTO #__modules_menu VALUES(28,207);
INSERT INTO #__modules_menu VALUES(28,227);
INSERT INTO #__modules_menu VALUES(28,229);
INSERT INTO #__modules_menu VALUES(28,233);
INSERT INTO #__modules_menu VALUES(28,234);
INSERT INTO #__modules_menu VALUES(28,238);
INSERT INTO #__modules_menu VALUES(28,242);
INSERT INTO #__modules_menu VALUES(28,243);
INSERT INTO #__modules_menu VALUES(28,244);
INSERT INTO #__modules_menu VALUES(28,249);
INSERT INTO #__modules_menu VALUES(28,251);
INSERT INTO #__modules_menu VALUES(28,252);
INSERT INTO #__modules_menu VALUES(28,253);
INSERT INTO #__modules_menu VALUES(28,254);
INSERT INTO #__modules_menu VALUES(28,255);
INSERT INTO #__modules_menu VALUES(28,256);
INSERT INTO #__modules_menu VALUES(28,257);
INSERT INTO #__modules_menu VALUES(28,259);
INSERT INTO #__modules_menu VALUES(28,260);
INSERT INTO #__modules_menu VALUES(28,262);
INSERT INTO #__modules_menu VALUES(28,263);
INSERT INTO #__modules_menu VALUES(28,265);
INSERT INTO #__modules_menu VALUES(28,266);
INSERT INTO #__modules_menu VALUES(28,267);
INSERT INTO #__modules_menu VALUES(28,268);
INSERT INTO #__modules_menu VALUES(28,270);
INSERT INTO #__modules_menu VALUES(28,271);
INSERT INTO #__modules_menu VALUES(28,272);
INSERT INTO #__modules_menu VALUES(28,273);
INSERT INTO #__modules_menu VALUES(28,274);
INSERT INTO #__modules_menu VALUES(28,275);
INSERT INTO #__modules_menu VALUES(28,276);
INSERT INTO #__modules_menu VALUES(28,277);
INSERT INTO #__modules_menu VALUES(28,278);
INSERT INTO #__modules_menu VALUES(28,279);
INSERT INTO #__modules_menu VALUES(28,281);
INSERT INTO #__modules_menu VALUES(28,282);
INSERT INTO #__modules_menu VALUES(28,283);
INSERT INTO #__modules_menu VALUES(28,284);
INSERT INTO #__modules_menu VALUES(28,285);
INSERT INTO #__modules_menu VALUES(28,290);
INSERT INTO #__modules_menu VALUES(28,294);
INSERT INTO #__modules_menu VALUES(28,296);
INSERT INTO #__modules_menu VALUES(28,300);
INSERT INTO #__modules_menu VALUES(28,301);
INSERT INTO #__modules_menu VALUES(28,302);
INSERT INTO #__modules_menu VALUES(28,303);
INSERT INTO #__modules_menu VALUES(28,304);
INSERT INTO #__modules_menu VALUES(28,305);
INSERT INTO #__modules_menu VALUES(28,306);
INSERT INTO #__modules_menu VALUES(28,307);
INSERT INTO #__modules_menu VALUES(28,309);
INSERT INTO #__modules_menu VALUES(28,310);
INSERT INTO #__modules_menu VALUES(28,311);
INSERT INTO #__modules_menu VALUES(28,312);
INSERT INTO #__modules_menu VALUES(28,313);
INSERT INTO #__modules_menu VALUES(28,316);
INSERT INTO #__modules_menu VALUES(28,317);
INSERT INTO #__modules_menu VALUES(28,318);
INSERT INTO #__modules_menu VALUES(28,319);
INSERT INTO #__modules_menu VALUES(28,320);
INSERT INTO #__modules_menu VALUES(28,321);
INSERT INTO #__modules_menu VALUES(28,322);
INSERT INTO #__modules_menu VALUES(28,323);
INSERT INTO #__modules_menu VALUES(28,324);
INSERT INTO #__modules_menu VALUES(28,325);
INSERT INTO #__modules_menu VALUES(28,326);
INSERT INTO #__modules_menu VALUES(28,399);
INSERT INTO #__modules_menu VALUES(28,400);
INSERT INTO #__modules_menu VALUES(28,402);
INSERT INTO #__modules_menu VALUES(28,403);
INSERT INTO #__modules_menu VALUES(28,404);
INSERT INTO #__modules_menu VALUES(28,405);
INSERT INTO #__modules_menu VALUES(28,406);
INSERT INTO #__modules_menu VALUES(28,409);
INSERT INTO #__modules_menu VALUES(28,410);
INSERT INTO #__modules_menu VALUES(28,411);
INSERT INTO #__modules_menu VALUES(28,412);
INSERT INTO #__modules_menu VALUES(28,413);
INSERT INTO #__modules_menu VALUES(28,414);
INSERT INTO #__modules_menu VALUES(28,415);
INSERT INTO #__modules_menu VALUES(28,416);
INSERT INTO #__modules_menu VALUES(28,417);
INSERT INTO #__modules_menu VALUES(28,418);
INSERT INTO #__modules_menu VALUES(28,419);
INSERT INTO #__modules_menu VALUES(28,422);
INSERT INTO #__modules_menu VALUES(28,423);
INSERT INTO #__modules_menu VALUES(28,424);
INSERT INTO #__modules_menu VALUES(28,427);
INSERT INTO #__modules_menu VALUES(28,429);
INSERT INTO #__modules_menu VALUES(28,430);
INSERT INTO #__modules_menu VALUES(28,431);
INSERT INTO #__modules_menu VALUES(28,432);
INSERT INTO #__modules_menu VALUES(28,433);
INSERT INTO #__modules_menu VALUES(28,435);
INSERT INTO #__modules_menu VALUES(28,436);
INSERT INTO #__modules_menu VALUES(28,437);
INSERT INTO #__modules_menu VALUES(28,438);
INSERT INTO #__modules_menu VALUES(28,439);
INSERT INTO #__modules_menu VALUES(28,443);
INSERT INTO #__modules_menu VALUES(28,444);
INSERT INTO #__modules_menu VALUES(28,445);
INSERT INTO #__modules_menu VALUES(28,446);
INSERT INTO #__modules_menu VALUES(28,447);
INSERT INTO #__modules_menu VALUES(28,448);
INSERT INTO #__modules_menu VALUES(28,449);
INSERT INTO #__modules_menu VALUES(28,450);
INSERT INTO #__modules_menu VALUES(28,452);
INSERT INTO #__modules_menu VALUES(28,453);
INSERT INTO #__modules_menu VALUES(28,455);
INSERT INTO #__modules_menu VALUES(28,456);
INSERT INTO #__modules_menu VALUES(28,457);
INSERT INTO #__modules_menu VALUES(28,458);
INSERT INTO #__modules_menu VALUES(28,459);
INSERT INTO #__modules_menu VALUES(28,462);
INSERT INTO #__modules_menu VALUES(28,463);
INSERT INTO #__modules_menu VALUES(28,464);
INSERT INTO #__modules_menu VALUES(28,466);
INSERT INTO #__modules_menu VALUES(28,467);
INSERT INTO #__modules_menu VALUES(29,201);
INSERT INTO #__modules_menu VALUES(29,207);
INSERT INTO #__modules_menu VALUES(29,227);
INSERT INTO #__modules_menu VALUES(29,229);
INSERT INTO #__modules_menu VALUES(29,233);
INSERT INTO #__modules_menu VALUES(29,234);
INSERT INTO #__modules_menu VALUES(29,238);
INSERT INTO #__modules_menu VALUES(29,242);
INSERT INTO #__modules_menu VALUES(29,243);
INSERT INTO #__modules_menu VALUES(29,244);
INSERT INTO #__modules_menu VALUES(29,249);
INSERT INTO #__modules_menu VALUES(29,251);
INSERT INTO #__modules_menu VALUES(29,252);
INSERT INTO #__modules_menu VALUES(29,253);
INSERT INTO #__modules_menu VALUES(29,254);
INSERT INTO #__modules_menu VALUES(29,255);
INSERT INTO #__modules_menu VALUES(29,256);
INSERT INTO #__modules_menu VALUES(29,257);
INSERT INTO #__modules_menu VALUES(29,259);
INSERT INTO #__modules_menu VALUES(29,260);
INSERT INTO #__modules_menu VALUES(29,262);
INSERT INTO #__modules_menu VALUES(29,263);
INSERT INTO #__modules_menu VALUES(29,265);
INSERT INTO #__modules_menu VALUES(29,266);
INSERT INTO #__modules_menu VALUES(29,267);
INSERT INTO #__modules_menu VALUES(29,268);
INSERT INTO #__modules_menu VALUES(29,270);
INSERT INTO #__modules_menu VALUES(29,271);
INSERT INTO #__modules_menu VALUES(29,272);
INSERT INTO #__modules_menu VALUES(29,273);
INSERT INTO #__modules_menu VALUES(29,274);
INSERT INTO #__modules_menu VALUES(29,275);
INSERT INTO #__modules_menu VALUES(29,276);
INSERT INTO #__modules_menu VALUES(29,277);
INSERT INTO #__modules_menu VALUES(29,278);
INSERT INTO #__modules_menu VALUES(29,279);
INSERT INTO #__modules_menu VALUES(29,281);
INSERT INTO #__modules_menu VALUES(29,282);
INSERT INTO #__modules_menu VALUES(29,283);
INSERT INTO #__modules_menu VALUES(29,284);
INSERT INTO #__modules_menu VALUES(29,285);
INSERT INTO #__modules_menu VALUES(29,290);
INSERT INTO #__modules_menu VALUES(29,294);
INSERT INTO #__modules_menu VALUES(29,296);
INSERT INTO #__modules_menu VALUES(29,300);
INSERT INTO #__modules_menu VALUES(29,301);
INSERT INTO #__modules_menu VALUES(29,302);
INSERT INTO #__modules_menu VALUES(29,303);
INSERT INTO #__modules_menu VALUES(29,304);
INSERT INTO #__modules_menu VALUES(29,305);
INSERT INTO #__modules_menu VALUES(29,306);
INSERT INTO #__modules_menu VALUES(29,307);
INSERT INTO #__modules_menu VALUES(29,309);
INSERT INTO #__modules_menu VALUES(29,310);
INSERT INTO #__modules_menu VALUES(29,311);
INSERT INTO #__modules_menu VALUES(29,312);
INSERT INTO #__modules_menu VALUES(29,313);
INSERT INTO #__modules_menu VALUES(29,316);
INSERT INTO #__modules_menu VALUES(29,317);
INSERT INTO #__modules_menu VALUES(29,318);
INSERT INTO #__modules_menu VALUES(29,319);
INSERT INTO #__modules_menu VALUES(29,320);
INSERT INTO #__modules_menu VALUES(29,321);
INSERT INTO #__modules_menu VALUES(29,322);
INSERT INTO #__modules_menu VALUES(29,323);
INSERT INTO #__modules_menu VALUES(29,324);
INSERT INTO #__modules_menu VALUES(29,325);
INSERT INTO #__modules_menu VALUES(29,326);
INSERT INTO #__modules_menu VALUES(29,399);
INSERT INTO #__modules_menu VALUES(29,400);
INSERT INTO #__modules_menu VALUES(29,402);
INSERT INTO #__modules_menu VALUES(29,403);
INSERT INTO #__modules_menu VALUES(29,404);
INSERT INTO #__modules_menu VALUES(29,405);
INSERT INTO #__modules_menu VALUES(29,406);
INSERT INTO #__modules_menu VALUES(29,409);
INSERT INTO #__modules_menu VALUES(29,410);
INSERT INTO #__modules_menu VALUES(29,411);
INSERT INTO #__modules_menu VALUES(29,412);
INSERT INTO #__modules_menu VALUES(29,413);
INSERT INTO #__modules_menu VALUES(29,414);
INSERT INTO #__modules_menu VALUES(29,415);
INSERT INTO #__modules_menu VALUES(29,416);
INSERT INTO #__modules_menu VALUES(29,417);
INSERT INTO #__modules_menu VALUES(29,418);
INSERT INTO #__modules_menu VALUES(29,419);
INSERT INTO #__modules_menu VALUES(29,422);
INSERT INTO #__modules_menu VALUES(29,423);
INSERT INTO #__modules_menu VALUES(29,424);
INSERT INTO #__modules_menu VALUES(29,427);
INSERT INTO #__modules_menu VALUES(29,429);
INSERT INTO #__modules_menu VALUES(29,430);
INSERT INTO #__modules_menu VALUES(29,431);
INSERT INTO #__modules_menu VALUES(29,432);
INSERT INTO #__modules_menu VALUES(29,433);
INSERT INTO #__modules_menu VALUES(29,435);
INSERT INTO #__modules_menu VALUES(29,436);
INSERT INTO #__modules_menu VALUES(29,437);
INSERT INTO #__modules_menu VALUES(29,438);
INSERT INTO #__modules_menu VALUES(29,439);
INSERT INTO #__modules_menu VALUES(29,443);
INSERT INTO #__modules_menu VALUES(29,444);
INSERT INTO #__modules_menu VALUES(29,445);
INSERT INTO #__modules_menu VALUES(29,446);
INSERT INTO #__modules_menu VALUES(29,447);
INSERT INTO #__modules_menu VALUES(29,448);
INSERT INTO #__modules_menu VALUES(29,449);
INSERT INTO #__modules_menu VALUES(29,450);
INSERT INTO #__modules_menu VALUES(29,452);
INSERT INTO #__modules_menu VALUES(29,453);
INSERT INTO #__modules_menu VALUES(29,455);
INSERT INTO #__modules_menu VALUES(29,456);
INSERT INTO #__modules_menu VALUES(29,457);
INSERT INTO #__modules_menu VALUES(29,458);
INSERT INTO #__modules_menu VALUES(29,459);
INSERT INTO #__modules_menu VALUES(29,462);
INSERT INTO #__modules_menu VALUES(29,463);
INSERT INTO #__modules_menu VALUES(29,464);
INSERT INTO #__modules_menu VALUES(29,466);
INSERT INTO #__modules_menu VALUES(29,467);
INSERT INTO #__modules_menu VALUES(30,410);
INSERT INTO #__modules_menu VALUES(31,309);
INSERT INTO #__modules_menu VALUES(31,435);
INSERT INTO #__modules_menu VALUES(32,309);
INSERT INTO #__modules_menu VALUES(33,307);
INSERT INTO #__modules_menu VALUES(34,201);
INSERT INTO #__modules_menu VALUES(34,207);
INSERT INTO #__modules_menu VALUES(34,227);
INSERT INTO #__modules_menu VALUES(34,229);
INSERT INTO #__modules_menu VALUES(34,233);
INSERT INTO #__modules_menu VALUES(34,234);
INSERT INTO #__modules_menu VALUES(34,238);
INSERT INTO #__modules_menu VALUES(34,242);
INSERT INTO #__modules_menu VALUES(34,243);
INSERT INTO #__modules_menu VALUES(34,244);
INSERT INTO #__modules_menu VALUES(34,249);
INSERT INTO #__modules_menu VALUES(34,251);
INSERT INTO #__modules_menu VALUES(34,252);
INSERT INTO #__modules_menu VALUES(34,253);
INSERT INTO #__modules_menu VALUES(34,254);
INSERT INTO #__modules_menu VALUES(34,255);
INSERT INTO #__modules_menu VALUES(34,256);
INSERT INTO #__modules_menu VALUES(34,257);
INSERT INTO #__modules_menu VALUES(34,259);
INSERT INTO #__modules_menu VALUES(34,260);
INSERT INTO #__modules_menu VALUES(34,262);
INSERT INTO #__modules_menu VALUES(34,263);
INSERT INTO #__modules_menu VALUES(34,265);
INSERT INTO #__modules_menu VALUES(34,266);
INSERT INTO #__modules_menu VALUES(34,267);
INSERT INTO #__modules_menu VALUES(34,268);
INSERT INTO #__modules_menu VALUES(34,270);
INSERT INTO #__modules_menu VALUES(34,271);
INSERT INTO #__modules_menu VALUES(34,272);
INSERT INTO #__modules_menu VALUES(34,273);
INSERT INTO #__modules_menu VALUES(34,274);
INSERT INTO #__modules_menu VALUES(34,275);
INSERT INTO #__modules_menu VALUES(34,276);
INSERT INTO #__modules_menu VALUES(34,277);
INSERT INTO #__modules_menu VALUES(34,278);
INSERT INTO #__modules_menu VALUES(34,279);
INSERT INTO #__modules_menu VALUES(34,281);
INSERT INTO #__modules_menu VALUES(34,282);
INSERT INTO #__modules_menu VALUES(34,283);
INSERT INTO #__modules_menu VALUES(34,284);
INSERT INTO #__modules_menu VALUES(34,285);
INSERT INTO #__modules_menu VALUES(34,290);
INSERT INTO #__modules_menu VALUES(34,294);
INSERT INTO #__modules_menu VALUES(34,296);
INSERT INTO #__modules_menu VALUES(34,300);
INSERT INTO #__modules_menu VALUES(34,301);
INSERT INTO #__modules_menu VALUES(34,302);
INSERT INTO #__modules_menu VALUES(34,303);
INSERT INTO #__modules_menu VALUES(34,304);
INSERT INTO #__modules_menu VALUES(34,305);
INSERT INTO #__modules_menu VALUES(34,306);
INSERT INTO #__modules_menu VALUES(34,307);
INSERT INTO #__modules_menu VALUES(34,309);
INSERT INTO #__modules_menu VALUES(34,310);
INSERT INTO #__modules_menu VALUES(34,311);
INSERT INTO #__modules_menu VALUES(34,312);
INSERT INTO #__modules_menu VALUES(34,313);
INSERT INTO #__modules_menu VALUES(34,316);
INSERT INTO #__modules_menu VALUES(34,317);
INSERT INTO #__modules_menu VALUES(34,318);
INSERT INTO #__modules_menu VALUES(34,319);
INSERT INTO #__modules_menu VALUES(34,320);
INSERT INTO #__modules_menu VALUES(34,321);
INSERT INTO #__modules_menu VALUES(34,322);
INSERT INTO #__modules_menu VALUES(34,323);
INSERT INTO #__modules_menu VALUES(34,324);
INSERT INTO #__modules_menu VALUES(34,325);
INSERT INTO #__modules_menu VALUES(34,326);
INSERT INTO #__modules_menu VALUES(34,399);
INSERT INTO #__modules_menu VALUES(34,400);
INSERT INTO #__modules_menu VALUES(34,402);
INSERT INTO #__modules_menu VALUES(34,403);
INSERT INTO #__modules_menu VALUES(34,404);
INSERT INTO #__modules_menu VALUES(34,405);
INSERT INTO #__modules_menu VALUES(34,406);
INSERT INTO #__modules_menu VALUES(34,409);
INSERT INTO #__modules_menu VALUES(34,410);
INSERT INTO #__modules_menu VALUES(34,411);
INSERT INTO #__modules_menu VALUES(34,412);
INSERT INTO #__modules_menu VALUES(34,413);
INSERT INTO #__modules_menu VALUES(34,414);
INSERT INTO #__modules_menu VALUES(34,415);
INSERT INTO #__modules_menu VALUES(34,416);
INSERT INTO #__modules_menu VALUES(34,417);
INSERT INTO #__modules_menu VALUES(34,418);
INSERT INTO #__modules_menu VALUES(34,419);
INSERT INTO #__modules_menu VALUES(34,422);
INSERT INTO #__modules_menu VALUES(34,423);
INSERT INTO #__modules_menu VALUES(34,424);
INSERT INTO #__modules_menu VALUES(34,427);
INSERT INTO #__modules_menu VALUES(34,429);
INSERT INTO #__modules_menu VALUES(34,430);
INSERT INTO #__modules_menu VALUES(34,431);
INSERT INTO #__modules_menu VALUES(34,432);
INSERT INTO #__modules_menu VALUES(34,433);
INSERT INTO #__modules_menu VALUES(34,435);
INSERT INTO #__modules_menu VALUES(34,436);
INSERT INTO #__modules_menu VALUES(34,437);
INSERT INTO #__modules_menu VALUES(34,438);
INSERT INTO #__modules_menu VALUES(34,439);
INSERT INTO #__modules_menu VALUES(34,443);
INSERT INTO #__modules_menu VALUES(34,444);
INSERT INTO #__modules_menu VALUES(34,445);
INSERT INTO #__modules_menu VALUES(34,446);
INSERT INTO #__modules_menu VALUES(34,447);
INSERT INTO #__modules_menu VALUES(34,448);
INSERT INTO #__modules_menu VALUES(34,449);
INSERT INTO #__modules_menu VALUES(34,450);
INSERT INTO #__modules_menu VALUES(34,452);
INSERT INTO #__modules_menu VALUES(34,453);
INSERT INTO #__modules_menu VALUES(34,455);
INSERT INTO #__modules_menu VALUES(34,456);
INSERT INTO #__modules_menu VALUES(34,457);
INSERT INTO #__modules_menu VALUES(34,458);
INSERT INTO #__modules_menu VALUES(34,459);
INSERT INTO #__modules_menu VALUES(34,462);
INSERT INTO #__modules_menu VALUES(34,463);
INSERT INTO #__modules_menu VALUES(34,464);
INSERT INTO #__modules_menu VALUES(34,466);
INSERT INTO #__modules_menu VALUES(34,467);
INSERT INTO #__modules_menu VALUES(35,306);
INSERT INTO #__modules_menu VALUES(36,304);
INSERT INTO #__modules_menu VALUES(37,311);
INSERT INTO #__modules_menu VALUES(38,300);
INSERT INTO #__modules_menu VALUES(39,301);
INSERT INTO #__modules_menu VALUES(40,313);
INSERT INTO #__modules_menu VALUES(41,324);
INSERT INTO #__modules_menu VALUES(44,0);
INSERT INTO #__modules_menu VALUES(45,201);
INSERT INTO #__modules_menu VALUES(45,207);
INSERT INTO #__modules_menu VALUES(45,227);
INSERT INTO #__modules_menu VALUES(45,229);
INSERT INTO #__modules_menu VALUES(45,233);
INSERT INTO #__modules_menu VALUES(45,234);
INSERT INTO #__modules_menu VALUES(45,238);
INSERT INTO #__modules_menu VALUES(45,242);
INSERT INTO #__modules_menu VALUES(45,243);
INSERT INTO #__modules_menu VALUES(45,244);
INSERT INTO #__modules_menu VALUES(45,249);
INSERT INTO #__modules_menu VALUES(45,251);
INSERT INTO #__modules_menu VALUES(45,252);
INSERT INTO #__modules_menu VALUES(45,253);
INSERT INTO #__modules_menu VALUES(45,254);
INSERT INTO #__modules_menu VALUES(45,255);
INSERT INTO #__modules_menu VALUES(45,256);
INSERT INTO #__modules_menu VALUES(45,257);
INSERT INTO #__modules_menu VALUES(45,259);
INSERT INTO #__modules_menu VALUES(45,260);
INSERT INTO #__modules_menu VALUES(45,262);
INSERT INTO #__modules_menu VALUES(45,263);
INSERT INTO #__modules_menu VALUES(45,265);
INSERT INTO #__modules_menu VALUES(45,266);
INSERT INTO #__modules_menu VALUES(45,267);
INSERT INTO #__modules_menu VALUES(45,268);
INSERT INTO #__modules_menu VALUES(45,270);
INSERT INTO #__modules_menu VALUES(45,271);
INSERT INTO #__modules_menu VALUES(45,272);
INSERT INTO #__modules_menu VALUES(45,273);
INSERT INTO #__modules_menu VALUES(45,274);
INSERT INTO #__modules_menu VALUES(45,275);
INSERT INTO #__modules_menu VALUES(45,276);
INSERT INTO #__modules_menu VALUES(45,277);
INSERT INTO #__modules_menu VALUES(45,278);
INSERT INTO #__modules_menu VALUES(45,279);
INSERT INTO #__modules_menu VALUES(45,281);
INSERT INTO #__modules_menu VALUES(45,282);
INSERT INTO #__modules_menu VALUES(45,283);
INSERT INTO #__modules_menu VALUES(45,284);
INSERT INTO #__modules_menu VALUES(45,285);
INSERT INTO #__modules_menu VALUES(45,290);
INSERT INTO #__modules_menu VALUES(45,294);
INSERT INTO #__modules_menu VALUES(45,296);
INSERT INTO #__modules_menu VALUES(45,300);
INSERT INTO #__modules_menu VALUES(45,301);
INSERT INTO #__modules_menu VALUES(45,302);
INSERT INTO #__modules_menu VALUES(45,303);
INSERT INTO #__modules_menu VALUES(45,304);
INSERT INTO #__modules_menu VALUES(45,305);
INSERT INTO #__modules_menu VALUES(45,306);
INSERT INTO #__modules_menu VALUES(45,307);
INSERT INTO #__modules_menu VALUES(45,309);
INSERT INTO #__modules_menu VALUES(45,310);
INSERT INTO #__modules_menu VALUES(45,311);
INSERT INTO #__modules_menu VALUES(45,312);
INSERT INTO #__modules_menu VALUES(45,313);
INSERT INTO #__modules_menu VALUES(45,316);
INSERT INTO #__modules_menu VALUES(45,317);
INSERT INTO #__modules_menu VALUES(45,318);
INSERT INTO #__modules_menu VALUES(45,319);
INSERT INTO #__modules_menu VALUES(45,320);
INSERT INTO #__modules_menu VALUES(45,321);
INSERT INTO #__modules_menu VALUES(45,322);
INSERT INTO #__modules_menu VALUES(45,323);
INSERT INTO #__modules_menu VALUES(45,324);
INSERT INTO #__modules_menu VALUES(45,325);
INSERT INTO #__modules_menu VALUES(45,326);
INSERT INTO #__modules_menu VALUES(45,399);
INSERT INTO #__modules_menu VALUES(45,400);
INSERT INTO #__modules_menu VALUES(45,402);
INSERT INTO #__modules_menu VALUES(45,403);
INSERT INTO #__modules_menu VALUES(45,404);
INSERT INTO #__modules_menu VALUES(45,405);
INSERT INTO #__modules_menu VALUES(45,406);
INSERT INTO #__modules_menu VALUES(45,409);
INSERT INTO #__modules_menu VALUES(45,410);
INSERT INTO #__modules_menu VALUES(45,411);
INSERT INTO #__modules_menu VALUES(45,412);
INSERT INTO #__modules_menu VALUES(45,413);
INSERT INTO #__modules_menu VALUES(45,414);
INSERT INTO #__modules_menu VALUES(45,415);
INSERT INTO #__modules_menu VALUES(45,416);
INSERT INTO #__modules_menu VALUES(45,417);
INSERT INTO #__modules_menu VALUES(45,418);
INSERT INTO #__modules_menu VALUES(45,419);
INSERT INTO #__modules_menu VALUES(45,422);
INSERT INTO #__modules_menu VALUES(45,423);
INSERT INTO #__modules_menu VALUES(45,424);
INSERT INTO #__modules_menu VALUES(45,427);
INSERT INTO #__modules_menu VALUES(45,429);
INSERT INTO #__modules_menu VALUES(45,430);
INSERT INTO #__modules_menu VALUES(45,431);
INSERT INTO #__modules_menu VALUES(45,432);
INSERT INTO #__modules_menu VALUES(45,433);
INSERT INTO #__modules_menu VALUES(45,435);
INSERT INTO #__modules_menu VALUES(45,436);
INSERT INTO #__modules_menu VALUES(45,437);
INSERT INTO #__modules_menu VALUES(45,438);
INSERT INTO #__modules_menu VALUES(45,439);
INSERT INTO #__modules_menu VALUES(45,443);
INSERT INTO #__modules_menu VALUES(45,444);
INSERT INTO #__modules_menu VALUES(45,445);
INSERT INTO #__modules_menu VALUES(45,446);
INSERT INTO #__modules_menu VALUES(45,447);
INSERT INTO #__modules_menu VALUES(45,448);
INSERT INTO #__modules_menu VALUES(45,449);
INSERT INTO #__modules_menu VALUES(45,450);
INSERT INTO #__modules_menu VALUES(45,452);
INSERT INTO #__modules_menu VALUES(45,453);
INSERT INTO #__modules_menu VALUES(45,455);
INSERT INTO #__modules_menu VALUES(45,456);
INSERT INTO #__modules_menu VALUES(45,457);
INSERT INTO #__modules_menu VALUES(45,458);
INSERT INTO #__modules_menu VALUES(45,459);
INSERT INTO #__modules_menu VALUES(45,462);
INSERT INTO #__modules_menu VALUES(45,463);
INSERT INTO #__modules_menu VALUES(45,464);
INSERT INTO #__modules_menu VALUES(45,466);
INSERT INTO #__modules_menu VALUES(45,467);
INSERT INTO #__modules_menu VALUES(47,231);
INSERT INTO #__modules_menu VALUES(47,234);
INSERT INTO #__modules_menu VALUES(47,242);
INSERT INTO #__modules_menu VALUES(47,243);
INSERT INTO #__modules_menu VALUES(47,244);
INSERT INTO #__modules_menu VALUES(47,296);
INSERT INTO #__modules_menu VALUES(47,399);
INSERT INTO #__modules_menu VALUES(47,400);
INSERT INTO #__modules_menu VALUES(48,0);
INSERT INTO #__modules_menu VALUES(49,417);
INSERT INTO #__modules_menu VALUES(52,-435);
INSERT INTO #__modules_menu VALUES(56,305);
INSERT INTO #__modules_menu VALUES(57,238);
INSERT INTO #__modules_menu VALUES(57,427);
INSERT INTO #__modules_menu VALUES(57,429);
INSERT INTO #__modules_menu VALUES(57,430);
INSERT INTO #__modules_menu VALUES(57,431);
INSERT INTO #__modules_menu VALUES(57,432);
INSERT INTO #__modules_menu VALUES(57,433);
INSERT INTO #__modules_menu VALUES(57,462);
INSERT INTO #__modules_menu VALUES(57,463);
INSERT INTO #__modules_menu VALUES(58,427);
INSERT INTO #__modules_menu VALUES(58,429);
INSERT INTO #__modules_menu VALUES(58,430);
INSERT INTO #__modules_menu VALUES(58,431);
INSERT INTO #__modules_menu VALUES(58,432);
INSERT INTO #__modules_menu VALUES(58,433);
INSERT INTO #__modules_menu VALUES(58,462);
INSERT INTO #__modules_menu VALUES(58,463);
INSERT INTO #__modules_menu VALUES(61,443);
INSERT INTO #__modules_menu VALUES(62,231);
INSERT INTO #__modules_menu VALUES(62,234);
INSERT INTO #__modules_menu VALUES(62,242);
INSERT INTO #__modules_menu VALUES(62,243);
INSERT INTO #__modules_menu VALUES(62,244);
INSERT INTO #__modules_menu VALUES(62,296);
INSERT INTO #__modules_menu VALUES(62,399);
INSERT INTO #__modules_menu VALUES(62,400);
INSERT INTO #__modules_menu VALUES(63,0);
INSERT INTO #__modules_menu VALUES(64,447);
INSERT INTO #__modules_menu VALUES(65,427);
INSERT INTO #__modules_menu VALUES(65,429);
INSERT INTO #__modules_menu VALUES(65,430);
INSERT INTO #__modules_menu VALUES(65,431);
INSERT INTO #__modules_menu VALUES(65,432);
INSERT INTO #__modules_menu VALUES(65,433);
INSERT INTO #__modules_menu VALUES(65,462);
INSERT INTO #__modules_menu VALUES(65,463);
INSERT INTO #__modules_menu VALUES(68,243);
INSERT INTO #__modules_menu VALUES(69,459);
INSERT INTO #__modules_menu VALUES(70,285);
INSERT INTO #__modules_menu VALUES(70,316);
INSERT INTO #__modules_menu VALUES(71,285);
INSERT INTO #__modules_menu VALUES(71,316);
INSERT INTO #__modules_menu VALUES(72,285);
INSERT INTO #__modules_menu VALUES(72,316);
INSERT INTO #__modules_menu VALUES(73,285);
INSERT INTO #__modules_menu VALUES(73,316);
INSERT INTO #__modules_menu VALUES(74,285);
INSERT INTO #__modules_menu VALUES(74,316);
INSERT INTO #__modules_menu VALUES(75,285);
INSERT INTO #__modules_menu VALUES(75,316);
INSERT INTO #__modules_menu VALUES(76,285);
INSERT INTO #__modules_menu VALUES(76,316);
INSERT INTO #__modules_menu VALUES(77,0);
INSERT INTO #__modules_menu VALUES(78,0);
INSERT INTO #__modules_menu VALUES(79,0);
INSERT INTO #__modules_menu VALUES(84,467);
INSERT INTO #__modules_menu VALUES(86,0);
INSERT INTO #__modules_menu VALUES(87,0);
INSERT INTO #__modules_menu VALUES(88,0);
INSERT INTO #__modules_menu VALUES(89,0);
INSERT INTO #__modules_menu VALUES(125,280);
INSERT INTO #__modules_menu VALUES(126,280);
INSERT INTO #__modules_menu VALUES(127,280);
INSERT INTO #__modules_menu VALUES(128,280);
INSERT INTO #__modules_menu VALUES(129,280);
INSERT INTO #__modules_menu VALUES(130,280);
INSERT INTO #__modules_menu VALUES(131,280);
INSERT INTO #__modules_menu VALUES(132,280);
INSERT INTO #__modules_menu VALUES(133,280);
INSERT INTO #__modules_menu VALUES(134,280);
INSERT INTO #__modules_menu VALUES(135,280);
INSERT INTO #__modules_menu VALUES(136,280);
INSERT INTO #__modules_menu VALUES(137,280);
INSERT INTO #__modules_menu VALUES(138,280);
INSERT INTO #__modules_menu VALUES(139,280);
INSERT INTO #__modules_menu VALUES(140,280);
INSERT INTO #__modules_menu VALUES(141,280);
INSERT INTO #__modules_menu VALUES(142,280);
INSERT INTO #__modules_menu VALUES(143,280);
INSERT INTO #__modules_menu VALUES(144,280);
INSERT INTO #__modules_menu VALUES(145,280);
INSERT INTO #__modules_menu VALUES(146,280);
INSERT INTO #__modules_menu VALUES(147,280);
INSERT INTO #__modules_menu VALUES(149,435);
INSERT INTO #__modules_menu VALUES(150,472);
INSERT INTO #__modules_menu VALUES(150,473);
INSERT INTO #__modules_menu VALUES(150,475);
INSERT INTO #__modules_menu VALUES(150,476);
INSERT INTO #__modules_menu VALUES(150,477);
INSERT INTO #__modules_menu VALUES(151,201);
INSERT INTO #__modules_menu VALUES(151,207);
INSERT INTO #__modules_menu VALUES(151,233);
INSERT INTO #__modules_menu VALUES(151,234);
INSERT INTO #__modules_menu VALUES(151,238);
INSERT INTO #__modules_menu VALUES(151,242);
INSERT INTO #__modules_menu VALUES(151,243);
INSERT INTO #__modules_menu VALUES(151,244);
INSERT INTO #__modules_menu VALUES(151,290);
INSERT INTO #__modules_menu VALUES(151,294);
INSERT INTO #__modules_menu VALUES(151,296);
INSERT INTO #__modules_menu VALUES(151,399);
INSERT INTO #__modules_menu VALUES(151,400);
INSERT INTO #__modules_menu VALUES(151,427);
INSERT INTO #__modules_menu VALUES(151,429);
INSERT INTO #__modules_menu VALUES(151,430);
INSERT INTO #__modules_menu VALUES(151,431);
INSERT INTO #__modules_menu VALUES(151,432);
INSERT INTO #__modules_menu VALUES(151,433);
INSERT INTO #__modules_menu VALUES(151,438);
INSERT INTO #__modules_menu VALUES(151,439);
INSERT INTO #__modules_menu VALUES(151,444);
INSERT INTO #__modules_menu VALUES(151,445);
INSERT INTO #__modules_menu VALUES(151,446);
INSERT INTO #__modules_menu VALUES(151,448);
INSERT INTO #__modules_menu VALUES(151,449);
INSERT INTO #__modules_menu VALUES(151,450);
INSERT INTO #__modules_menu VALUES(151,455);
INSERT INTO #__modules_menu VALUES(151,462);
INSERT INTO #__modules_menu VALUES(151,463);
INSERT INTO #__modules_menu VALUES(151,464);
INSERT INTO #__modules_menu VALUES(151,472);
INSERT INTO #__modules_menu VALUES(152,435);
INSERT INTO #__modules_menu VALUES(152,472);
INSERT INTO #__modules_menu VALUES(152,473);
INSERT INTO #__modules_menu VALUES(152,474);
INSERT INTO #__modules_menu VALUES(152,475);
INSERT INTO #__modules_menu VALUES(152,476);
INSERT INTO #__modules_menu VALUES(152,477);
INSERT INTO #__modules_menu VALUES(152,478);
INSERT INTO #__modules_menu VALUES(153,472);
INSERT INTO #__modules_menu VALUES(153,475);
INSERT INTO #__modules_menu VALUES(154,0);
INSERT INTO #__modules_menu VALUES(161,474);
INSERT INTO #__modules_menu VALUES(168,480);
INSERT INTO #__modules_menu VALUES(168,481);
INSERT INTO #__modules_menu VALUES(168,482);
INSERT INTO #__modules_menu VALUES(168,483);
INSERT INTO #__modules_menu VALUES(168,484);
INSERT INTO #__modules_menu VALUES(169,480);
INSERT INTO #__modules_menu VALUES(169,483);
INSERT INTO #__modules_menu VALUES(170,480);
INSERT INTO #__modules_menu VALUES(170,483);
INSERT INTO #__modules_menu VALUES(171,481);
INSERT INTO #__modules_menu VALUES(172,480);
INSERT INTO #__modules_menu VALUES(172,481);
INSERT INTO #__modules_menu VALUES(172,482);
INSERT INTO #__modules_menu VALUES(172,483);
INSERT INTO #__modules_menu VALUES(172,484);
INSERT INTO #__modules_menu VALUES(173,480);
INSERT INTO #__modules_menu VALUES(173,482);
INSERT INTO #__modules_menu VALUES(173,483);
INSERT INTO #__modules_menu VALUES(174,0);
INSERT INTO #__modules_menu VALUES(175,0);
INSERT INTO #__modules_menu VALUES(176,472);
INSERT INTO #__modules_menu VALUES(177,472);
INSERT INTO #__modules_menu VALUES(177,475);
INSERT INTO #__modules_menu VALUES(178,472);
INSERT INTO #__modules_menu VALUES(178,475);
INSERT INTO #__modules_menu VALUES(180,482);
INSERT INTO #__modules_menu VALUES(181,435);
INSERT INTO #__modules_menu VALUES(185,435);
INSERT INTO #__modules_menu VALUES(185,472);
INSERT INTO #__modules_menu VALUES(185,476);
INSERT INTO #__modules_menu VALUES(185,477);
INSERT INTO #__modules_menu VALUES(186,435);
INSERT INTO #__modules_menu VALUES(186,472);
INSERT INTO #__modules_menu VALUES(186,476);
INSERT INTO #__modules_menu VALUES(186,477);
INSERT INTO #__modules_menu VALUES(187,435);
INSERT INTO #__modules_menu VALUES(187,472);
INSERT INTO #__modules_menu VALUES(187,476);
INSERT INTO #__modules_menu VALUES(187,477);
INSERT INTO #__modules_menu VALUES(188,435);
INSERT INTO #__modules_menu VALUES(189,435);
INSERT INTO #__modules_menu VALUES(190,435);
INSERT INTO #__modules_menu VALUES(191,435);
INSERT INTO #__modules_menu VALUES(192,472);
INSERT INTO #__modules_menu VALUES(192,482);
INSERT INTO #__modules_menu VALUES(193,480);
INSERT INTO #__modules_menu VALUES(193,481);
INSERT INTO #__modules_menu VALUES(193,483);



DROP TABLE IF EXISTS #__newsfeeds;

CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

INSERT INTO #__newsfeeds VALUES(17,1,'Joomla! Announcements','joomla-announcements','http://www.joomla.org/announcements.feed?type=rss','',1,5,3600,0,'0000-00-00 00:00:00',1,1,1,'en-GB','{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}','2011-01-01 00:00:01',614,'','2011-12-27 12:25:05',42,'','','{\"robots\":\"\",\"rights\":\"\"}','','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__newsfeeds VALUES(17,2,'New Joomla! Extensions','new-joomla-extensions','http://feeds.joomla.org/JoomlaExtensions','',1,5,3600,0,'0000-00-00 00:00:00',4,1,1,'en-GB','{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}','2011-01-01 00:00:01',614,'','2011-12-27 12:25:36',42,'','','{\"robots\":\"\",\"rights\":\"\"}','','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__newsfeeds VALUES(17,3,'Joomla! Security News','joomla-security-news','http://feeds.joomla.org/JoomlaSecurityNews','',1,5,3600,0,'0000-00-00 00:00:00',2,1,1,'en-GB','{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}','2011-01-01 00:00:01',614,'','2011-12-27 12:24:55',42,'','','{\"robots\":\"\",\"rights\":\"\"}','','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__newsfeeds VALUES(17,4,'Joomla! Connect','joomla-connect','http://feeds.joomla.org/JoomlaConnect','',1,5,3600,0,'0000-00-00 00:00:00',3,1,1,'en-GB','{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"newsfeed_layout\":\"\",\"feed_display_order\":\"\"}','2011-01-01 00:00:01',614,'','2011-12-27 12:25:10',42,'','','{\"robots\":\"\",\"rights\":\"\"}','','0000-00-00 00:00:00','0000-00-00 00:00:00');



DROP TABLE IF EXISTS #__overrider;

CREATE TABLE `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__schemas;

CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) DEFAULT CHARSET=utf8;

INSERT INTO #__schemas VALUES(700,'2.5.8');
INSERT INTO #__schemas VALUES(10002,'2.0');
INSERT INTO #__schemas VALUES(10005,'2.1');
INSERT INTO #__schemas VALUES(10040,'2.2.5');



DROP TABLE IF EXISTS #__template_styles;

CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) AUTO_INCREMENT=116 DEFAULT CHARSET=utf8;

INSERT INTO #__template_styles VALUES(2,'bluestork',1,'1','Bluestork - Default','{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\"}');
INSERT INTO #__template_styles VALUES(3,'atomic',0,'0','Atomic - Default','{}');
INSERT INTO #__template_styles VALUES(4,'beez_20',0,'0','Beez2 - Default','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\",\"html5\":\"0\"}');
INSERT INTO #__template_styles VALUES(5,'hathor',1,'0','Hathor - Default','{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}');
INSERT INTO #__template_styles VALUES(6,'beez5',0,'0','Beez5 - Default','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/sampledata\\/fruitshop\\/fruits.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"html5\":\"0\"}');
INSERT INTO #__template_styles VALUES(114,'beez_20',0,'0','Beez2 - Parks Site','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"\",\"sitetitle\":\"Australian Parks\",\"sitedescription\":\"Parks Sample Site\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}');
INSERT INTO #__template_styles VALUES(115,'dj-real-estate02',0,'1','dj-real-estate02 - Default','{\"Logo\":\"images\\/modules\\/logo.png\",\"SiteTitle\":\"\",\"SiteDescription\":\"\",\"StyleSwitcher\":\"0\",\"TemplateStyle\":\"1\",\"fontSizeSwitcher\":\"1\",\"backToTop\":\"0\",\"FavIconImg\":\"\",\"TemplateWidth\":\"980\",\"TabletWidth\":\"800\",\"MobileWidth\":\"480\",\"SchemeOption\":\"left-content_right\",\"ColumnLeftWidth\":\"25\",\"ColumnRightWidth\":\"25\",\"fontSizeSelector\":\"12\",\"bodyFontChooser\":\"0;fontFaceChooser\",\"fontFaceChooser\":\"Arial, Helvetica, sans-serif\",\"customFont\":\"Tahoma\",\"bodyGooglewebfontChooser\":\"\",\"bodyGooglewebfontFamily\":\"\",\"djmenuFontSizeSelector\":\"16\",\"djmenuFontChooser\":\"2;djmenuGooglewebfontChooser;djmenuGooglewebfontFamily\",\"djmenuFontFaceChooser\":\"Times New Roman, Times, serif;\",\"djmenuCustomFont\":\"Tahoma\",\"djmenuGooglewebfontChooser\":\"http:\\/\\/fonts.googleapis.com\\/css?family=Open+Sans\",\"djmenuGooglewebfontFamily\":\"\'Open Sans\', sans-serif\",\"headingsFontSizeSelector\":\"18\",\"headingsFontChooser\":\"2;headingsGooglewebfontChooser;headingsGooglewebfontFamily\",\"headingsFontFaceChooser\":\"Times New Roman, Times, serif;\",\"headingsCustomFont\":\"Tahoma\",\"headingsGooglewebfontChooser\":\"http:\\/\\/fonts.googleapis.com\\/css?family=Open+Sans\",\"headingsGooglewebfontFamily\":\"\'Open Sans\', sans-serif\",\"articlesFontSizeSelector\":\"18\",\"articlesFontChooser\":\"2;articlesGooglewebfontChooser;articlesGooglewebfontFamily\",\"articlesFontFaceChooser\":\"Arial, Helvetica, sans-serif\",\"articlesCustomFont\":\"Tahoma\",\"articlesGooglewebfontChooser\":\"http:\\/\\/fonts.googleapis.com\\/css?family=Open+Sans\",\"articlesGooglewebfontFamily\":\"\'Open Sans\', sans-serif\",\"advancedFontSizeSelector\":\"24\",\"advancedFontChooser\":\"0;advancedFontFaceChooser\",\"advancedFontFaceChooser\":\"Arial, Helvetica, sans-serif\",\"advancedCustomFont\":\"Tahoma\",\"advancedGooglewebfontChooser\":\"\",\"advancedGooglewebfontFamily\":\"\",\"advancedSelectors\":\"\",\"GoogleAnalytics\":\"1\",\"GoogleAnalyticsCode\":\"\",\"GoogleWebmaster\":\"1\",\"GoogleWebmasterMeta\":\"\",\"CssCompress\":\"1\"}');



DROP TABLE IF EXISTS #__update_categories;

CREATE TABLE `#__update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
) DEFAULT CHARSET=utf8 COMMENT='Update Categories';




DROP TABLE IF EXISTS #__update_sites;

CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='Update Sites';

INSERT INTO #__update_sites VALUES(1,'Joomla Core','collection','http://update.joomla.org/core/list.xml',1,1352893697);
INSERT INTO #__update_sites VALUES(2,'Joomla Extension Directory','collection','http://update.joomla.org/jed/list.xml',1,1352893697);
INSERT INTO #__update_sites VALUES(3,'Accredited Joomla! Translations','collection','http://update.joomla.org/language/translationlist.xml',1,1352893697);



DROP TABLE IF EXISTS #__update_sites_extensions;

CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';

INSERT INTO #__update_sites_extensions VALUES(1,700);
INSERT INTO #__update_sites_extensions VALUES(2,700);
INSERT INTO #__update_sites_extensions VALUES(3,600);



DROP TABLE IF EXISTS #__updates;

CREATE TABLE `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `categoryid` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) AUTO_INCREMENT=384 DEFAULT CHARSET=utf8 COMMENT='Available Updates';

INSERT INTO #__updates VALUES(1,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.7.3','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(2,3,0,0,'Khmer','','pkg_km-KH','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/km-KH_details.xml','');
INSERT INTO #__updates VALUES(3,3,0,0,'Swedish','','pkg_sv-SE','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/sv-SE_details.xml','');
INSERT INTO #__updates VALUES(4,3,0,0,'Hungarian','','pkg_hu-HU','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hu-HU_details.xml','');
INSERT INTO #__updates VALUES(5,3,0,0,'Bulgarian','','pkg_bg-BG','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/bg-BG_details.xml','');
INSERT INTO #__updates VALUES(6,3,0,0,'French','','pkg_fr-FR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/fr-FR_details.xml','');
INSERT INTO #__updates VALUES(7,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(8,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(9,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(10,3,0,0,'Turkish','','pkg_tr-TR','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/tr-TR_details.xml','');
INSERT INTO #__updates VALUES(11,3,0,0,'Ukrainian','','pkg_uk-UA','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/uk-UA_details.xml','');
INSERT INTO #__updates VALUES(12,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(13,3,0,0,'Belarusian','','pkg_be-BY','package','',0,'2.5.6.1','','http://update.joomla.org/language/details/be-BY_details.xml','');
INSERT INTO #__updates VALUES(14,3,0,0,'Latvian','','pkg_lv-LV','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/lv-LV_details.xml','');
INSERT INTO #__updates VALUES(15,3,0,0,'Estonian','','pkg_et-EE','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/et-EE_details.xml','');
INSERT INTO #__updates VALUES(16,3,0,0,'Romanian','','pkg_ro-RO','package','',0,'2.5.5.1','','http://update.joomla.org/language/details/ro-RO_details.xml','');
INSERT INTO #__updates VALUES(17,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(18,3,0,0,'Macedonian','','pkg_mk-MK','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/mk-MK_details.xml','');
INSERT INTO #__updates VALUES(19,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(20,3,0,0,'Serbian Latin','','pkg_sr-YU','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/sr-YU_details.xml','');
INSERT INTO #__updates VALUES(21,3,0,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ar-AA_details.xml','');
INSERT INTO #__updates VALUES(22,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(23,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(24,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(25,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(26,3,0,0,'Serbian Cyrillic','','pkg_sr-RS','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/sr-RS_details.xml','');
INSERT INTO #__updates VALUES(27,3,0,0,'Lithuanian','','pkg_lt-LT','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/lt-LT_details.xml','');
INSERT INTO #__updates VALUES(28,3,0,0,'Albanian','','pkg_sq-AL','package','',0,'2.5.1.5','','http://update.joomla.org/language/details/sq-AL_details.xml','');
INSERT INTO #__updates VALUES(29,3,0,0,'Persian','','pkg_fa-IR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/fa-IR_details.xml','');
INSERT INTO #__updates VALUES(30,3,0,0,'Galician','','pkg_gl-ES','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/gl-ES_details.xml','');
INSERT INTO #__updates VALUES(31,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(32,3,0,0,'Syriac','','pkg_sy-IQ','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/sy-IQ_details.xml','');
INSERT INTO #__updates VALUES(33,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(34,3,0,0,'Hebrew','','pkg_he-IL','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/he-IL_details.xml','');
INSERT INTO #__updates VALUES(35,3,0,0,'Laotian','','pkg_lo-LA','package','',0,'2.5.6.1','','http://update.joomla.org/language/details/lo-LA_details.xml','');
INSERT INTO #__updates VALUES(36,3,0,0,'Afrikaans','','pkg_af-ZA','package','',0,'2.5.6.2','','http://update.joomla.org/language/details/af-ZA_details.xml','');
INSERT INTO #__updates VALUES(37,3,0,0,'Chinese Simplified','','pkg_zh-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/zh-CN_details.xml','');
INSERT INTO #__updates VALUES(38,3,0,0,'Greek','','pkg_el-GR','package','',0,'2.5.6.1','','http://update.joomla.org/language/details/el-GR_details.xml','');
INSERT INTO #__updates VALUES(39,3,0,0,'Esperanto','','pkg_eo-XX','package','',0,'2.5.6.1','','http://update.joomla.org/language/details/eo-XX_details.xml','');
INSERT INTO #__updates VALUES(40,3,0,0,'Finnish','','pkg_fi-FI','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/fi-FI_details.xml','');
INSERT INTO #__updates VALUES(41,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(42,3,0,0,'Chinese Traditional','','pkg_zh-TW','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/zh-TW_details.xml','');
INSERT INTO #__updates VALUES(43,3,0,0,'Vietnamese','','pkg_vi-VN','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/vi-VN_details.xml','');
INSERT INTO #__updates VALUES(44,3,0,0,'Kurdish Sorani','','pkg_ckb-IQ','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ckb-IQ_details.xml','');
INSERT INTO #__updates VALUES(45,3,0,0,'Bosnian','','pkg_bs-BA','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/bs-BA_details.xml','');
INSERT INTO #__updates VALUES(46,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(47,3,0,0,'Azeri','','pkg_az-AZ','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/az-AZ_details.xml','');
INSERT INTO #__updates VALUES(48,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(49,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(50,3,0,0,'Scottish Gaelic','','pkg_gd-GB','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/gd-GB_details.xml','');
INSERT INTO #__updates VALUES(51,3,0,0,'Thai','','pkg_th-TH','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/th-TH_details.xml','');
INSERT INTO #__updates VALUES(52,3,0,0,'Basque','','pkg_eu-ES','package','',0,'1.7.0.1','','http://update.joomla.org/language/details/eu-ES_details.xml','');
INSERT INTO #__updates VALUES(53,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.6.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(54,3,0,0,'Korean','','pkg_ko-KR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/ko-KR_details.xml','');
INSERT INTO #__updates VALUES(55,3,0,0,'Hindi','','pkg_hi-IN','package','',0,'2.5.6.1','','http://update.joomla.org/language/details/hi-IN_details.xml','');
INSERT INTO #__updates VALUES(56,3,0,0,'Welsh','','pkg_cy-GB','package','',0,'2.5.6.1','','http://update.joomla.org/language/details/cy-GB_details.xml','');
INSERT INTO #__updates VALUES(57,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(58,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(59,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(60,3,0,0,'Swahili','','pkg_sw-KE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sw-KE_details.xml','');
INSERT INTO #__updates VALUES(61,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(62,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(63,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(64,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(65,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(66,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(67,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(68,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(69,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(70,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(71,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(72,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(73,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(74,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(75,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(76,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(77,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(78,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(79,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(80,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(81,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(82,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(83,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(84,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(85,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(86,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(87,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(88,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(89,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(90,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(91,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(92,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(93,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(94,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(95,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(96,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(97,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(98,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(99,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(100,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(101,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(102,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(103,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(104,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(105,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(106,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(107,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(108,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(109,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(110,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(112,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(113,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(114,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(115,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(116,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(117,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(118,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(119,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(120,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(121,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(122,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(123,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(124,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(125,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(126,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(127,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(128,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(129,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(130,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(131,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(132,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(133,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(134,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(135,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(136,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(137,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(138,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(139,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(140,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(141,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(142,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.2','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(143,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(144,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(145,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(146,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(147,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(148,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(149,3,0,0,'Hungarian','','pkg_hu-HU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/hu-HU_details.xml','');
INSERT INTO #__updates VALUES(150,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(151,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(152,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(153,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(154,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(155,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(156,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(157,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(158,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(159,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(160,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(161,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.2','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(162,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(163,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(164,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(165,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(166,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(167,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(168,3,0,0,'Hungarian','','pkg_hu-HU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/hu-HU_details.xml','');
INSERT INTO #__updates VALUES(169,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(170,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(171,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(172,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(173,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(174,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(175,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(176,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(177,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(178,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(179,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(180,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.2','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(181,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(182,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(183,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(184,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(185,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(186,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(187,3,0,0,'Hungarian','','pkg_hu-HU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/hu-HU_details.xml','');
INSERT INTO #__updates VALUES(188,3,0,0,'French','','pkg_fr-FR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fr-FR_details.xml','');
INSERT INTO #__updates VALUES(189,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(190,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(191,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(192,3,0,0,'Turkish','','pkg_tr-TR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/tr-TR_details.xml','');
INSERT INTO #__updates VALUES(193,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(194,3,0,0,'Latvian','','pkg_lv-LV','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/lv-LV_details.xml','');
INSERT INTO #__updates VALUES(195,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(196,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(197,3,0,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ar-AA_details.xml','');
INSERT INTO #__updates VALUES(198,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(199,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(200,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(201,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(202,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(203,3,0,0,'Syriac','','pkg_sy-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sy-IQ_details.xml','');
INSERT INTO #__updates VALUES(204,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.2','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(205,3,0,0,'Finnish','','pkg_fi-FI','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fi-FI_details.xml','');
INSERT INTO #__updates VALUES(206,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(207,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(208,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(209,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(210,3,0,0,'Thai','','pkg_th-TH','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/th-TH_details.xml','');
INSERT INTO #__updates VALUES(211,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(212,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(213,3,0,0,'Swedish','','pkg_sv-SE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sv-SE_details.xml','');
INSERT INTO #__updates VALUES(214,3,0,0,'Hungarian','','pkg_hu-HU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/hu-HU_details.xml','');
INSERT INTO #__updates VALUES(215,3,0,0,'French','','pkg_fr-FR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fr-FR_details.xml','');
INSERT INTO #__updates VALUES(216,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(217,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(218,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(219,3,0,0,'Turkish','','pkg_tr-TR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/tr-TR_details.xml','');
INSERT INTO #__updates VALUES(220,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(221,3,0,0,'Latvian','','pkg_lv-LV','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/lv-LV_details.xml','');
INSERT INTO #__updates VALUES(222,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(223,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(224,3,0,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ar-AA_details.xml','');
INSERT INTO #__updates VALUES(225,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(226,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(227,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(228,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(229,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(230,3,0,0,'Syriac','','pkg_sy-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sy-IQ_details.xml','');
INSERT INTO #__updates VALUES(231,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.2','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(232,3,0,0,'Finnish','','pkg_fi-FI','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fi-FI_details.xml','');
INSERT INTO #__updates VALUES(233,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(234,3,0,0,'Kurdish Sorani','','pkg_ckb-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ckb-IQ_details.xml','');
INSERT INTO #__updates VALUES(235,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(236,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(237,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(238,3,0,0,'Thai','','pkg_th-TH','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/th-TH_details.xml','');
INSERT INTO #__updates VALUES(239,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(240,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(241,3,0,0,'Swedish','','pkg_sv-SE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sv-SE_details.xml','');
INSERT INTO #__updates VALUES(242,3,0,0,'Hungarian','','pkg_hu-HU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/hu-HU_details.xml','');
INSERT INTO #__updates VALUES(243,3,0,0,'French','','pkg_fr-FR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fr-FR_details.xml','');
INSERT INTO #__updates VALUES(244,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(245,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(246,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(247,3,0,0,'Turkish','','pkg_tr-TR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/tr-TR_details.xml','');
INSERT INTO #__updates VALUES(248,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(249,3,0,0,'Latvian','','pkg_lv-LV','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/lv-LV_details.xml','');
INSERT INTO #__updates VALUES(250,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(251,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(252,3,0,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ar-AA_details.xml','');
INSERT INTO #__updates VALUES(253,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(254,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(255,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(256,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(257,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(258,3,0,0,'Syriac','','pkg_sy-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sy-IQ_details.xml','');
INSERT INTO #__updates VALUES(259,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.2','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(260,3,0,0,'Finnish','','pkg_fi-FI','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fi-FI_details.xml','');
INSERT INTO #__updates VALUES(261,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(262,3,0,0,'Kurdish Sorani','','pkg_ckb-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ckb-IQ_details.xml','');
INSERT INTO #__updates VALUES(263,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(264,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(265,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(266,3,0,0,'Thai','','pkg_th-TH','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/th-TH_details.xml','');
INSERT INTO #__updates VALUES(267,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(268,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(269,3,0,0,'Swedish','','pkg_sv-SE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sv-SE_details.xml','');
INSERT INTO #__updates VALUES(270,3,0,0,'Hungarian','','pkg_hu-HU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/hu-HU_details.xml','');
INSERT INTO #__updates VALUES(271,3,0,0,'French','','pkg_fr-FR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fr-FR_details.xml','');
INSERT INTO #__updates VALUES(272,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(273,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(274,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(275,3,0,0,'Turkish','','pkg_tr-TR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/tr-TR_details.xml','');
INSERT INTO #__updates VALUES(276,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(277,3,0,0,'Latvian','','pkg_lv-LV','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/lv-LV_details.xml','');
INSERT INTO #__updates VALUES(278,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(279,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(280,3,0,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ar-AA_details.xml','');
INSERT INTO #__updates VALUES(281,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(282,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(283,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(284,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(285,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(286,3,0,0,'Syriac','','pkg_sy-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sy-IQ_details.xml','');
INSERT INTO #__updates VALUES(287,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.3','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(288,3,0,0,'Finnish','','pkg_fi-FI','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fi-FI_details.xml','');
INSERT INTO #__updates VALUES(289,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(290,3,0,0,'Vietnamese','','pkg_vi-VN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/vi-VN_details.xml','');
INSERT INTO #__updates VALUES(291,3,0,0,'Kurdish Sorani','','pkg_ckb-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ckb-IQ_details.xml','');
INSERT INTO #__updates VALUES(292,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(293,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(294,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(295,3,0,0,'Thai','','pkg_th-TH','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/th-TH_details.xml','');
INSERT INTO #__updates VALUES(296,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(297,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(298,3,0,0,'Swedish','','pkg_sv-SE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sv-SE_details.xml','');
INSERT INTO #__updates VALUES(299,3,0,0,'Hungarian','','pkg_hu-HU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/hu-HU_details.xml','');
INSERT INTO #__updates VALUES(300,3,0,0,'French','','pkg_fr-FR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fr-FR_details.xml','');
INSERT INTO #__updates VALUES(301,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(302,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(303,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(304,3,0,0,'Turkish','','pkg_tr-TR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/tr-TR_details.xml','');
INSERT INTO #__updates VALUES(305,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(306,3,0,0,'Latvian','','pkg_lv-LV','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/lv-LV_details.xml','');
INSERT INTO #__updates VALUES(307,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(308,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(309,3,0,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ar-AA_details.xml','');
INSERT INTO #__updates VALUES(310,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(311,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(312,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(313,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(314,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(315,3,0,0,'Syriac','','pkg_sy-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sy-IQ_details.xml','');
INSERT INTO #__updates VALUES(316,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.3','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(317,3,0,0,'Finnish','','pkg_fi-FI','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fi-FI_details.xml','');
INSERT INTO #__updates VALUES(318,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(319,3,0,0,'Vietnamese','','pkg_vi-VN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/vi-VN_details.xml','');
INSERT INTO #__updates VALUES(320,3,0,0,'Kurdish Sorani','','pkg_ckb-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ckb-IQ_details.xml','');
INSERT INTO #__updates VALUES(321,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(322,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(323,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(324,3,0,0,'Thai','','pkg_th-TH','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/th-TH_details.xml','');
INSERT INTO #__updates VALUES(325,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(326,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(327,3,0,0,'Swedish','','pkg_sv-SE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sv-SE_details.xml','');
INSERT INTO #__updates VALUES(328,3,0,0,'Hungarian','','pkg_hu-HU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/hu-HU_details.xml','');
INSERT INTO #__updates VALUES(329,3,0,0,'French','','pkg_fr-FR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fr-FR_details.xml','');
INSERT INTO #__updates VALUES(330,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(331,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(332,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(333,3,0,0,'Turkish','','pkg_tr-TR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/tr-TR_details.xml','');
INSERT INTO #__updates VALUES(334,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(335,3,0,0,'Latvian','','pkg_lv-LV','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/lv-LV_details.xml','');
INSERT INTO #__updates VALUES(336,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(337,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(338,3,0,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ar-AA_details.xml','');
INSERT INTO #__updates VALUES(339,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(340,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(341,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(342,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(343,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(344,3,0,0,'Syriac','','pkg_sy-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sy-IQ_details.xml','');
INSERT INTO #__updates VALUES(345,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.3','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(346,3,0,0,'Finnish','','pkg_fi-FI','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fi-FI_details.xml','');
INSERT INTO #__updates VALUES(347,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(348,3,0,0,'Vietnamese','','pkg_vi-VN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/vi-VN_details.xml','');
INSERT INTO #__updates VALUES(349,3,0,0,'Kurdish Sorani','','pkg_ckb-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ckb-IQ_details.xml','');
INSERT INTO #__updates VALUES(350,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(351,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(352,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(353,3,0,0,'Thai','','pkg_th-TH','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/th-TH_details.xml','');
INSERT INTO #__updates VALUES(354,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');
INSERT INTO #__updates VALUES(355,3,0,0,'Danish','','pkg_da-DK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/da-DK_details.xml','');
INSERT INTO #__updates VALUES(356,3,0,0,'Swedish','','pkg_sv-SE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sv-SE_details.xml','');
INSERT INTO #__updates VALUES(357,3,0,0,'Hungarian','','pkg_hu-HU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/hu-HU_details.xml','');
INSERT INTO #__updates VALUES(358,3,0,0,'French','','pkg_fr-FR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fr-FR_details.xml','');
INSERT INTO #__updates VALUES(359,3,0,0,'Italian','','pkg_it-IT','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/it-IT_details.xml','');
INSERT INTO #__updates VALUES(360,3,0,0,'Spanish','','pkg_es-ES','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/es-ES_details.xml','');
INSERT INTO #__updates VALUES(361,3,0,0,'Dutch','','pkg_nl-NL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-NL_details.xml','');
INSERT INTO #__updates VALUES(362,3,0,0,'Turkish','','pkg_tr-TR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/tr-TR_details.xml','');
INSERT INTO #__updates VALUES(363,3,0,0,'Slovak','','pkg_sk-SK','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sk-SK_details.xml','');
INSERT INTO #__updates VALUES(364,3,0,0,'Latvian','','pkg_lv-LV','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/lv-LV_details.xml','');
INSERT INTO #__updates VALUES(365,3,0,0,'Flemish','','pkg_nl-BE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nl-BE_details.xml','');
INSERT INTO #__updates VALUES(366,3,0,0,'Japanese','','pkg_ja-JP','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ja-JP_details.xml','');
INSERT INTO #__updates VALUES(367,3,0,0,'Arabic Unitag','','pkg_ar-AA','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ar-AA_details.xml','');
INSERT INTO #__updates VALUES(368,3,0,0,'German','','pkg_de-DE','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/de-DE_details.xml','');
INSERT INTO #__updates VALUES(369,3,0,0,'Norwegian Bokmal','','pkg_nb-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nb-NO_details.xml','');
INSERT INTO #__updates VALUES(370,3,0,0,'English AU','','pkg_en-AU','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-AU_details.xml','');
INSERT INTO #__updates VALUES(371,3,0,0,'English US','','pkg_en-US','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/en-US_details.xml','');
INSERT INTO #__updates VALUES(372,3,0,0,'Polish','','pkg_pl-PL','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pl-PL_details.xml','');
INSERT INTO #__updates VALUES(373,3,0,0,'Syriac','','pkg_sy-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/sy-IQ_details.xml','');
INSERT INTO #__updates VALUES(374,3,0,0,'Russian','','pkg_ru-RU','package','',0,'2.5.8.4','','http://update.joomla.org/language/details/ru-RU_details.xml','');
INSERT INTO #__updates VALUES(375,3,0,0,'Finnish','','pkg_fi-FI','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/fi-FI_details.xml','');
INSERT INTO #__updates VALUES(376,3,0,0,'Portuguese Brazil','','pkg_pt-BR','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/pt-BR_details.xml','');
INSERT INTO #__updates VALUES(377,3,0,0,'Vietnamese','','pkg_vi-VN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/vi-VN_details.xml','');
INSERT INTO #__updates VALUES(378,3,0,0,'Kurdish Sorani','','pkg_ckb-IQ','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ckb-IQ_details.xml','');
INSERT INTO #__updates VALUES(379,3,0,0,'Croatian','','pkg_hr-HR','package','',0,'2.5.7.2','','http://update.joomla.org/language/details/hr-HR_details.xml','');
INSERT INTO #__updates VALUES(380,3,0,0,'Norwegian Nynorsk','','pkg_nn-NO','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/nn-NO_details.xml','');
INSERT INTO #__updates VALUES(381,3,0,0,'Tamil India','','pkg_ta-IN','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/ta-IN_details.xml','');
INSERT INTO #__updates VALUES(382,3,0,0,'Thai','','pkg_th-TH','package','',0,'2.5.8.1','','http://update.joomla.org/language/details/th-TH_details.xml','');
INSERT INTO #__updates VALUES(383,3,0,0,'Uyghur','','pkg_ug-CN','package','',0,'2.5.7.1','','http://update.joomla.org/language/details/ug-CN_details.xml','');



DROP TABLE IF EXISTS #__user_notes;

CREATE TABLE `#__user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) DEFAULT CHARSET=utf8;




DROP TABLE IF EXISTS #__user_profiles;

CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) DEFAULT CHARSET=utf8 COMMENT='Simple user profile storage table';




DROP TABLE IF EXISTS #__viewlevels;

CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

INSERT INTO #__viewlevels VALUES(1,'Public',0,'[1]');
INSERT INTO #__viewlevels VALUES(2,'Registered',1,'[6,2,8]');
INSERT INTO #__viewlevels VALUES(3,'Special',2,'[6,3,8]');
INSERT INTO #__viewlevels VALUES(4,'Customer Access Level (Example)',3,'[6,3,12]');
INSERT INTO #__viewlevels VALUES(5,'Guest',0,'[13]');



DROP TABLE IF EXISTS #__weblinks;

CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;

INSERT INTO #__weblinks VALUES(1,32,0,'Joomla!','joomla','http://www.joomla.org','<p>Home of Joomla!</p>','0000-00-00 00:00:00',3,1,0,'0000-00-00 00:00:00',1,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__weblinks VALUES(2,33,0,'php.net','php','http://www.php.net','<p>The language that Joomla! is developed in</p>','0000-00-00 00:00:00',6,1,0,'0000-00-00 00:00:00',1,0,1,1,'{\"target\":\"\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__weblinks VALUES(3,33,0,'MySQL','mysql','http://www.mysql.com','<p>The most commonly used database for Joomla!.</p>','0000-00-00 00:00:00',1,1,0,'0000-00-00 00:00:00',2,0,1,1,'{\"target\":\"\",\"width\":\"\",\"height\":\"\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',614,'','2012-01-17 16:19:43',42,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__weblinks VALUES(4,32,0,'OpenSourceMatters','opensourcematters','http://www.opensourcematters.org','<p>Home of OSM</p>','0000-00-00 00:00:00',11,1,0,'0000-00-00 00:00:00',3,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__weblinks VALUES(5,32,0,'Joomla! - Forums','joomla-forums','http://forum.joomla.org','<p>Joomla! Forums</p>','0000-00-00 00:00:00',4,1,0,'0000-00-00 00:00:00',2,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__weblinks VALUES(6,33,0,'Ohloh Tracking of Joomla!','ohloh-tracking-of-joomla','http://www.ohloh.net/projects/20','<p>Objective reports from Ohloh about Joomla\'s development activity. Joomla! has some star developers with serious kudos.</p>','0000-00-00 00:00:00',1,1,0,'0000-00-00 00:00:00',3,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__weblinks VALUES(7,31,0,'Baw Baw National Park','baw-baw-national-park','http://www.parkweb.vic.gov.au/1park_display.cfm?park=44','<p>Park of the Austalian Alps National Parks system, Baw Baw  features sub alpine vegetation, beautiful views, and opportunities for hiking, skiing and other outdoor activities.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',1,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__weblinks VALUES(8,31,0,'Kakadu','kakadu','http://www.environment.gov.au/parks/kakadu/index.html','<p>Kakadu is known for both its cultural heritage and its natural features. It is one of a small number of places listed as World Heritage Places for both reasons. Extensive rock art is found there.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',2,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00');
INSERT INTO #__weblinks VALUES(9,31,0,'Pulu Keeling','pulu-keeling','http://www.environment.gov.au/parks/cocos/index.html','<p>Located on an atoll 2000 kilometers north of Perth, Pulu Keeling is Australia\'s smallest national park.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',3,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',614,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','2010-07-10 23:44:03','0000-00-00 00:00:00');



DROP TABLE IF EXISTS `#__usergroups`;
CREATE TABLE IF NOT EXISTS `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`) USING BTREE
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=14 ;

--
-- Dumping data for table `#__usergroups`
--

INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES
(1, 0, 1, 22, 'Public'),
(2, 1, 8, 19, 'Registered'),
(3, 2, 9, 16, 'Author'),
(4, 3, 10, 13, 'Editor'),
(5, 4, 11, 12, 'Publisher'),
(6, 1, 4, 7, 'Manager'),
(7, 6, 5, 6, 'Administrator'),
(8, 1, 20, 21, 'Super Users'),
(12, 2, 17, 18, 'Customer Group (Example)'),
(10, 3, 14, 15, 'Shop Suppliers (Example)'),
(13, 1, 2, 3, 'Guest');